ikiwiki (3.20170622) unstable; urgency=medium

  * t/git-cgi.t: Wait 1 second before doing a revert that should work.
    This hopefully fixes a race condition in which the test failed
    around 6% of the time. (Closes: 862494)
  * Guard against set-but-empty REMOTE_USER CGI variable on
    misconfigured nginx servers, and in general treat sessions with
    a set-but-empty name as if they were not signed in.
  * When the CGI fails, print the error to stderr, not "Died"
  * mdwn: Don't mangle <style> into <elyts> under some circumstances
  * mdwn: Enable footnotes by default when using the default Discount
    implementation. A new mdwn_footnotes option can be used to disable
    footnotes in MultiMarkdown and Discount.
  * mdwn: Don't enable alphabetically labelled ordered lists by
    default when using the default Discount implementation. A new
    mdwn_alpha_list option can be used to restore the old
    interpretation.
  * osm: Convert savestate hook into a changes hook. savestate is not
    the right place to write wiki content, and in particular this
    breaks websetup if osm's dependencies are not installed, even
    if the osm plugin is not actually enabled. (Closes: #719913)
  * toc: if the heading is of the form <h1 id="...">, use that for
    the link in the table of contents (but continue to generate
    <a name="index42"></a> in case someone was relying on it)
  * color: Do not leak markup into contexts that take only the plain
    text, such as toc
  * meta: Document [[!meta name="foo" content="bar"]]
  * debian: Use preferred https URL for Format of debian/copyright
  * debian: Declare compliance with Debian Policy 4.0.0

 -- Simon McVittie <smcv@debian.org>  Thu, 22 Jun 2017 09:24:57 +0100

ikiwiki (3.20170111) unstable; urgency=high

  * passwordauth: prevent authentication bypass via multiple name
    parameters (CVE-2017-0356, OVE-20170111-0001)
  * passwordauth: avoid userinfo forgery via repeated email parameter
    (also in the scope of CVE-2017-0356)
  * CGI, attachment, passwordauth: harden against repeated parameters
    (not believed to have been a vulnerability)
  * remove: make it clearer that repeated page parameter is OK here
  * t/passwordauth.t: new automated test for passwordauth

 -- Simon McVittie <smcv@debian.org>  Wed, 11 Jan 2017 18:16:53 +0000

ikiwiki (3.20170110) unstable; urgency=medium

  [ Amitai Schleier ]
  * wrappers: Correctly escape quotes in git_wrapper_background_command

  [ Simon McVittie ]
  * git: use an explicit function parameter for the directory to work
    in. Previously, we used global state that was not restored correctly
    on catching exceptions, causing an unintended log message
    "cannot chdir to .../ikiwiki-temp-working: No such file or directory"
    with versions >= 3.20161229 when an attempt to revert a change fails
    or is disallowed
  * git: don't run "git rev-list ... -- -- ..." which would select the
    wrong commits if a file named literally "--" is present in the
    repository
  * check_canchange: log "bad file name whatever", not literal string
    "bad file name %s"
  * t/git-cgi.t: fix a race condition that made the test fail
    intermittently
  * t/git-cgi.t: be more careful to provide a syntactically valid
    author/committer name and email, hopefully fixing this test on
    ci.debian.net
  * templates, comments, passwordauth: use rel=nofollow microformat
    for dynamic URLs
  * templates: use rel=nofollow microformat for comment authors
  * news: use Debian security tracker instead of MITRE for security
    references. Thanks, anarcat
  * Set package format to 3.0 (native)
  * d/copyright: re-order to put more specific stanzas later, to get the
    intended interpretation
  * d/source/lintian-overrides: override obsolete-url-in-packaging for
    OpenID Selector, which does not seem to have any more current URL
    (and in any case our version is a fork)
  * docwiki.setup: exclude TourBusStop from offline documentation.
    It does not make much sense there.
  * d/ikiwiki.lintian-overrides: override script-not-executable warnings
  * d/ikiwiki.lintian-overrides: silence false positive spelling warning
    for Moin Moin
  * d/ikiwiki.doc-base: register the documentation with doc-base
  * d/control: set libmagickcore-6.q16-3-extra as preferred
    build-dependency, with virtual package libmagickcore-extra as an
    alternative, to help autopkgtest to do the right thing

 -- Simon McVittie <smcv@debian.org>  Tue, 10 Jan 2017 13:22:01 +0000

ikiwiki (3.20161229.1) unstable; urgency=medium

  * git: Attribute reverts to the user doing the revert, not the wiki
    itself.
  * git: Do not disable the commit hook while preparing a revert.

 -- Simon McVittie <smcv@debian.org>  Thu, 29 Dec 2016 20:46:24 +0000

ikiwiki (3.20161229) unstable; urgency=medium

  * Security: force CGI::FormBuilder->field to scalar context where
    necessary, avoiding unintended function argument injection
    analogous to CVE-2014-1572. In ikiwiki this could be used to
    forge commit metadata, but thankfully nothing more serious.
    (CVE-2016-9646)
  * Security: try revert operations in a temporary working tree before
    approving them. Previously, automatic rename detection could result in
    a revert writing outside the wiki srcdir or altering a file that the
    reverting user should not be able to alter, an authorization bypass.
    (CVE-2016-10026 represents the original vulnerability.)
    The incomplete fix released in 3.20161219 was not effective for git
    versions prior to 2.8.0rc0.
    (CVE-2016-9645 represents that incomplete solution.)
  * Add CVE references for CVE-2016-10026
  * Add automated test for using the CGI with git, including
    CVE-2016-10026
    - Build-depend on libipc-run-perl for better build-time test coverage
  * Add missing ikiwiki.setup for the manual test for CVE-2016-10026
  * git: don't issue a warning if the rcsinfo CGI parameter is undefined
  * git: do not fail to commit changes with a recent git version
    and an anonymous committer

 -- Simon McVittie <smcv@debian.org>  Thu, 29 Dec 2016 17:36:15 +0000

ikiwiki (3.20161219) unstable; urgency=medium

  [ Joey Hess ]
  * inline: Prevent creating a file named ".mdwn" when the
    postform is submitted with an empty title.

  [ Simon McVittie ]
  * Security: tell `git revert` not to follow renames. If it does, then
    renaming a file can result in a revert writing outside the wiki srcdir
    or altering a file that the reverting user should not be able to alter,
    an authorization bypass. Thanks, intrigeri. (CVE-2016-10026)
  * cgitemplate: remove some dead code. Thanks, blipvert
  * Restrict CSS matches against header class to not break
    Pandoc tables with header rows. Thanks, karsk
  * Make pagestats output more deterministic. Thanks, intrigeri

 -- Simon McVittie <smcv@debian.org>  Mon, 19 Dec 2016 20:34:23 +0000

ikiwiki (3.20160905) unstable; urgency=medium

  [ Joey Hess ]
  * Fix installation when prefix includes a string metacharacter.
    Thanks, Sam Hathaway.

  [ Simon McVittie ]
  * Use git log --no-renames to generate recentchanges, fixing the git
    test-case with git 2.9 (Closes: #835612)

 -- Simon McVittie <smcv@debian.org>  Mon, 05 Sep 2016 21:26:19 +0100

ikiwiki (3.20160728) unstable; urgency=medium

  * Explicitly remove current working directory from Perl's library
    search path, mitigating CVE-2016-1238 (see #588017)
  * wrappers: allocate new environment dynamically, so we won't overrun
    the array if third-party plugins add multiple environment variables.
  * Standards-Version: 3.9.8 (no changes required)

 -- Simon McVittie <smcv@debian.org>  Thu, 28 Jul 2016 10:41:56 +0100

ikiwiki (3.20160509) unstable; urgency=high

  [ Amitai Schlair ]
  * img: ignore the case of the extension when detecting image format,
    fixing the regression that *.JPG etc. would not be displayed
    since 3.20160506

  [ Simon McVittie ]
  * img: parse img_allowed_formats case-insensitively, as was done in
    3.20141016.3
  * inline: restore backwards compat for show=-1 syntax, which
    worked before 3.20160121
  * Remove a spurious changelog entry from 3.20160506 (the relevant
    change was already in 3.20150614)
  * Add CVE-2016-4561 reference to 3.20160506 changelog
  * Set high urgency to get the CVE-2016-4561 fix and CVE-2016-3714
    mitigation into testing

 -- Simon McVittie <smcv@debian.org>  Mon, 09 May 2016 21:57:09 +0100

ikiwiki (3.20160506) unstable; urgency=medium

  [ Simon McVittie ]
  * HTML-escape error messages, in one case avoiding potential cross-site
    scripting (CVE-2016-4561, OVE-20160505-0012)
  * Mitigate ImageMagick vulnerabilities such as CVE-2016-3714:
    - img: force common Web formats to be interpreted according to extension,
      so that "allowed_attachments: '*.jpg'" does what one might expect
    - img: restrict to JPEG, PNG and GIF images by default, again mitigating
      CVE-2016-3714 and similar vulnerabilities
    - img: check that the magic number matches what we would expect from
      the extension before giving common formats to ImageMagick
  * d/control: use https for Homepage
  * d/control: add Vcs-Browser

  [ Joey Hess ]
  * img: Add back support for SVG images, bypassing ImageMagick and
    simply passing the SVG through to the browser, which is supported by all
    commonly used browsers these days.
    SVG scaling by img directives has subtly changed; where before
    size=wxh would preserve aspect ratio, this cannot be done when passing
    them through and so specifying both a width and height can change
    the SVG's aspect ratio.
  * loginselector: When only openid and emailauth are enabled, but
    passwordauth is not, avoid showing a "Other" box which opens an
    empty form.

  [ Amitai Schlair ]
  * mdwn: Process .md like .mdwn, but disallow web creation.

  [ Florian Wagner ]
  * git: Correctly handle filenames starting with a dash in add/rm/mv.

 -- Simon McVittie <smcv@debian.org>  Fri, 06 May 2016 07:54:26 +0100

ikiwiki (3.20160121) unstable; urgency=medium

  [ Amitai Schlair ]
  * meta: Fix [[!meta name=foo]] by closing the open quote.
  * Avoid unescaped "{" in regular expressions
  * meta test: Add tests for many behaviors of the directive.
  * img test: Bail gracefully when ImageMagick is not present.

  [ Joey Hess ]
  * emailauth: Added emailauth_sender config.
  * Modified page.tmpl to to set html lang= and dir= when
    values have been specified for them, which the po plugin does.
  * Specifically license the javascript underlay under the permissive
    basewiki license.

  [ Simon McVittie ]
  * git: if no committer identity is known, set it to
    "IkiWiki <ikiwiki.info>" in .git/config. This resolves commit errors
    in versions of git that require a non-trivial committer identity.
  * inline, trail: rename show, feedshow parameters to limit, feedlimit
    (with backwards compatibility)
  * pagestats: add "show" option to show meta fields. Thanks, Louis
  * inline: force RSS <comments> to be a fully absolute URL as required
    by the W3C validator. Please use Atom feeds if relative URLs are
    desirable on your site.
  * inline: add <atom:link rel="self"> to RSS feeds as recommended by
    the W3C validator
  * inline: do not produce links containing /./ or /../
  * syslog: accept and encode UTF-8 messages
  * syslog: don't fail to log if the wiki name contains %s
  * Change dependencies from transitional package perlmagick
    to libimage-magick-perl (Closes: #789221)
  * debian/copyright: update for the rename of openid-selector to
    login-selector
  * d/control: remove leading article from Description
    (lintian: description-synopsis-starts-with-article)
  * d/control: Standards-Version: 3.9.6, no changes required
  * Wrap and sort control files (wrap-and-sort -abst)
  * Silence "used only once: possible typo" warnings for variables
    that are part of modules' APIs
  * Run autopkgtest tests using autodep8 and the pkg-perl team's
    infrastructure
  * Add enough build-dependencies to run all tests, except for
    non-git VCSs
  * tests: consistently use done_testing instead of no_plan
  * t/img.t: do not spuriously skip
  * img test: skip testing PDFs if unsupported
  * img test: use the right filenames when testing that deletion occurs

 -- Simon McVittie <smcv@debian.org>  Thu, 21 Jan 2016 09:53:07 +0000

ikiwiki (3.20150614) unstable; urgency=medium

  * inline: change default sort order from age to "age title" for
    determinism, partially fixing deterministic build for git-annex,
    ikiwiki-hosting etc. (Closes: #785757)
  * img: avoid ImageMagick misinterpreting filenames containing a colon
  * img test: set old timestamp on source file that will change, so that
    the test will pass even if it takes less than 1 second

 -- Simon McVittie <smcv@debian.org>  Sun, 14 Jun 2015 18:13:23 +0100

ikiwiki (3.20150610) unstable; urgency=low

  [ Joey Hess ]
  * New emailauth plugin lets users log in, without any registration,
    by simply clicking on a link in an email.
  * Re-remove google from openid selector; their openid provider is
    gone for good.
  * Make the openid selector display "Password" instead of "Other"
    when appropriate, so users are more likely to click on it when
    they don't have an openid.
  * Converted openid-selector into a more generic loginselector helper
    plugin.
  * passwordauth: Don't allow registering accounts that look like openids.
  * Make cgiurl output deterministic, not hash order. Closes: #785738
    Thanks, Daniel Kahn Gillmor

  [ Simon McVittie ]
  * Do not enable emailauth by default, to avoid surprises on httpauth-only
    sites. Enable it by default in openid instead, since it is essentially
    a replacement for OpenIDs.
  * Make the attachment plugin work with CGI.pm 4.x (Closes: #786586;
    workaround for #786587 in libcgi-pm-perl)
  * Add a public-domain email icon from tango-icon-theme
  * Populate pagectime from either mtime or inode change time,
    whichever is older, again for more reproducible builds
  * debian: build the docwiki with LC_ALL=C.UTF-8 and TZ=UTC
  * debian/copyright: consolidate permissive licenses
  * debian/copyright: turn comments on provenance into Comment
  * brokenlinks: sort the pages that link to the missing page, for
    better reproducibility
  * Add [[!meta date]] to news items and tips, since the git checkout
    and build process can leave the checkout date in the tarball
    release, leading to unstable sorting
  * Sort backlinks deterministically, by falling back to sorting by href
    if the link text is identical
  * Add a $config{deterministic} option and use it for the docwiki
  * haiku: if deterministic build is requested, return a hard-coded haiku
  * polygen: if deterministic build is requested, use a well-known random seed

 -- Simon McVittie <smcv@debian.org>  Wed, 10 Jun 2015 21:56:36 +0100

ikiwiki (3.20150329) experimental; urgency=high

  [ Joey Hess ]
  * Fix NULL ptr deref on ENOMEM in wrapper. (Thanks, igli)

  [ Simon McVittie ]
  * Really don't double-decode CGI submissions, even on Perl versions that
    bundle an old enough Encode.pm for that not to be a problem: the
    system might have a newer Encode.pm installed separately, like Fedora 20.
    (Closes: #776181; thanks, Anders Kaseorg)
  * If neither timezone nor TZ is set, set both to :/etc/localtime if
    we're on a GNU system and that file exists, or GMT otherwise
  * t/inline.t: accept translations of "Add a new post titled:"
    (Closes: #779365)
  * Consistently document command-line options as e.g. --refresh, not -refresh

  [ Amitai Schlair ]
  * In VCS-committed anonymous comments, link to url.

  [ Joey Hess ]
  * Fix XSS in openid selector. Thanks, Raghav Bisht. (Closes: #781483)

 -- Simon McVittie <smcv@debian.org>  Sun, 29 Mar 2015 21:48:24 +0100

ikiwiki (3.20150107) experimental; urgency=medium

  [ Joey Hess ]
  * Added ikiwiki-comment program.
  * Add missing build-depends on libcgi-formbuilder-perl, needed for
    t/relativity.t
  * openid: Stop suppressing the email field on the Preferences page.
  * Set Debian package maintainer to Simon McVittie as I'm retiring from
    Debian.

  [ Simon McVittie ]
  * calendar: add calendar_autocreate option, with which "ikiwiki --refresh"
    can mostly supersede the ikiwiki-calendar command.
    Thanks, Louis Paternault
  * search: add more classes as a hook for CSS. Thanks, sajolida
  * core: generate HTML5 by default, but keep avoiding new elements
    like <section> that require specific browser support unless html5 is
    set to 1.
  * Tell mobile browsers to draw our pages in a device-sized viewport,
    not an 800-1000px viewport designed to emulate a desktop/laptop browser.
  * Add new responsive_layout option which can be set to 0 if your custom
    CSS only works in a large viewport.
  * style.css, actiontabs, blueview, goldtype, monochrome: adjust layout
    below 600px ("responsive layout") so that horizontal scrolling is not
    needed on smartphone browsers or other small viewports.
  * core: new libdirs option alongside libdir. Thanks, Louis Paternault

  [ Amitai Schlair ]
  * core: log a debug message before waiting for the lock.
    Thanks, Mark Jason Dominus
  * build: in po/Makefile, use the same $(MAKE) as the rest of the build.
    Thanks, ttw
  * blogspam: use the 2.0 JSON API (the 1.0 XML-RPC API has been EOL'd).
    Closes: #774441

  [ Joey Hess ]
  * po: If msgmerge falls over on a problem po file, print a warning
    message, but don't let this problem crash ikiwiki entirely.

 -- Simon McVittie <smcv@debian.org>  Wed, 07 Jan 2015 09:13:58 +0000

ikiwiki (3.20141016) unstable; urgency=medium

  [ Joey Hess ]
  * Fix crash that can occur when only_committed_changes is set and a
    file is deleted from the underlay.

  [ Simon McVittie ]
  * core: avoid dangerous use of CGI->param in list context, which led
    to a security flaw in Bugzilla; as far as we can tell, ikiwiki
    is not vulnerable to a similar attack, but it's best to be safe
  * core: new reverse_proxy option prevents ikiwiki from trying to detect
    how to make self-referential URLs by using the CGI environment variables,
    for instance when it's deployed behind a HTTP reverse proxy
    (Closes: #745759)
  * core: the default User-Agent is now "ikiwiki/$version" to work around
    ModSecurity rules assuming that only malware uses libwww-perl
  * core: use protocol-relative URLs (e.g. //www.example.com/wiki) so that
    https stays on https and http stays on http, particularly if the
    html5 option is enabled
  * core: avoid mixed content when a https cgiurl links to http static pages
    on the same server (the static pages are assumed to be accessible via
    https too)
  * core: force the correct top URL in w3mmode
  * google plugin: Use search form
  * docwiki: replace Paypal and Flattr buttons with text links
  * comments: don't record the IP address in the wiki if the user is
    logged in via passwordauth or httpauth
  * templates: add ARIA roles to some page elements, if html5 is enabled.
    Thanks, Patrick
  * debian: build-depend on libmagickcore-6.q16-2-extra | libmagickcore-extra
    so we can thumbnail SVGs in the docwiki
  * debian: explicitly depend and build-depend on libcgi-pm-perl
  * debian: drop unused python-support dependency
  * debian: rename debian/link to debian/links so the intended symlinks appear
  * debian: fix some wrong paths in the copyright file

 -- Simon McVittie <smcv@debian.org>  Thu, 16 Oct 2014 23:28:26 +0100

ikiwiki (3.20140916) unstable; urgency=low

  * Don't double-decode CGI submissions with Encode.pm >= 2.53,
    fixing "Error: Cannot decode string with wide characters".
    Thanks, Antoine Beaupré
  * Avoid making trails depend on everything in the wiki by giving them
    a better way to sort the pages
  * Don't let users post comments that won't be displayed
  * Fix encoding of Unicode strings in Python plugins.
    Thanks, chrysn
  * Improve performance and correctness of the [[!if]] directive
  * Let [[!inline rootpage=foo postform=no]] disable the posting form
  * Switch default [[!man]] shortcut to manpages.debian.org. Closes: #700322
  * Add UUID and TIME variables to edittemplate. Closes: #752827
    Thanks, Jonathon Anderson
  * Display pages in linkmaps as their pagetitle (no underscore escapes).
    Thanks, chrysn
  * Fix aspect ratio when scaling small images, and add support for
    converting SVG and PDF graphics to PNG.
    Thanks, chrysn
    - suggest ghostscript (required for PDF-to-PNG thumbnailing)
      and libmagickcore-extra (required for SVG-to-PNG thumbnailing)
    - build-depend on ghostscript so the test for scalable images can be run
  * In the CGI wrapper, incorporate $config{ENV} into the environment
    before executing Perl code, so that PERL5LIB can point to a
    non-system-wide installation of IkiWiki.
    Thanks, Lafayette Chamber Singers Webmaster
  * filecheck: accept MIME types not containing ';'
  * autoindex: index files in underlays if the resulting pages aren't
    going to be committed. Closes: #611068
  * Add [[!templatebody]] directive so template pages don't have to be
    simultaneously a valid template and valid HTML
  * Add myself to Uploaders and release to Debian

 -- Simon McVittie <smcv@debian.org>  Fri, 12 Sep 2014 21:23:58 +0100

ikiwiki (3.20140831) unstable; urgency=medium

  * Make --no-gettime work in initial build. Closes: #755075

 -- Joey Hess <joeyh@debian.org>  Sun, 31 Aug 2014 14:17:24 -0700

ikiwiki (3.20140815) unstable; urgency=medium

  * Add google back to openid selector. Apparently this has gotten a stay
    of execution until April 2015. (It may continue to work until 2017.)
  * highlight: Add compatibility with highlight 3.18, while still supporting
    3.9+. Closes: #757679
    Thanks, David Bremner
  * highlight: Add support for multiple language definition directories
    Closes: #757680
    Thanks, David Bremner

 -- Joey Hess <joeyh@debian.org>  Fri, 15 Aug 2014 12:58:08 -0400

ikiwiki (3.20140613) unstable; urgency=medium

  * only_committed_changes could fail in a git repository merged
    with git merge -s ours.
  * Remove google from openid selector, per http://xkcd.com/1361/

 -- Joey Hess <joeyh@debian.org>  Fri, 13 Jun 2014 10:09:10 -0400

ikiwiki (3.20140227) unstable; urgency=medium

  * Added useragent config setting. Closes: #737121
    Thanks, Tuomas Jormola
  * po: Add html_lang_code and html_lang_dir template variables
    for the language code and direction of text.
    Thanks, Mesar Hameed
  * Allow up to 8 levels of nested directives, rather than previous 3
    in directive infinite loop guard.
  * git diffurl: Do not escape / in paths to changed files, in order to
    interoperate with cgit (gitweb works either way)
    Thanks, intrigeri.
  * git: Explicity push master branch, as will be needed by git 2.0's
    change to push.default=matching by default.
    Thanks, smcv
  * Deal with nasty issue with gettext clobbering $@ while printing
    error message containing it.
    Thanks, smcv
  * Cleanup of the openid login widget, including replacing of hotlinked
    images from openid providers with embedded, freely licensed artwork.
    Thanks, smcv
  * Improve templates testing.
    Thanks, smcv
  * python proxy: Avoid utf-8 related crash.
    Thanks, Antoine Beaupré
  * Special thanks to Simon McVittie for being the patchmeister for this
    release.

 -- Joey Hess <joeyh@debian.org>  Thu, 27 Feb 2014 11:55:35 -0400

ikiwiki (3.20140125) unstable; urgency=medium

  * inline: Allow overriding the title of the feed. Closes: #735123
    Thanks, Christophe Rhodes
  * osm: Escape name parameter. Closes: #731797

 -- Joey Hess <joeyh@debian.org>  Sat, 25 Jan 2014 16:40:32 -0400

ikiwiki (3.20140102) unstable; urgency=low

  * aggregate: Improve display of post author.
  * poll: Fix behavior of poll buttons when inlined.
  * Fixed unncessary tight loop hash copy in saveindex where a pointer
    can be used instead. Can speed up refreshes by nearly 50% in some
    circumstances.
  * Optimized loadindex by caching the page name in the index.
  * Added only_committed_changes config setting, which speeds up wiki
    refresh by querying git to find the files that were changed, rather
    than looking at the work tree. Not enabled by default as it can
    break some setups where not all files get committed to git.
  * comments: Write pending moderation comments to the transient underlay
    to avoid conflict with only_committed_changes.
  * search: Added google_search option, which makes it search google
    rather than using the internal xapain database.
    (googlesearch plugin is too hard to turn on when xapain databases
    corrupt themselves, which happens all too frequently).
  * osm: Remove invalid use of charset on embedded javascript tags.
    Closes: #731197
  * style.css: Add compatibility definitions for more block-level
    html5 elements. Closes: #731199
  * aggregrate: Fix several bugs in handling of empty and colliding
    titles when generating filenames.

 -- Joey Hess <joeyh@debian.org>  Thu, 02 Jan 2014 12:22:22 -0400

ikiwiki (3.20130904.1) unstable; urgency=low

  * Fix cookiejar default setting.

 -- Joey Hess <joeyh@debian.org>  Wed, 04 Sep 2013 10:15:37 -0400

ikiwiki (3.20130904) unstable; urgency=low

  * calendar: Display the popup mouseover when there is only 1 page for a
    given day, for better UI consistency.
  * meta: Can now be used to add an enclosure to a page, which is a fancier
    way to do podcasting than just inlining the media files directly;
    this way you can write a post about the podcast episode with show notes,
    author information, etc.
    (schmonz)
  * aggregate: Show author in addition to feedname, if different.
    (schmonz)
  * Consistently configure LWP::UserAgent to allow use of http_proxy
    and no_proxy environment variables, as well as ~/.ikiwiki/cookies
    (schmonz)
  * Fix test suite to work with perl 5.18. Closes: #719969

 -- Joey Hess <joeyh@debian.org>  Wed, 04 Sep 2013 08:54:31 -0400

ikiwiki (3.20130711) unstable; urgency=low

  * Deal with git behavior change in 1.7.2 and newer that broke support
    for commits with an empty commit message.
  * Pass --no-edit when used with git 1.7.8 and newer.

 -- Joey Hess <joeyh@debian.org>  Wed, 10 Jul 2013 21:49:23 -0400

ikiwiki (3.20130710) unstable; urgency=low

  * blogspam: Fix encoding issue in RPC::XML call.
    Thanks, Changaco
  * comments: The formats allowed to be used in comments can be configured
    using comments_allowformats.
    Thanks, Michal Sojka
  * calendar: When there are multiple pages for a given day, they're
    displayed in a popup on mouseover.
    Thanks, Louis
  * osm: Remove trailing slash from KML maps icon.
  * page.tmpl: omit searchform, trails, sidebar and most metadata in CGI
    (smcv)
  * openid: Automatically upgrade openid_realm to https when
    accessed via https.
  * The ip() pagespec can now contain glob characters to match eg, a subnet
    full of spammers.
  * Fix crash that could occur when a needsbuild hook returned a file
    that does not exist.
  * Fix python proxy to not crash when fed unicode data in getstate
    and setstate.
    Thanks, chrysn
  * Fix committing attachments when using svn.

 -- Joey Hess <joeyh@debian.org>  Wed, 10 Jul 2013 17:45:40 -0400

ikiwiki (3.20130518) unstable; urgency=low

  * Fix test suite to not fail when XML::Twig is not installed.
    Closes: #707436
  * theme: Now <TMPL_IF THEME_$NAME> can be used in all templates when
    a theme is enabled.
  * notifyemail: Fix bug that caused duplicate emails to be sent when
    site was rebuilt.
  * bzr: bzr rm no longer has a --force option, remove

 -- Joey Hess <joeyh@debian.org>  Sat, 18 May 2013 16:28:21 -0400

ikiwiki (3.20130504) unstable; urgency=low

  * Allow dots in directive parameter names. (tango)
  * Add missing plugin section, and deal with missing sections with a warning.
  * Detect plugins with a broken getsetup and warn.
  * map: Correct reversion introduced in version 3.20110225 that could
    generate invalid html. (smcv)
  * Makefile.PL: overwrite theme style.css instead of appending
    (Thanks, Mikko Rapeli)
  * meta: Fix anchors used to link to the page's license and copyright.
    Closes: #706437

 -- Joey Hess <joeyh@debian.org>  Sat, 04 May 2013 23:47:21 -0400

ikiwiki (3.20130212) unstable; urgency=low

  * htmlscrubber: Allow the bitcoin URI scheme.
  * htmlscrubber: Allow the URI schemes of major VCS's.
  * aggregate: When run with --aggregate, if an aggregation is already
    running, don't go on and --refresh.
  * trail: Avoid excess dependencies between pages in the trail
    and the page defining the trail. Thanks, smcv.
  * opendiscussion: Don't allow editing discussion pages if discussion pages
    are disabled. (smcv)
  * poll: Add expandable option to allow users to easily add new choices to
    a poll.
  * trail: Avoid massive slowdown caused by pagetemplate hook when displaying
    dynamic cgi pages, which cannot use trail anyway.
  * Deal with empty diffurl in configuration.
  * cvs: Various fixes. (schmonz)
  * highlight: Now adds a span with class highlight-<extension> around
    highlighted content, allowing for language-specific css styling.

 -- Joey Hess <joeyh@debian.org>  Tue, 12 Feb 2013 21:48:02 -0400

ikiwiki (3.20121212) unstable; urgency=low

  * filecheck: Fix bug that prevented File::MimeInfo::Magic from ever
    being used.
  * openid: Display openid in Preferences page as a comment, so it can be
    selected in all browsers.

 -- Joey Hess <joeyh@debian.org>  Tue, 11 Dec 2012 12:12:12 -0400

ikiwiki (3.20121017) unstable; urgency=low

  * recentchangesdiff: fix further breakage to the template from 3.20120725 

 -- Joey Hess <joeyh@debian.org>  Tue, 16 Oct 2012 20:49:27 -0400

ikiwiki (3.20121016) unstable; urgency=low

  * monochrome: New theme, contributed by Jon Dowland.
  * rst: Ported to python 3, while still also being valid python 2.
    Thanks, W. Trevor King
  * Try to avoid a situation in which so many ikiwiki cgi wrapper programs
    are running, all waiting on some long-running thing like a site rebuild,
    that it prevents the web server from doing anything else. The current
    approach only avoids this problem for GET requests; if multiple cgi's
    run GETs on a site at the same time, one will display a "please wait"
    page for a configurable number of seconds, which then redirects to retry.
    To enable this protection, set cgi_overload_delay to the number of
    seconds to wait. This is not enabled by default.
  * Add back a 1em margin between archivepage divs.
  * recentchangesdiff: Correct broken template that resulted in duplicate
    diff icons being displayed, and bloated the recentchanges page with
    inline diffs when the configuration should have not allowed them.

 -- Joey Hess <joeyh@debian.org>  Tue, 16 Oct 2012 15:14:19 -0400

ikiwiki (3.20120725) unstable; urgency=low

  * recentchangesdiff: When diffurl is not set, provide inline diffs
    in the recentchanges page, with visibility toggleable via javascript.
    Thanks, Antoine Beaupré
  * Split CFLAGS into words when building wrapper. Closes: #682237
  * osm: Avoid calling urlto before generated files are registered.
    Thanks, Philippe Gauthier and Antoine Beaupré
  * osm: Add osm_openlayers_url configuration setting.
    Thanks, Genevieve
  * osm: osm_layers can be used to configured the layers displayed on the map.
    Thanks, Antoine Beaupré
  * comments: Remove ipv6 address specific code.

 -- Joey Hess <joeyh@debian.org>  Sat, 25 Aug 2012 10:58:42 -0400

ikiwiki (3.20120629) unstable; urgency=low

  * mirrorlist: Add mirrorlist_use_cgi setting that avoids usedirs or
    other config differences by linking to the mirror's CGI. (intrigeri)

 -- Joey Hess <joeyh@debian.org>  Fri, 29 Jun 2012 10:16:08 -0400

ikiwiki (3.20120516) unstable; urgency=high

  * meta: Security fix; add missing sanitization of author and authorurl.
    CVE-2012-0220 Thanks, Raúl Benencia

 -- Joey Hess <joeyh@debian.org>  Wed, 16 May 2012 19:51:27 -0400

ikiwiki (3.20120419) unstable; urgency=low

  * Remove dead link from plugins/teximg. Closes: #664885
  * inline: When the pagenames list includes pages that do not exist, skip
    them.
  * meta: Export author information in html <meta> tag. Closes: #664779
    Thanks, Martin Michlmayr
  * notifyemail: New plugin, sends email notifications about new and 
    changed pages, and allows subscribing to comments.
  * Added a "changes" hook. Renamed the "change" hook to "rendered", but
    the old hook name is called for now for back-compat.
  * meta: Support keywords header. Closes: #664780
    Thanks, Martin Michlmayr
  * passwordauth: Fix url in password recovery email to be absolute.
  * httpauth: When it's the only auth method, avoid a pointless and
    confusing signin form, and go right to the httpauthurl.
  * rename: Allow rename to be started not from the edit page; return to
    the renamed page in this case.
  * remove: Support removing of pages in the transient underlay. (smcv)
  * inline, trail: The pagenames parameter is now a list of absolute
    pagenames, not relative wikilink type names. This is necessary to fix
    a bug, and makes pagenames more consistent with the pagespec used
    in the pages parameter. (smcv)
  * link: Fix renaming wikilinks that contain embedded urls.
  * graphviz: Handle self-links.
  * trail: Improve CSS, also display trail links at bottom of page,
    and a bug fix. (smcv)

 -- Joey Hess <joeyh@debian.org>  Thu, 19 Apr 2012 15:32:07 -0400

ikiwiki (3.20120319) unstable; urgency=low

  * osm: New plugin to embed an OpenStreetMap into a wiki page.
    Supports waypoints, tags, and can even draw paths matching
    wikilinks between pages containing waypoints.
    Thanks to Blars Blarson and Antoine Beaupré, as well as the worldwide
    OpenStreetMap community for this utter awesomeness.
  * trail: New plugin to add navigation trails through pages via Next and
    Previous links. Trails can easily be added to existing inlines by setting
    trail=yes in the inline.
    Thanks to Simon McVittie for his persistance developing this feature.
  * Fix a snail mail address. Closes: #659158
  * openid-jquery.js: Update URL of Wordpress favicon. Closes: #660549
  * Drop the version attribute on the generator tag in Atom feeds
    to make builds more reproducible. Closes: #661569 (Paul Wise)
  * shortcut: Support Wikipedia's form of url-encoding for unicode
    characters, which involves mojibake. Closes: #661198
  * Add a few missing jquery UI icons to attachment upload widget underlay.
  * URI escape filename when generating the diffurl.
  * Add build-affected hook. Used by trail.

 -- Joey Hess <joeyh@debian.org>  Mon, 19 Mar 2012 14:24:43 -0400

ikiwiki (3.20120202) unstable; urgency=low

  * mdwn: Added nodiscount setting, which can be used to avoid using the
    markdown discount engine, when maximum compatability is needed.
  * Switch to YAML::XS to work around insanity in YAML::Mo. Closes: #657533
  * cvs: Ensure text files are added in non-binary mode. (Amitai Schlair)
  * cvs: Various cleanups and testing. (Amitai Schlair)
  * calendar: Fix strftime encoding bug.
  * shortcuts: Fixed a broken shortcut to wikipedia (accidentially
    made into a shortcut to wikiMedia).
  * Various portability improvements. (Amitai Schlair)

 -- Joey Hess <joeyh@debian.org>  Thu, 02 Feb 2012 21:42:40 -0400

ikiwiki (3.20120115) unstable; urgency=low

  * Make backlink(.) work. Thanks, Giuseppe Bilotta.
  * mdwn: Workaround discount's eliding of <style> blocks.
  * attachment: Fix utf-8 display bug.

 -- Joey Hess <joeyh@debian.org>  Sun, 15 Jan 2012 16:19:25 -0400

ikiwiki (3.20120109) unstable; urgency=low

  * mdwn: Can use the discount markdown library, via the
    Text::Markdown::Discount perl module. This is preferred if available
    since it's the fastest currently supported markdown library, speeding up
    ikiwiki's markdown rendering by a factor of 40.
    (However, when multimarkdown is enabled, Text::Markdown::Multimarkdown
    is still used.)
  * On Debian, depend on libtext-markdown-discount.

 -- Joey Hess <joeyh@debian.org>  Mon, 09 Jan 2012 11:49:14 -0400

ikiwiki (3.20111229) unstable; urgency=low

  * Consume all stdin when rcs_receive short-circuits,
    to avoid git SIGPIPE race.
  * Add path and path_natural sort orders (smcv)
  * Test coverage can be checked with `make coverage` (smcv)
  * tag: encode categories using numeric values. (tango)

 -- Joey Hess <joeyh@debian.org>  Thu, 29 Dec 2011 12:00:53 -0400

ikiwiki (3.20111107) unstable; urgency=low

  * img: Bugfix to width/height tags for scaled down image when only
    one dimension was provided. Thanks, Per Carlson.
  * editpage: Fix FormattingHelp link on Discussion pages.
  * The umask setting can now be set to private, group, or public,
    avoiding the need to enter octal correctly which is particularly
    difficult in yaml setup files. (smcv)
  * graphviz: Support urls embedded in the graph, by having graphviz
    generate an imagemap.
  * graphviz: Support wikilinks embedded in the graph.
    (Sponsored by The TOVA Company.)

 -- Joey Hess <joeyh@debian.org>  Wed, 30 Nov 2011 16:31:48 -0400

ikiwiki (3.20111106) unstable; urgency=low

  * searchquery.tmpl: Track escaping change in upstream template.
    Thanks Olly Betts for review.
  * svn: Support subversion 1.7, which does not have .svn in each
    subdirectory.
  * rst: import docutils lazily, to avoid errors during ikiwiki --setup.
    Closes: #637604 (Thanks, smcv)
  * Make the setup automator create YAML formatted files.
  * Fix handling of discussion page creation links to make discussion pages
    in the right place and with the right case. Broken by page case
    preservation feature added in 3.20110707.

 -- Joey Hess <joeyh@debian.org>  Sun, 06 Nov 2011 16:27:29 -0400

ikiwiki (3.20110905) unstable; urgency=low

  * mercurial: Openid nicknames are now used when committing. (Daniel Andersson)
  * mercurial: Implement rcs_commit_staged so comments, attachments, etc
    can be used. (Daniel Andersson)
  * mercurial: Implement rcs_rename, rcs_remove. (Daniel Andersson)
  * mercurial: Fix viewing of a diff containing non-utf8 changes.
    (Daniel Andersson)
  * mercurial: Make both rcs_getctime and rcs_getmtime fast. (Daniel Andersson)
  * mercurial: Implement rcs_diff. (Daniel Andersson)
  * po: Add `LANG_CODE` and `LANG_NAME` template variables. (intrigeri)
  * Fix typo in Danish translation of shortcuts page that caused exponential
    regexp blowup.
  * Fix escaping of html entities in permalinks.
  * Fix escaping of html entities in tag names.
  * Avoid using named capture groups in heredoc code for oldperl compatibility.
  * Put in a workaround for #622591, by ensuring Search::Xapian gets loaded
    before Image::Magick.
  * Add unminified jquery js and css files to source.
  * Update to jquery 1.6.2, and jquery-ui 1.8.14.
  * Use lockf rather than flock when taking the cgilock, for better
    portability.
  * search: Fix encoding bug in calculation of maximum term size.
  * inline: When indexing internal pages for searching, use the url of
    the inlining page.
  * Fix comments testsuite to not rely on Date::Parse's ability to
    parse the date Columbus discovered America. Closes: #640350
  * Avoid warning message when generating setup file if highlight
    is not installed. Closes: #637606
  * Promote RPC::XML to a Recommends, since it's used by auto-blog.setup.
    Closes: #637603
  * Fix web revert of a file deletion.

 -- Joey Hess <joeyh@debian.org>  Mon, 05 Sep 2011 14:53:00 -0400

ikiwiki (3.20110715) unstable; urgency=low

  * rename: Fix logic error that broke renaming pages when the attachment
    plugin was disabled.
  * rename: Fix logic error that bypassed the usual pagespec checks.

 -- Joey Hess <joeyh@debian.org>  Fri, 15 Jul 2011 18:36:29 -0400

ikiwiki (3.20110712) unstable; urgency=low

  * attachment: Bugfix to create directory when moving attachment out of 
    holding area.
  * Display attachment manipulation links always, since attachments can be
    uploaded via javascript.

 -- Joey Hess <joeyh@debian.org>  Tue, 12 Jul 2011 00:41:26 -0400

ikiwiki (3.20110711) unstable; urgency=low

  * Add build dep on python-support. Closes: #633536
  * attachment: Bugfix to move upload attachments out of holding area
    when saving.
  * attachment: Bugfix for trying to attach files to a subpage of the index
    page.

 -- Joey Hess <joeyh@debian.org>  Mon, 11 Jul 2011 13:03:04 -0400

ikiwiki (3.20110707) unstable; urgency=low

  * userlist: New plugin, lets admins see a list of users and their info.
  * aggregate: Improve checking for too long aggregated filenames.
  * Updated to jQuery 1.6.1.
  * attachment: Speed up multiple file uploads by storing uploaded files
    in a staging area until the page is saved/previewed, rather than
    refreshing the site after each upload.
    (Sponsored by The TOVA Company.)
  * attachment: Files can be dragged into the edit page to upload them.
    Multiple file batch upload support. Upload progress bars.
    AJAX special effects. Impemented using the jQuery-File-Upload widget.
    (If you don't have javascript don't worry, I kept that working too.)
    (Sponsored by The TOVA Company.)
  * Add libtext-multimarkdown-perl to Suggests. Closes: #630705
  * headinganchors: Plugin by Paul Wise that adds ids to <hn> headings.
  * html5 is not experimental anymore. But not the default either, quite yet.
  * Support svg as a inlinable image type; svg images can be included on a
    page by simply linking to them, or by using the img directive.
    Note that sanitizing svg files is still not addressed.
  * img: Generate png format thumbnails for svg images.
  * Preserve mixed case in page creation links, and when creating a page
    whose title is mixed case, allow selecting between the mixed case and
    all lower-case names.
  * Fix ikiwiki-update-wikilist -r to actually work.
  * comments: collect metadata in a scan-phase preprocess hook, which
    fixes sorting comments by date. (smcv)
  * Run scan hooks for internal pages (preprocess hooks already run in scan
    mode) (smcv)
  * inline: Handle obfuscated urls, such as the mailto urls generated by
    markdown when forcing urls absolute.
  * Bugfix for wikilink containing an email address not showing up in 
    brokenlinks list.
  * Bugfix for trying to attach files to a subpage of the index page.

 -- Joey Hess <joeyh@debian.org>  Thu, 07 Jul 2011 20:38:31 -0400

ikiwiki (3.20110608) unstable; urgency=high

  * ikiwiki-mass-rebuild: Fix tty hijacking vulnerability by using su.
    (Once su's related bug #628843 is fixed.) Thanks, Ludwig Nussel.
    (CVE-2011-1408)
  * search: Update search page when page.tmpl or searchquery.tmpl are locally
    modified.

 -- Joey Hess <joeyh@debian.org>  Fri, 03 Jun 2011 20:30:35 -0400

ikiwiki (3.20110431) unstable; urgency=low

  * Danish translation update. Closes: #625721
  * Danish underlay translation update. Closes: #625765
    (Thanks, Jonas Smedegaard)
  * Support YAML::XS by not passing decoded unicode to Load. Closes: #625713
  * openid, aggregate, pinger: Use Net::INET6Glue if available to
    support making ipv6 connections. (Note that if LWPx::ParanoidAgent
    is installed, it defeats this for openid.)
  * Add additional directive quoting styles, to better support nested
    directives. Both triple-single-quote and heredoc quotes can be used.
    (Thanks, Timo Paulssen)
  * Changed license of madduck's python plugins from GPL-2 to BSD-2-clause.
  * po: support language codes in the form of 'es_AR', and 'arn'. (intrigeri)
    Closes: #627844
  * po: Make po4a warn, not error on a malformed document. (intrigeri)
  * Support the Hiawatha web server which sets HTTPS=off rather than not
    setting it. (There does not seem to be a standard here.)

 -- Joey Hess <joeyh@debian.org>  Fri, 03 Jun 2011 14:38:23 -0400

ikiwiki (3.20110430) unstable; urgency=low

  * meta: Allow adding javascript to pages. Only when htmlscrubber is
    disabled, naturally. (Thanks, Giuseppe Bilotta) Closes: #623154
  * comments: Add avatar picture of comment author, using Libravatar::URL
    when available. The avatar is looked up based on the user's openid,
    or email address. (Thanks, Francois Marier)
  * Recommend libgravatar-url-perl, which contains Libravatar::URL.
  * monotone: Implement rcs_getmtime, and work around a problem with monotone
    0.48 that affects rcs_getctime. (Thanks, Richard Levitte)
  * meta: Fix bug in loading of HTML::Entities that can break inline
    archive=yes (mostly masked by other plugins that load the module).
  * Be quiet about updating wrappers, except in verbose mode. (jmtd)
  * meta: Add FOAF support. Closes: #623156 (Jonas Smedegaard)
  * Promote Crypt::SSLeay to Recommends; needed for https openid auth.
  * tag: Avoid autocreating multiple tag pages that vary only in
    capitalization. The first capitalization seen of a tag will be used
    for the tag page.
  * Fix yaml build dep. Closes: #624712

 -- Joey Hess <joeyh@debian.org>  Sat, 30 Apr 2011 17:13:24 -0400

ikiwiki (3.20110328) unstable; urgency=low

  * Yaml formatted setup files are now produced by default.
    (Perl formatted setup files can still be used.)
  * Add timezone setting in setup file. This alows time zone to be configured
    via the web.
  * comment: Better fix to avoid showing comments of subpages, while
    not breaking manual inlining of comments.
  * meta: Security fix; don't allow alternative stylesheets to be added
    on pages where the htmlscrubber is enabled. CVE-2011-1401

 -- Joey Hess <joeyh@debian.org>  Mon, 28 Mar 2011 12:23:26 -0400

ikiwiki (3.20110321) unstable; urgency=low

  * comment: Don't show comments of subpages on parent pages.
    (Fixes bug introduced in version 3.20100505.)
  * darcs: Fix multiple issues preventing rcs_diff from working.
  * aggregate: Read cookies from ~/.ikiwiki/cookies by default.
    Also, the cookiejar configuration setting can be used by
    other plugins to provide a custom `cookie_jar` object for LWP::UserAgent.
    (Thanks, schmonz)
  * Avoid escaping / characters in filenames when building the cgiurl,
    as this confuses eg, cvsweb. 

 -- Joey Hess <joeyh@debian.org>  Mon, 21 Mar 2011 14:45:05 -0400

ikiwiki (3.20110225) unstable; urgency=low

  * editpage: Avoid inheriting internal page types.
  * htmltidy: Avoid breaking the sidebar when websetup is running.
  * transient: New utility plugin that allows transient pages to
    be stored in .ikiwiki/transient/ (smcv)
  * aggregate: Aggregated content is stored in the transient underlay.
    (Existing aggregated content is not moved, since it will eventually
    expire and be removed) (smcv)
  * autoindex, tag: Added autoindex_commit and tag_autocreate_commit that
    can be unset to make index files and tags respectively not be committed,
    and instead be stored in the transient underlay.
    Closes: #544322 (smcv)
  * autoindex: Adapted to use add_autofile. Slight behavior changes
    in edge cases that are probably really bug fixes. (smcv)
  * recentchanges: Use transient underlay (smcv)
  * map: Avoid unnecessary ul's in maps with nested directories.
    (Giuseppe Bilotta)
  * Fix broken baseurl in cgi mode when usedirs is disabled. Bug introduced
    in 3.20101231.
  * inline: Fix link to nested inlined pages's feeds. (Giuseppe Bilotta)
  * inline: Add 'id' parameter that can be used when styling individual
    feedlinks and postforms. (Giuseppe Bilotta)

 -- Joey Hess <joeyh@debian.org>  Fri, 25 Feb 2011 17:31:08 -0400

ikiwiki (3.20110124) unstable; urgency=low

  * comments: Fix commenting, broken by security fix.
  * blogspam: Don't check modifications from admins for spam, and also
    allow the blogspam_pagespec to do other matches against who the user is.
  * inline: Fix regression in feed titles. Closes: #610878
    (Thanks, Paul Wise)

 -- Joey Hess <joeyh@debian.org>  Mon, 24 Jan 2011 17:07:44 -0400

ikiwiki (3.20110123) unstable; urgency=low

  * Adapt autoindex test suite to work with old Test::More.
  * Fix posting by blog form, broken by last release.

 -- Joey Hess <joeyh@debian.org>  Sun, 23 Jan 2011 10:12:33 -0400

ikiwiki (3.20110122) unstable; urgency=medium

  * inline: Pass feed titles to templates and add title and rel attributes
    to feed links. (Giuseppe Bilotta)
  * inline: Use class rather than id for feedlinks and blogform.
    (Giuseppe Bilotta)
  * comments: Fix XSS security hole due to missing validation of page name.
    CVE-2011-0428 (Thanks, Dave B.)
  * rename: Fix crash when renaming a page that is linked to by a page
    in an underlay.

 -- Joey Hess <joeyh@debian.org>  Sat, 22 Jan 2011 10:22:25 -0400

ikiwiki (3.20110105) unstable; urgency=low

  * tag: Do not include tagbase in rss/atom category tags. (Giuseppe Bilotta)
  * tag: Improve display of tags with a slash in their names.
    (Giuseppe Bilotta)
  * Fix redirect to use a full url. Was broken (in theory) by baseurl
    changes in last release.
  * Fix `<base>` output by cgi to have a full url again, broken by last
    release.
  * Fix permalinks to recentchanges items and comments, broken by last
    release.
  * Export three cgi env vars needed for CGI->url to work. Fixed
    openid breakage from last release.
  * Removed `IkiWiki::misctemplate()` function. Any plugins using
    it should use `IkiWiki::cgitemplate()` instead.

 -- Joey Hess <joeyh@debian.org>  Wed, 05 Jan 2011 17:33:05 -0400

ikiwiki (3.20101231) unstable; urgency=low

  * Better support for serving the same site on multiple urls. (Such as
    a http and a https url, or a ipv4 and an ipv6 url.)
    (Thanks, smcv)
  * API: urlto without a defined second parameter now generates an url
    that starts with "/" (when possible; eg when the site's url and cgiurl
    are on the same domain).
  * Now when users log in via https, ikiwiki sends a secure cookie, that can
    only be used over https. If the user switches to using http, they will
    need to re-login. (smcv)
  * inline: Display feed buttons for nested inlines, linking to the inlined
    page's feed. (Giuseppe Bilotta)
  * goldtype: New theme, based on blueview, contributed by Lars Wirzenius.
  * po: do not override homepage title when it was overridden. (intrigeri)
  * Set HTML::Template's parent_global_vars option to allow using parameters
    like title_overridden that do not appear on the template. (intrigeri)
    (See https://rt.cpan.org/Public/Bug/Display.html?id=64158)
  * inline: Force an absolute page location when the inline postform is used.
  * editpage, comment: Clean up title when editing or creating a page or
    comment.
  * teximg: Use `\[` and `\]` instead of not recommended `$$`. (Paul Menzel)
    Closes: #596084
  * monotone: Improve version parsing to support patch and development
    versions of the monotone binary. (tommyd3mdi)
  * highlight: Support highlight 3.2+svn19 (note that released version 3.2
    is not supported). Closes: #605779 (David Bremner)
  * Add a second parameter to the rcs_diff hook, and avoid bloating memory
    reading in enormous commits.
  * git: Fix bug involving attempting to web revert a commit that included
    changes to attachments.

 -- Joey Hess <joeyh@debian.org>  Fri, 31 Dec 2010 21:23:37 -0400

ikiwiki (3.20101201) unstable; urgency=low

  * meta: Fix calling of htmlscrubber to pass the page parameter.
    The change of the htmlscrubber to look at page rather than destpage
    caused htmlscrubber_skip to not work for meta directives.

 -- Joey Hess <joeyh@debian.org>  Wed, 01 Dec 2010 20:28:01 -0400

ikiwiki (3.20101129) unstable; urgency=low

  * websetup: Fix encoding problem when restoring old setup file.
  * more: Add pages parameter to limit where the more is displayed.
    (thanks, dark)
  * Fix escaping of filenames in historyurl. (Thanks, aj)
  * inline: Improve RSS url munging to use a proper html parser,
    and support all elements that HTML::Tagset knows about. 
    (Which doesn't include html5 just yet, but then the old version
    didn't either.) Bonus: 4 times faster than old regexp method.
  * Optimise glob() pagespec. (Thanks, Kathryn and smcv)
  * highlight: Support new format of filetypes.conf used by version 3.2
    of the highlight package.
  * edittemplate: Fix crash if using a .tmpl file or other non-page file
    as a template for a new page.
  * git: Fix temp file location.
  * rename: Fix to pass named parameters to rcs_commit.
  * git: Avoid adding files when committing, so as not to implicitly add
    files like recentchanges files that are not normally checked in,
    when fixing links after rename.

 -- Joey Hess <joeyh@debian.org>  Mon, 29 Nov 2010 13:59:10 -0400

ikiwiki (3.20101112) unstable; urgency=HIGH

  * txt: Fix display when used inside a format directive.
  * highlight: Ensure that other, more-specific format plugins,
    like txt are used in preference to this one in case of ties.
  * htmltidy, sortnaturally: Add missing checkconfig hook
    registration. Closes: #601912
    (Thanks, Craig Lennox and Tuomas Jormola)
  * git: Use author date, not committer date. Closes: #602012
    (Thanks, Tuomas Jormola)
  * Fix htmlscrubber_skip to be matched on the source page, not the page it is
    inlined into. Should allow setting to "* and !comment(*)" to scrub
    comments, but leave your blog posts unscrubbed, etc. CVE-2010-1673
  * comments: Make postcomment() pagespec work when previewing a comment,
    including during moderation. CVE-2010-1673
  * comments: Make comment() pagespec also match comments that are being
    posted. CVE-2010-1673

 -- Joey Hess <joeyh@debian.org>  Fri, 12 Nov 2010 00:36:06 -0400

ikiwiki (3.20101023) unstable; urgency=low

  * Fix typo that broke anonymous git push.
  * Fix web reversion when the srcdir is in a subdir of the git repo.

 -- Joey Hess <joeyh@debian.org>  Sat, 23 Oct 2010 16:36:50 -0400

ikiwiki (3.20101019) unstable; urgency=low

  * Fix test suite failure on other side of date line.
  * htmltidy: Allow configuring tidy parameters in setup file.
    (W. Trevor King)
  * Updated French program translation. Closes: #598918
  * git: Added new rcs_revert and rcs_preprevert hooks.
  * recentchanges: Add revert buttons to RecentChanges page, and
    implement web-based reversion interface.
  * Thanks to Peter Gammie for his assistance with the web-based reversion
    feature.
  * actiontabs: More consistent styling of Hn tags.
  * websetup: Fix saving of advanced mode changes.
  * websetup: Fix defaults of checkboxes in advanced mode.
  * monotone: Fix recentchanges page when the srcdir is not at the top
    of the monotone workspace. Thanks, tommyd.
  * img: If a class is specified, don't also put the img in the img
    class.
  * auto-blog.setup: Don't enable opendiscussion by default; require users be
    logged in to post comments.

 -- Joey Hess <joeyh@debian.org>  Tue, 19 Oct 2010 02:32:23 -0400

ikiwiki (3.20100926) unstable; urgency=low

  * meta: Ensure that the url specified by xrds-location is absolute.
  * attachment: Fix attachment file size display.
  * Propigate PATH into wrapper.
  * htmlbalance: Fix compatibility with HTML::Tree 4.0. (smcv)

 -- Joey Hess <joeyh@debian.org>  Sun, 26 Sep 2010 23:02:54 -0400

ikiwiki (3.20100915) unstable; urgency=low

  * needsbuild hook interface changed; the hooks should now return
    the modified array of things that need built. (Backwards compatibility
    code keeps plugins using the old interface working.)
  * Remove PATH overriding code in ikiwiki script that was present to make
    perl taint checking happy, but taint checking is disabled.
  * teximg: Use Unicode UTF-8 encoding by default. Closes: #596067
    Thanks, Paul Menzel.
  * po: Make the po_master_language use a langpair like "en|English",
    so it can be configured via the web.
  * po: Allow enabling via web setup.
  * po: Auto-upgrade old format settings to new formats when writing
    setup file.
  * Pass array of names of files that have been deleted to needsbuild hook
    as second parameter, to allow for plugins that needs access to this
    information earlier than the delete hook.
  * actiontabs: Improve tab padding.
  * blueview: Fix display of links to translated pages in the page header.
  * Set isPermaLink="no" for guids in rss feeds. 
  * blogspam: Fix crash when content contained utf-8.
  * external: Disable RPC::XML's "smart" encoding, which sent ints
    for strings that contained only a number, fixing a longstanding crash
    of the rst plugin.
  * git: When updating from remote, use git pull --prune, to avoid possible
    errors from conflicting obsolete remote branches.
  * cutpaste: Fix bug that occured in some cases involving inlines when
    text was pasted on a page before being cut.

 -- Joey Hess <joeyh@debian.org>  Wed, 15 Sep 2010 16:29:01 -0400

ikiwiki (3.20100831) unstable; urgency=low

  * filecheck: Fall back to using the file command if the freedesktop
    magic file cannot identify a file.
  * flattr: New plugin. (Thanks to jaywalk for the initial implementation
    at a flattr plugin! This one is less configurable, but simpler.)
  * smiley: warn instead of error for missing smileys (Giuseppe Bilotta)
  * openid: Syntax tweak to the javascript code to make it work with MSIE 7
    (and MSIE 8 in compat mode). Thanks to Iain McLaren for reporting
    the bug and providing access to debug it.
  * style.css: Use relative, not absolute font sizes. Thanks, Giuseppe Bilotta.
  * htmlscrubber: Do not scrub url anchors that contain colons.
  * Danish translation update. Closes: #594673
  * highlight: Make location of highlight's files configurable in setup
    file to allow for nonstandard installations.
  * Allow "link(.)" and similar PageSpecs. Thanks, Giuseppe Bilotta.
  * Run the preprocess hooks in scan mode *before* the scan hooks.
    This allows the po plugin to register a scan hook that runs
    last and rescans pages after all data from the first scan pass is
    completed. This avoids the po plugin needing to rebuild some pages.
    (intrigeri)
  * po: Fix some bugs that affected l10n.ikiwiki.info's unusual
    setup. (intrigeri)
  * t/bazaar.t: Work around bzr 2.2.0's new requirement to configure
    bzr whoami before committing.
  * httpauth: Avoid redirecting the user to the cgiauthurl if
    they already have a login session.

 -- Joey Hess <joeyh@debian.org>  Tue, 31 Aug 2010 14:22:47 -0400

ikiwiki (3.20100815) unstable; urgency=medium

  * Fix po test suite to not assume ikiwiki's underlay is already installed.
    Closes: #593047

 -- Joey Hess <joeyh@debian.org>  Sun, 15 Aug 2010 11:42:55 -0400

ikiwiki (3.20100804) unstable; urgency=low

  * template: Fix dependency tracking. Broken in version 3.20100427.
  * po: The po_slave_languages setting is now a list, so the order of
    translated languages can be controlled. (intrigeri)
  * git: Fix gitweb historyurl examples so "diff to current" links work.
    (Thanks jrayhawk)
  * meta: Allow syntax closer to html meta to be used.
  * Add new disable hook, allowing plugins to perform cleanup after they
    have been disabled.
  * Use Digest::SHA built into perl rather than external Digest::SHA1
    to simplify dependencies. Closes: #591040
  * Fixes a bug that prevented matching deleted pages when using the page()
    PageSpec.

 -- Joey Hess <joeyh@debian.org>  Wed, 04 Aug 2010 09:20:52 -0400

ikiwiki (3.20100722) unstable; urgency=low

  * img: Add a margin around images displayed by this directive.
  * comments: Added commentmoderation directive for easy linking to the
    comment moderation queue.
  * aggregate: Write timestamp next aggregation can happen to
    .ikiwiki/aggregatetime, to allow for more sophisticated cron jobs.
  * Add --changesetup mode that allows easily changing options in a
    setup file.
  * openid: Fix handling of utf-8 nicknames.
  * Clarified what the filter hook should be passed: Only be the raw,
    complete text of a page. Not a snippet, or data read in from an
    unrelated file.
  * template: Do not pass filled in template through filter hook.
    Avoids causing breakage in po plugin.
  * color, comments, conditional, cutpaste, more, sidebar, toggle: Also
    avoid unnecessary calls to filter hook.
  * po: needstranslation() pagespec can have a percent specified.
  * Drop Cache-Control must-revalidate (Firefox 3.5.10 does not seem to have
    the caching problem that was added to work around). Closes: #588623
  * Made much more robust in cases where multiple source files produce
    conflicting files/directories in the destdir.
  * Updated French translation from Philippe Batailler. Closes: #589423
  * po: Fix selflink display on tranlsated pages. (intrigeri)
  * Avoid showing 'Add a comment' link at the bottom of the comment post form.

 -- Joey Hess <joeyh@debian.org>  Thu, 22 Jul 2010 16:49:05 -0400

ikiwiki (3.20100704) unstable; urgency=low

  * Changes to avoid display of ugly google openids, by displaying
    a username taken from openid.
  * API: Add new optional field nickname to rcs_recentchanges.
  * API: rcs_commit and rcs_commit_staged are now passed named
    parameters.
  * openid: Store nickname based on username or email provided from
    openid provider.
  * git: Record the nickname from openid in the git author email.
  * comment: Record the username from openid in the comment page.
  * Fixed some confusion and bugginess about whether
    rcs_getctime/rcs_getmtime were passed absolute or relative filenames.
    (Make it relative like everything else.)
  * hnb: Fixed broken use of mkstemp that had caused dangling temp files,
    and prevented actually rendering hnb files.
  * Use comment template on comments page of example blog.
  * comment.tmpl: Fix up display when inline uses it to display a non-comment
    page. (Such as a discussion page.)
  * git: Added git_wrapper_background_command option. Can be used to eg, 
    make the git wrapper push to github in the background after ikiwiki
    runs.
  * po: Added needstranslation() pagespec. (intrigeri)
  * po: Added support for .html source pages. (intrigeri)
  * comment: Fix problem moderating comments of certian pages with utf-8
    in their name.

 -- Joey Hess <joeyh@debian.org>  Sun, 04 Jul 2010 16:19:43 -0400

ikiwiki (3.20100623) unstable; urgency=low

  * openid: Add openid_realm and openid_cgiurl configuration options,
    useful in a few edge case setups.
  * attachment: Show files from underlay in attachments list.
  * img: Support hspace and vspace attributes.
  * editpage: Rename "comments" field to avoid CSS conflict with the
    comments div.
  * edittemplate: Make silent mode not disable display when the template
    page does not exist, so it can be easily created.
  * edittemplate: Look for template pages under templates/ like everything
    else (still looks in old location for backwards compatibility).
  * attachment: When inserting links, insert img directives for images,
    if that plugin is enabled.
  * websetup: Allow enabling plugins listed in disable_plugins.
  * editpage, comments: Fix broken links in sidebar (due to forcebaseurl).
    (Thanks, privat)
  * calendar: Tune archive_pagespec to only match pages, not other files.
  * Fix issues with combining unicode srcdirs and source files.
    (Workaround bug #586045)
  * Make --gettime be honored after initial setup.
  * git: Fix --gettime to properly support utf8 filenames.
  * attachment: Support Windows paths when taking basename of client-supplied
    file name.
  * theme: New plugin, allows easily themeing a site via the underlay.
  * Added actiontabs theme by Svend Sorensen.
  * Added blueview theme by Bernd Zeimetz.
  * mercurial: Fix buggy getctime code. Closes: #586279
  * link: Enhanced to handle URLs and email addresses. (Bernd Zeimetz)

 -- Joey Hess <joeyh@debian.org>  Wed, 23 Jun 2010 14:10:26 -0400

ikiwiki (3.20100610) unstable; urgency=low

  * creation_day() etc use local time, not gmtime. To match calendars, which
    use local time.
  * img: Fill in missing height or width when scaling image.
  * Remove example blog tag pages; allow autotag creation to create them
    when used.
  * Fix support for globbing in tagged() pagespecs.
  * Fix display of sidebar when previewing page edit. (Thanks, privat)
  * relativedate: Fix problem with localised dates not working.
  * editpage: Avoid storing accidental state changes when previewing pages.
  * page.tmpl: Add a div around the page content, and comments, to aide in
    sidebar styling.
  * style.css: Improvements to make floating sidebar fit much better on
    pages with inlines.
  * calendar: Shorten day names, and improve styling of month calendar.
  * style.css: Reduced sidebar width back to 20ex from 30; the month calendar
    will now fit in the smaller width, and 30 was feeling too large.

 -- Joey Hess <joeyh@debian.org>  Thu, 10 Jun 2010 14:24:05 -0400

ikiwiki (3.20100518.2) unstable; urgency=low

  * Fix a typo in the last release.

 -- Joey Hess <joeyh@debian.org>  Tue, 18 May 2010 14:17:01 -0400

ikiwiki (3.20100518) unstable; urgency=low

  * page.tmpl: Accidentially broke po plugin's otherlanguages list styling
    when modifying for html5; now fixed.
  * Fix a bug that prevented matching deleted comments, and so did not update
    pages that had contained them.

 -- Joey Hess <joeyh@debian.org>  Tue, 18 May 2010 13:37:39 -0400

ikiwiki (3.20100515) unstable; urgency=low

  * Removed misc.tmpl. Now to theme ikiwiki, you only need to customise
    a single template, page.tmpl.
  * If you have a locally customised page.tmpl, it needs to be updated
    to set <base> when BASEURL or FORCEBASEURL is set.
  * comments: Comments pending moderation are now stored in the srcdir
    alongside accepted comments, but with a `._comment_pending` extension.
    This allows easier byhand moderation, as the "_pending" need
    only be stripped off and the comment be committed to version control.
  * The `comment_pending()` pagespec can be used to match such unmoderated
    comments, which makes it easy to add a feed of them, or a counter
    indicating how many there are.
  * Belatedly added a `comment()` pagespec.
  * Gave comment and page editing forms some CSS and accessability love.
  * Renamed postscan hook to indexhtml, to reflect its changed position,
    and typical use.
  * inline: Call indexhtml when inlining internal pages, so their
    text can be indexed for searching.
  * Delete hooks are passed deleted internal pages. 
  * openid: Incorporated a fancy openid-selector signin form.
    (Based on http://code.google.com/p/openid-selector/)
  * openid: Use "openid_identifier" as the form field, as required
    by OpenID Authentication v2.0 spec.
  * Removed the openidsignup option. Instead, my recommendation is to
    leave passwordauth enabled and let people who don't have an openid use it.
    The openid selector form avoids the UI annoyance of having both openid
    and passwordauth on one form.
  * calendar: Allow negative month to be specified. -1 is last month, etc.
    (And also negative years.)
  * calendar: Display year in title of month calendar.
  * Use xhtml friendly pubdate setting.
  * remove, rename: Add guards against XSRF attacks.

 -- Joey Hess <joeyh@debian.org>  Sat, 15 May 2010 21:00:45 -0400

ikiwiki (3.20100504) unstable; urgency=low

  * Add parameter to displaytime to specify that it is a pubdate,
    and in html5 mode, use time tag.
  * Add placeholder text in search form (in html5 mode only).
  * In html5 mode, use all the nice new semantic tags. Care was taken
    to not change the id/class named used in the CSS, so only CSS
    that refers to tag types needed to be changed.
  * Add ACTIONS variable to page.tmpl, which allows plugins to add arbitrary
    links to the action bar without modifying the template further.
    (COMMENTSLINK and DISCUSSIONLINK could be folded into this, but
    are kept separate for now to avoid breaking modified templates.)
  * websetup: Only display Setup button on admins' preferences page. 
  * graphviz: Fix display of preexisting images in preview mode.
  * Fixes a bug in skipping of illegal source files introduced in 
    3.20100427.

 -- Joey Hess <joeyh@debian.org>  Tue, 04 May 2010 20:26:20 -0400

ikiwiki (3.20100501) unstable; urgency=low

  * TMPL_INCLUDE re-enabled for templates read from the templatedir.
    (But not in-wiki templates.)
  * Version dependency on liburi-perl to >= 1.36; previous versions
    did not support building urls from utf-8 strings. Closes: #579713
  * Ikiwiki can be configured to generate html5 instead of the default xhtml
    1.0. The html5 output mode is experimental, not yet fully standards
    compliant, and will be subject to rapid change.
  * htmlscrubber: Allow html5 semantic tags: section, nav, article, aside
    hgroup, header, footer, figure, figcaption, time, mark
  * htmlscrubber: Also allow some other html5 tags: canvas, progress, meter,
    ruby, rt, rp, details, summary, datalist.
  * htmlscrubber: Round out html5 video support with the preload
    attribute and the source tag.
  * htmlscrubber: Allow the html5 form attributes: placeholder, autofocus,
    min, max, step, required, autocomplete, novalidate, pattern, list,
    and form. (Also the form* override attributes for input and buttons.)
  * htmlscrubber: Allow additional misc html5 attributes: reversed,
    spellcheck, and hidden.
  * template: Fix typo.

 -- Joey Hess <joeyh@debian.org>  Sat, 01 May 2010 20:49:28 -0400

ikiwiki (3.20100427) unstable; urgency=low

  [ Joey Hess ]
  * tag: Automatic creation of tag pages can now be enabled using
    the tag_autocreate setting. (David Riebenbauer)
  * Customised templates can now be included in the source of wikis
    (and also in underlays), and dependencies on them are tracked.
  * TMPL_INCLUDE is no longer supported in any template.
  * underlay: Removed the add_templates option.
  * Add template_depends function to plugin API.
  * bzr: Fix bzr log parsing to work with bzr 2.0. (liw)
  * comments: Fix missing entity encoding in title.
  * txt: Add a special case for robots.txt.

  [ Simon McVittie ]
  * Add support for link types, and make the the tagged() pagespec only
    match tags, not regular links (a bugfix).
  * Rebuild wikis on upgrade to this version to get tag link types recorded
    correctly.
  * Revamp sorting system; allow new sort methods to be added by plugins,
    and add a "sortspec" syntax that can combine, reverse, etc sort methods.
  * meta: Add `meta(author)`, `meta(title)` etc sortspecs to allow sorting
    by metadata.
  * meta: Add optional sortas parameter to author and title meta directives.
    This can be used to get names sorted by last name without displaying
    them last name first.
  * sortnaturally: New plugin; the title_natural sort method has moved here.
  * meta: store fields consistently unescaped, and escape on use.
    (A wiki rebuild is also needed due to this change.)

  [ Joey Hess ]
  * Update dependency for git-core to git transition.
  * po: Check that translated underlay directories exist before using them
    for master language.
  * po: Configuring the same language as master and slave confuses processing;
    so filter out such a misconfiguration.
  * calendar: Add archive_pagespec, which is used by ikiwiki-calendar to
    specify which pages to include on the calendar archive pages.
    (The pagespec can still also be specified on the ikiwiki-calendar command
    line.)
  * pagestats: Class parameter can be used to override default class for
    custom styling.
  * pagestats: Use style=list to get a list of tags, scaled by use like
    in a tag cloud. This is useful to put in a sidebar.
  * Rework example blog front page.
  * CSS and templates for sidebar changed to use a class, not an id.
  * sidebar: Now a sidebar directive can be used to override the sidebar
    shown on a page.
  * Enable calendar and sidebar in auto-blog.setup.
  * sidebar: Add global_sidebars setting.
  * conditional: Fix bug that forced "all" mode off by default.
  * calendarmonth.tmpl: The month calendar is now put in a sidebar.
  * calendar: Improved display of arrows.
  * Rename --getctime to --gettime. (The old name still works for
    backwards compatibility.)
  * --gettime now also looks up last modification time.
  * Automatically run --gettime the first time ikiwiki is run on 
    a given srcdir. (Use --no-gettime to disable.)
  * Add rcs_getmtime to plugin API; currently only implemented
    for git and svn.
  * Optimise --gettime for git, so it's appropriately screamingly
    fast. (This could be done for most other backends too.)
  * However, --gettime for git no longer follows renames. That would
    be slow, and whether a renamed wiki page is the same page is really
    an iffy thing.
  * Use above to fix up timestamps on docwiki, as well as ensure that
    timestamps on basewiki files shipped in the deb are sane.
  * autoindex: Switch to using %wikistate instead of abusing
    $pagestate{index}.
  * bzr: Support rcs_getmtime, and fix rcs_getctime implementation
    (Jelmer Vernooij)
  * Quite a lot of new optimisations, and one major fix to a recent
    performance regression.
  * Moved javascript files under the ikiwiki/ directory, to avoid cluttering
    the top of the web root. This is another things that requires a wiki
    rebuild on upgrade to this version.
  * Fix removal of rendered files in rebuild mode.
  * Add page() PageSpec, which is like glob() but matches only pages, 
    not other files.

 -- Joey Hess <joeyh@debian.org>  Tue, 27 Apr 2010 00:00:00 -0400

ikiwiki (3.20100403) unstable; urgency=low

  * websetup: Add websetup_unsafe to allow marking other settings
    as unsafe.
  * Improve openid url munging; do not display anchors and cgi parameters,
    as used by yahoo and google urls.
  * Add complete German basewiki and directives translation done by
    Sebastian Kuhnert.
  * Add a include setting, which can be used to make ikiwiki process
    wiki source files, such as .htaccess, that would normally be skipped
    for security or other reasons. Closes: #447267
    (Thanks to Aaron Wilson for the original patch.)
  * Add support for setup files written in YAML.
  * Add --set-yaml switch for setting more complex config file options.
  * filecheck: Fix bugs that prevented the pagespecs from matching when
    not called by attachment plugin.
  * Fix incorrect influence info returned by a failing link() pagespec,
    that could lead to bad dependency handling in certian situations.
  * Add preprocessed 'use lib' line to ikiwiki-transition and ikiwiki-calendar
    if necessary for unusual install.
  * auto-blog.setup: Set tagbase by default, since most bloggers will want it.
  * Allow wrappers to be built using tcc. (Workaround #452876)
  * openid: Use Openid Simple Registration or OpenID Attribute Exchange
    to get the user's email address and username. (Neither is yet
    used, but they are available in the session object now.)
  * page.tmpl: Add Cache-Control must-revalidate to ensure that users
    (especially of Firefox) see fresh page content.
  * htmlscrubber: Allow colons in urls after '?'
  * template: Search for templates in the templatedir, if they are not
    found as pages in the wiki.

 -- Joey Hess <joeyh@debian.org>  Sat, 03 Apr 2010 14:17:28 -0400

ikiwiki (3.20100312) unstable; urgency=HIGH

  * Fix utf8 issues in calls to md5_hex.
  * moderatedcomments: Added moderate_pagespec that can be used
    to control which users or comment locations are moderated.
    This can be used, just for example, to moderate "user(http://myopenid.com/*)"
    if you're getting a lot of spammers from one particular openid
    provider (who should perhaps answer your emails about them),
    while not moderating other users.
  * moderatedcomments: The moderate_users setting is deprecated. Instead,
    set moderate_pagespec to "!admin()" or "user(*)".
  * Fix missing span on recentchanges page template.
  * search: Avoid '$' in the wikiname appearing unescaped on omega's
    query template, where it might crash omega.
  * htmlscrubber: Security fix: In data:image/* uris, only allow a few
    whitelisted image types. No svg.

 -- Joey Hess <joeyh@debian.org>  Tue, 09 Mar 2010 19:46:35 -0500

ikiwiki (3.20100302) unstable; urgency=low

  * comments: Display number of comments in comment action link.
  * Rebuild wikis on upgrade to this version to get the comment counts
    added to existing pages.
  * Loosen regexp, to allow empty quoted parameters in directives.
  * Add force_overwrite setting to make setup automator overwrite existing
    files/directories.
  * Fix admin openid detection in setup automator, and avoid prompting
    for a password.
  * Add new --clean option; this makes ikiwiki remove all built
    files in the destdir, as well as wrappers and the .ikiwiki directory.

 -- Joey Hess <joeyh@debian.org>  Tue, 02 Mar 2010 22:17:30 -0500

ikiwiki (3.20100212) unstable; urgency=low

  * template: Preprocess parameters before htmlizing.
  * img: Fix a bug that could taint @links with undef values.
  * setup automator: Configure Term::Readline to use bold for prompt, rather
    than default underline. Closes: #517656
  * Allow jumping directly into account registration process by going to 
    ikiwiki.cgi?do=register
  * Improve display of openid in preferences page.
  * Add link to userpage (or creation link) to top of preferences page.
  * opendiscussion: This plugin will also now allow posting comments
    to otherwise locked-down sites. 
  * auto-blog.setup: Lock all pages, so only admin can post to the blog
    by default, and enable opendiscussion so others can comment.
  * Fix color and format plugins to appear in the websetup interface.
  * amazon_s3: Fix to support the EU S3 datacenter, which is more picky
    about attempts to create already existing buckets.
  * httpauth: When cgiauthurl is configured, httpauth can now be used
    alongside other authentication methods (like openid or anonok). Rather
    than always redirect to the cgiauthurl for authentication, there is now
    a button on the login form to use it.
  * httpauth: Add httpauth_pagespec setting that can be used to limit
    pages to only being edited via users authed with httpauth.
  * Allow globs to be used in user() pagespecs.
  * Group related plugins into sections in the setup file, and drop
    unused rcs plugins from the setup file.

 -- Joey Hess <joeyh@debian.org>  Fri, 12 Feb 2010 16:45:50 -0500

ikiwiki (3.20100122) unstable; urgency=low

  * inline: Avoid showing edit links if page editing is disabled.
    (Sjoerd)
  * signinedit: Auto-disable the plugin when all authentication methods
    are disabled.
  * comments: Fix permalinks for comments using new conflict-free filenames.
  * img: Support alignment of images with captions. (Giuseppe Bilotta)
  * websetup: Fix utf-8 problems.
  * websetup: Fix bug in array change detection.
  * linkmap: Simplify and improve browser compatibility by using an img, 
    not object tag.
  * git: The new git-notes feature in git 1.6.6 changes git log output
    in a way that broke ikiwiki's parser if notes are added to commits.
  * po: Avoid crash when a page is empty.

 -- Joey Hess <joeyh@debian.org>  Fri, 22 Jan 2010 16:02:36 -0500

ikiwiki (3.20100102.3) unstable; urgency=low

  Happy palindrome day!

  * pagestats: Add show parameter. Closes: #562129 (David Paleino)
  * toc: Add startlevel parameter. (kerravonsen)
  * Remove example ikiwiki setup file from the Debian package. This
    re-enables linking to /usr/share/ikiwiki/examples which has the
    example sites also used by auto-blog.setup. The example setup file
    can be generated at any time using ikiwiki --dumpsetup so I do
    not see a reason to ship it. Closes: #562183
  * Use env hack in python scripts.
  * comments: Add a checksum to the name of comment pages, to
    avoid merge conflicts when comments are posted to two branches of a
    site.
  * linkmap: Add option to omit disconnected pages from the map.
  * inline: Fix bug that limited displayed pages when feedshow was
    specified w/o show.
  * Fix several places that did not properly handle capitalization of
    the discussionpage setting. Specifically, fixes discussion actions
    on discussion pages, and unbreaks the opendiscussion plugin.

 -- Joey Hess <joeyh@debian.org>  Sat, 02 Jan 2010 21:46:16 -0500

ikiwiki (3.20091218) unstable; urgency=low

  * Add complete Spanish basewiki translation done by Fernando Gonzalez de
    Requena.
  * Improve javascript onload handling.
  * monotone: Deal with format change in version 0.45.
    (Thanks, Richard Levitte)
  * cvs: Add missing bit to Automator.
  * attachment: Fix reversion in attachment sorting by age.
  * Fix utf-8 problems in rename, remove, attachment, 404, sourcepage, and
    goto.

 -- Joey Hess <joeyh@debian.org>  Fri, 18 Dec 2009 20:47:24 -0500

ikiwiki (3.20091202) unstable; urgency=low

  * meta: Generate meta description tags even when the html scrubber is
    enabled.
  * meta: Allow use of DESCRIPTION in templates to get at the meta description
    value. (Thanks, NicolasLimare)
  * inline: Use caching of inlined pages to speed up builds of inlines that
    include feeds. Speedup of about 25% for small inlines; could be much
    larger for inlines of many, or complex pages.
  * Added (incomplete) Turkish po file. Closes: #556744
    Thanks, Recai Oktaş
  * date: New plugin that allows inserting date directives that expand to
    pretty-printed dates, using the same formatting as used for page
    modification date display, etc.
  * htmllink: Allow a title attribute to be specified.
  * calendar: Add title attributes for all links in the calendars.
  * calendar: Fix month wraparound error that broke in December.

 -- Joey Hess <joeyh@debian.org>  Wed, 02 Dec 2009 13:09:20 -0500

ikiwiki (3.20091113) unstable; urgency=low

  * underlay: Fix example values put in setup file to be array
    references.
  * underlay: Avoid crashing if lists of underlays (or template
    directories) are not configured.
  * Moved the postscan hook to run on the raw html of a page, before
    the template is filled out. This improves the search plugin's indexing,
    since it will not include navigational elements from the page template
    or sidebar.
  * localstyle: New plugin, allows overrding the toplevel local.css
    with one that is closer to a page.
  * httpauth: Add cgiauthurl setting that can be used to do http basic auth
    only when ikiwiki needs authentication, rather than for any access to 
    the cgi/wiki.
  * inline: Do not generate feeds for nested inlines.
  * inline: Allow direct inclusion of non-page files in raw mode.
  * inline: Fix display of all pages when archive=yes or show=0 are used.

 -- Joey Hess <joeyh@debian.org>  Fri, 13 Nov 2009 20:51:57 -0500

ikiwiki (3.20091031) unstable; urgency=low

  * po: Fix breakage caused by changes to render code.
  * mdwn: Avoid trying to use multimarkdown if it is not installed. 
  * moderatedcomments: New plugin to allow comment moderation w/o relying
    on blogspam.net.
  * When redirecting to a page, ie, after editing, ensure that the
    url is uri-encoded. Most browsers other than MSIE don't care, but it's
    the right thing to do.
  * Add a spec file to allow building rpm from the source package.
  * google: Pass the whole wiki url to google, not just the domain,
    so that search works correctly for wikis that are located in
    subdirectories of domains.

 -- Joey Hess <joeyh@debian.org>  Sat, 31 Oct 2009 18:29:38 -0400

ikiwiki (3.20091023) unstable; urgency=low

  * inline: Fix raw mode. Closes: #552114

 -- Joey Hess <joeyh@debian.org>  Fri, 23 Oct 2009 12:38:50 -0400

ikiwiki (3.20091022) unstable; urgency=low

  * edittemplate: Allow template page name to be specified using anything
    legal for a wikilink (including eg, leading slashes).
  * edittemplate: Work around bug #551499 in CGI::FormBuilder.
  * Fix a bug introduced in the last version that caused ikiwiki
    to skip all files if a sourcedir of "./" was specified.
  * Support CFLAGS when building wrapper.
  * meta: Gather permalink info on scan pass so it is available
    to inline when using a template that does not include page content.

 -- Joey Hess <joeyh@debian.org>  Thu, 22 Oct 2009 20:25:15 -0400

ikiwiki (3.20091017) unstable; urgency=low

  * Added support framework for multiple types of dependencies, including
    dependncies that are only affected by page precence or link changes.
  * Rebuild wikis on upgrade to this version to get improved dependency
    info.
  * pagecount, calendar, postsparkline, progress: Use a presence dependency,
    which makes these directives much less expensive to use, since page
    edits will no longer trigger an unnecessary update.
  * map: Use a presence dependency unless show= is specified.
    This makes maps efficient enough that they can be used on sidebars!
  * inline: Use a presence dependency in quick mode.
  * brokenlinks: Use a link dependency.
    This makes it much more efficient, only updating when really necessary.
  * orphans, pagestats: Use a combination of presence and link dependencies.
    This makes them more efficient. It also fixes a longstanding bug,
    where if only a small set of pages were considered by orphans/pagestats,
    changes to links on other pages failed to cause an update.
  * linkmap: Use a combination of presence and link dependencies.
    This makes the map be regenerated much less frequently in many cases,
    so larger maps are more practical to use now.
  * Plugins providing PageSpec `match_*` functions should pass additional
    influence information when creating result objects. This allows correctly
    handling many more complicated dependencies.
  * API change: `pagespec_match_list` has completly changed its interface.
    The old interface will be removed soon, and a warning will be printed
    if any plugins try to use it.
  * Transitive dependencies are now correctly supported.
  * ikiwiki-calendar: New command automates creation of archive pages
    using the calendar plugin.
  * calendar: Fix midnight rebuild trigger of calendars with explicit
    month/year.
  * calendar: Fix bug in next/previous year/month links, which sometimes
    linked to an archive page from the wrong year, or were missing.
  * git: --getctime will now follow renames back to the original creation
    of a file.
  * calendar: Fix CSS for year calendar to match the plugin documentation.
  * Added minimal default CSS for calendar plugin, just highlighting the
    current day.
  * inline: Optimize generation of archives, etc by not getting inlined page
    content if the template does not use it.

 -- Joey Hess <joeyh@debian.org>  Sat, 17 Oct 2009 15:37:04 -0400

ikiwiki (3.20091009) unstable; urgency=low

  * parentlinks: Add has_parentlinks template parameter to allow styling
    the toplevel index differently etc.
  * img: Correct bug in image size calculation code.
  * img: Fix dependency code for full size images.
  * toggle, relativedate: Support templates that add attributes
    to the body tag.
  * Support RPC::XML 0.69's incompatible object instantiation method.
  * mirrorlist: Display nothing if list is empty.
  * Fix a bug that could lead to duplicate links being recorded
    for tags.
  * Optimize away most expensive file prune checks, when refreshing,
    by only checking new files.

 -- Joey Hess <joeyh@debian.org>  Fri, 09 Oct 2009 19:53:50 -0400

ikiwiki (3.14159265) unstable; urgency=low

  * Add complete French basewiki and underlays translation from the Debian
    French l10n team, including Philippe Batailler, Alexandre Dupas, and
    Steve Petruzzello.
  * Expand banned_users; it can now include PageSpecs, which
    allows banning by IP address.
  * underlay: Also allow configuring additional directories to search 
    for template files in.
  * Fix parsing web commits from ipv6 addresses.
  * Add genwrapper hook, that can be used to add code into the C wrapper.
  * cvs: Yeah, ikiwiki even supports CVS now. Plugin contributed by
    Amitai Schlair.
  * Updated Czech translation from Miroslav Kure. Closes: #546223
  * rsync: New plugin that allows pushing the destdir to a remote host
    via rsync or similar. Thanks, Amitai Schlair.
  * auto.setup, auto-blog.setup: Fix sanitization of entered wikiname.
    Closes: #547378

 -- Joey Hess <joeyh@debian.org>  Thu, 24 Sep 2009 18:50:43 -0400

ikiwiki (3.1415926) unstable; urgency=high

  [ Joey Hess ]
  * po: Detect if nowrapi18n can't be passed to po4a, and warn about
    the old version, but continue. Closes: #541205 
  * inline: Avoid use of my $_ as it fails with older perls.
    Closes: #541215
  * Add discussionpage configuration setting.
  * Several optimisations, including speedups to orphans and brokenlinks
    calculation.
  * meta, img: Fix bugs in dependency code. (smcv)
  * Allow building ikiwiki on systems w/o po4a --
    building of the translated underlays will be skipped in this case.
  * Add basic styling of po plugin's languages list.
  * inline: Display an error if feedpages is specified and fails to match
    due to a problem such as created_before being told to check against
    a page that does not exist.
  * Remove deprecated ikiwiki/blog and ikiwiki/preprocessordirective
    pages from the basewiki.
  * Updated French program translation from Philippe Batailler.
    Closes: #542036
  * po: Fixed to run rcs_add ralative to srcdir.
  * Italian program translation from Luca Bruno.
  * Fix example blog's tags/life to not have a broken PageSpec.
    Closes: #543510
  * Optimize the dependencies list. This also fixes a bug
    that could cause repeated refreshes of the wiki to grow
    increasingly larger dependency lists, and get increasingly
    slower. (smcv)
  * Rebuild wikis on upgrade to this version to fix bloat caused
    by the dependency bug.
  * Further optimisation of dependency handling by adding a special
    case for simple page dependencies. (smcv)
  * htmltidy: Return an error message if tidy fails. Closes: #543722
  * po: Fix name of translated toplevel index page. (intrigeri)
  * po: Fix display of links from a translated page to itself (ntrigeri)
  * Add Czech basewiki translation from Miroslav Kure.
  * po: fix interdiction to create pages of type po (intrigeri)
  * po: po: favor the type of linking page's masterpage on page creation
    (intrigeri)
  * img: Don't generate new verison of image if it is scaled to be
    larger in either dimension.

  [ Josh Triplett ]
  * teximg: Replace the insufficient blacklist with the built-in security
    mechanisms of TeX. (CVE-2009-2944)

 -- Joey Hess <joeyh@debian.org>  Sun, 30 Aug 2009 15:20:46 -0400

ikiwiki (3.141592) unstable; urgency=low

  * Add new hooks: canremove, canrename, rename. (intrigeri)
  * rename: Refactor subpage rename handling code into rename hook. (intrigeri)
  * po: New plugin, suporting translation of wiki pages using po files.
    (intrigeri)
  * Add build machinery to build po files to translate the underlay wikis,
  * Add further build machinery to generate translated underlays from
    the po file, for use by wikis whose primary language is not English.
  * Add Danish basewiki translation by Jonas Smedegaard.
  * img: Fix adding of dependency from page to the image.
  * pagestats: add `among` parameter, which only counts links from specified
    pages (smcv)
  * pagestats: when making a tag cloud, don't emit links where the tag is
    unused (smcv)
  * map: Avoid emitting an unclosed ul element if the map is empty. (harishcm)
  * inline: Add pagenames parameter that can be used to list a set of
    pages to inline, in a specific order, without using a PageSpec. (smcv)
  * Add getsource plugin (Will, smcv)

 -- Joey Hess <joeyh@debian.org>  Tue, 11 Aug 2009 14:59:31 -0400

ikiwiki (3.14159) unstable; urgency=low

  * svn: Fix rcs_rename to properly scope call to dirname.
  * img: Pass the align parameter through to the generated img tag.
  * Move OpenID pretty-printing from openid plugin to core (smcv)

 -- Joey Hess <joeyh@debian.org>  Thu, 16 Jul 2009 14:37:22 -0400

ikiwiki (3.1415) unstable; urgency=low

  * img: Fix extra double quote with alt text. (smcv)
  * Updated French debconf templates translation. Closes: #535103
  * openid: Support Net::OpenID 2.x when pretty-printing
    openids. (smcv)
  * highlight: Fix utf-8 encoding bug. Closes: #535028

 -- Joey Hess <joeyh@debian.org>  Tue, 07 Jul 2009 16:25:05 -0400

ikiwiki (3.141) unstable; urgency=low

  * comment: Make comment directives no longer use the internal "_comment"
    form, and document the comment directive syntax.
  * Avoid relying on translators preserving the case when translating
    "discussion", which caused Discussion pages to get unwanted Discussion
    links.
  * Tighten up matching of bare words inside directives; do not
    allow an unterminated """ string to be treated as a series
    of bare words. Fixes runaway regexp recursion/backtracking
    in strange situations.
  * Setup automator: Check that each plugin added to the generated
    setup file can be loaded and that its config is ok. If a plugin
    fails for any reason, disable it in the generated file.
    Closes: 532001
  * pagecount: Fix broken optimisation for * pagespec.
  * goto: Support being passed a page title that is not a valid page
    name, to support several cases including mercurial's long user
    names on the RecentChanges page, and urls with spaces being handled
    by the 404 plugin.
  * Optimise use of gettext, and avoid ugly warnings if Locale::gettext
    is not available. Closes: #532285
  * meta: Add openid delegate parameter to allow delegating only
    openid or openid2.
  * Disable the Preferences link if no plugin with an auth hook is enabled.
  * Updated French translation. Closes: #532654
  * aggregate: Fix storing of changed md5.
  * aggregate: Avoid resetting ctime when an item md5 changes.

 -- Joey Hess <joeyh@debian.org>  Fri, 12 Jun 2009 19:50:46 -0400

ikiwiki (3.14) unstable; urgency=low

  * highlight: New plugin supporting syntax highlighting of pretty much
    anything.
  * debian/control: Add suggests for libhighlight-perl, although
    that package is not yet created by Debian's highlight source package.
    (See #529869)
  * format: Provide a htmlizefallback hook that other plugins
    can use to handle formats that are not suitable for general-purpose
    htmlize hooks. Used by highlight.
  * Fix test suite to not rely on an installed copy of ikiwiki after
    underlaydir change. Closes: #530502
  * Danish translation update. Closes: #530877

 -- Joey Hess <joeyh@debian.org>  Mon, 01 Jun 2009 13:05:34 -0400

ikiwiki (3.13) unstable; urgency=low

  * ikiwiki-transition: If passed a nonexistant srcdir, or one not
    containing .ikiwiki, abort with an error rather than creating it.
  * Allow underlaydir to be overridden without messing up inclusion
    of other underlays via add_underlay.
  * More friendly display of markdown, textile in edit form selector
    (jmtd)
  * Allow curly braces to be used in pagespecs, and avoid a whole class
    of potential security problems, by avoiding performing any string
    interpolation on user-supplied data when translating pagespecs.
  * ikiwiki-transition: Allow setup files to be passed to all subcommands
    that need a srcdir.
  * ikiwiki-transition: deduplinks was broken and threw away all
    metadata stored by plugins in the index. Fix this bug.
  * listdirectives: Avoid listing _comment directives and generally
    assume any directive starting with _ is likewise internal.

 -- Joey Hess <joeyh@debian.org>  Fri, 22 May 2009 14:10:56 -0400

ikiwiki (3.12) unstable; urgency=low

  * Re-enable python-support and add python:Depends to control file.
  * ikiwiki-makerepo: Avoid using abs_path, as it apparently
    fails on nonexistant directories with some broken perl
    versions.
  * inline: Minor optimisation.
  * add_link: New function, which plugins should use rather than
    modifying %links directly, to avoid it accumulating duplicates.
  * ikiwiki-transition: Add a deduplinks action, that can be used
    to remove duplicate links and optimise a wiki w/o rebuilding it.
  * external: Fix pagespec_match and pagespec_match_list.
    Closes: #527281

 -- Joey Hess <joeyh@debian.org>  Wed, 06 May 2009 00:31:16 -0400

ikiwiki (3.11) unstable; urgency=low

  * Avoid using python-support. Closes: #525086
  * websetup: Display stderr in browser if ikiwiki setup fails.
  * blogspam: Load RPC::XML library in checkconfig, so that an
    error can be printed at that point if it's not available,
    allowing the admin to see it during wiki setup.
    Closes: #520015
  * websetup: If setup fails, restore old setup file.
  * relativedate: Deal with clock skew.
  * Add IkiWiki::ErrorReason objects, and modify pagespecs to return
    them in cases where they fail to match due to a configuration or syntax
    error.
  * pagespec_match_list: New API function, matches pages in a list
    and throws an error if the pagespec is bad.
  * inline, brokenlinks, calendar, linkmap, map, orphans, pagecount,
    pagestate, postsparkline: Display a handy error message if the pagespec
    is erronious.
  * comments: Add link to comment post form to allow user to sign in
    if they wish to, if the configuration makes signin optional
    for commenting.
  * Updated Danish translation from Jonas Smedegaard. Closes: #525751
  * translation.mdwn: Typo fixes. Closes: #525753

 -- Joey Hess <joeyh@debian.org>  Mon, 04 May 2009 15:45:10 -0400

ikiwiki (3.10) unstable; urgency=low

  * darcs: Finally added support for this VCS, thanks to many
    contributors:
    - Thomas Schwinge wrote the original file, implementing only rcs_commit.
    - Benjamin A'Lee contributed an alternative implementation.
    - Tuomo Valkonen contributed rcs_getctime and stub rcs_recentchanges.
    - Simon Michael contributed multiple changes.
    - Petr Ročkai fixed rcs_recentchanges.
    - Sven M. Hallberg merged the above and added missing features.
  * Add missing newline to Confirm Password prompt.
  * Add missing permalink support to archivepage and titlepage templates.
  * debian/control: Wrap fields.
  * inline: Add author info to archive display.
  * Add a microblog template that is useful for inlining microblogging posts.

 -- Joey Hess <joeyh@debian.org>  Sat, 18 Apr 2009 19:40:25 -0400

ikiwiki (3.09) unstable; urgency=low

  * inline: Add title_natural sort order, using Sort::Naturally
    (chrysn)
  * inline: Fix urls to feed when feedfile is used on an index page.
  * git, mercurial: Fix --getctime to return file creation time,
    not last commit time.
  * Updated French translation (Jean-Luc Coulon). Closes: #521072
  * css: Add clear: both to inlinefooter.
  * comments: Fix too loose test for comments pages that matched
    normal pages with "comment_" in their name. Closes: #521322
  * comments: Fix anchor ids to be legal xhtml. Closes: #521339
  * Fix documentation of anonok_pagespec. Closes: #521793
  * Add missing suggests on libtext-textile-perl. Closes: #522039
  * recentchanges: change to using do=goto links for user links.
  * Fix git test suite to use a bare repo.

 -- Joey Hess <joeyh@debian.org>  Sat, 04 Apr 2009 14:33:49 -0400

ikiwiki (3.08) unstable; urgency=low

  * git: Fix utf-8 encoding of author names.
  * git: Manually decode git output from utf-8, avoids
    warning messages on invalidly encoded output.
  * Fix bug that caused weird things to appear as page types.

 -- Joey Hess <joeyh@debian.org>  Sun, 15 Mar 2009 17:54:47 -0400

ikiwiki (3.07) unstable; urgency=low
 
  * Updated German translation (Kai Wasserbäch). Closes: #518377
  * Updated French translation (Jean-Luc Coulon). Closes: #518510
  * wmd: New plugin contributed by William Uther to support the WMD
    Wysiwym markdown editor.
  * smiley: Avoid infinite loop in smiley expansion triggered
    by the template scan mode change in version 3.05. Closes: #518805
  * template: When loading a template in scan mode, let preprocess
    know it only needs to scan.

 -- Joey Hess <joeyh@debian.org>  Sun, 08 Mar 2009 19:00:46 -0400

ikiwiki (3.06) unstable; urgency=low

  * Setup automator: Fix bug in password comparison. Closes: #517654

 -- Joey Hess <joeyh@debian.org>  Sun, 01 Mar 2009 15:02:30 -0500

ikiwiki (3.05) unstable; urgency=low

  * debhelper v7(.0.50); rules file minimisation.
  * template: Load templates in scan mode.
    This is potentially expensive, but is necessary so that meta and tag
    directives, and other links on templates affect the page using the
    template reliably.
  * goto: Fix redirect to comments.
  * Add noextension parameter to htmlize hooks to support, eg, Makefile.
  * Add tagged() PageSpec.
  * Updated German translation (Kai Wasserbäch). Closes: #516770
  * Setup automator: Prompt for password twice. Closes: #516973
  * bzr: Add missing rcs_diff. (liw)
  * comments: Avoid showing comment moderation button in prefs to non-admins.
  * goto: Fix typo that broke recentchanges_link compatibility.

 -- Joey Hess <joeyh@debian.org>  Fri, 27 Feb 2009 15:48:39 -0500

ikiwiki (3.04) unstable; urgency=low

  * 404: New plugin which lets you use the IkiWiki CGI script as
    an Apache 404 handler, to give the behaviour of various other wiki
    engines where visiting a nonexistent page provides you with a link
    to create it. (smcv)
  * Factor out redundant code into goto plugin. (smcv)
  * Work around XML::Atom strangeness that results in double-encoded posts.
    (smcv) 
  * Fix unusual --setup --post-commit command line option combo.
  * Create any missing directory necessary to put the wrapper
    file into. Closes: #514384
  * shortcut: If default_pageext is set, first look for
    shortcuts.default_pageext.
  * Allow comments, rename, remove, and attachment plugins to be used
    even if the editpage plugin is disabled.

 -- Joey Hess <joeyh@debian.org>  Sat, 14 Feb 2009 02:27:14 -0500

ikiwiki (3.03) unstable; urgency=low

  * Avoid feeding decoded unicode to Term::ReadLine. Closes: 512169
  * blogspam: Log spam info on failure in debug mode.
  * Remove nonstandard css. Closes: #512378
  * blogspam: Fix use of blogspam_options and blogspam_server config settings.
  * comments: If comment content checks fail, store the comment
    (in .ikiwiki/comments_pending) for moderator review.
  * comments: Add a moderation web interface, which admins can
    access via their Preferences page.
  * git: Fix malformed utf8 received from git.
  * meta: New "updated" metadata specifies a fake modification time for a
    page, to be output into RSS and Atom feeds. (smcv)
  * underlay: New plugin, allows pulling in additional files not
    in version control. (smcv) 

 -- Joey Hess <joeyh@debian.org>  Thu, 29 Jan 2009 14:36:58 -0500

ikiwiki (3.02) unstable; urgency=low

  * blogspam: New plugin, adding spam filtering for page editing / comment
    posting using the BlogSpam.net API.
  * Add auto-blog.setup, which will set up an ikiwiki instance tuned for use
    in blogging.
  * checkcontent: New hook, can be used to implement arbitrary content
    filters, including spam filters.
  * table: Fix misparsed links in external files.
  * table: Find links in external files in scan pass.
  * rename: Show full names of affected pages.
  * comments: Fix cache avoidance hack.
  * repolist: New plugin to support the rel=vcs-* microformat.
  * goodstuff: Include repolist by default. (But it does nothing until
    configured with the repository locations.)
  * comments: Add support for removing comments via web interface. (smcv)
  * Consistently allow use of relative paths in all PageSpecs
    that take a page name parameter. Previously, match_created_before(),
    match_created_after(), match_sourcepage(), and match_destpage()
    did not support that, and the docs were not clear.
  * pinger: Get whole url, don't just head, avoids problems on
    the nostromo web server.
  * Recommend libterm-readline-gnu-perl since that makes auto.setup
    behave better.

 -- Joey Hess <joeyh@debian.org>  Sat, 17 Jan 2009 18:19:39 -0500

ikiwiki (3.01) unstable; urgency=low

  * ikiwiki-makerepo: Fix injecting of empty mercurial and bzr repositories.
    Closes: #510518
  * Fix documentation about git hook to use right name. Closes: #510393
  * yesno: Always accept English even when localised.
  * yesno: Also accept 1 and 0 as input.
  * A recent change to gitweb removed support for the form of diffurl 
    that many ikiwiki setups use. Document how to use the new url form.

 -- Joey Hess <joeyh@debian.org>  Mon, 05 Jan 2009 18:53:50 -0500

ikiwiki (3.00) unstable; urgency=low

  * Remove support for GlobLists.
  * Remove support for configuring allowed attachments, locked pages,
    and banned users from the admin preferences page. These can only be
    controlled via the setup file now.
  * ikiwiki-transition moveprefs can be used to move the above
    admin preferences into a setup file.
  * prefix_directives and aggregate_internal are now turned on by default.
  * ikiwiki-transition prefix_directives syntax changed
  * googlecalendar: removed this deprecated plugin. Use htmlscrubber_skip
    instead.
  * embed: This plugin is deprecated, use htmlscrubber_skip instead.
    Closes: ##462970.
  * Version 3.00 of the plugin API.
  * Replace blank OpenID placeholder logo with an unofficial OpenID
    logo developed by Anna Hess. The official logo does not seem destined to
    be free.
  * comments: Add cache avoidance.
  * htmlbalance: Demand-load HTML::TreeBuilder to avoid failing test suite
    if it is not present.
  * French translation update from Philippe Batailler. Closes: #510216
  * websetup: Avoid a crash when a new array setup item has been added in 
    a new ikiwiki release, and is thus not present in the setup file yet.

 -- Joey Hess <joeyh@debian.org>  Wed, 31 Dec 2008 15:17:47 -0500

ikiwiki (2.72) unstable; urgency=low

  * Avoid comments in recentchanges being broken links (smcv)
  * Add deprecation warning for GlobLists, which will stop working in 3.0.
  * camelcase: Add camelcase_ignore setting.
  * googlecalendar: Add runtime deprecation warning.
  * comments: Deal with users entering unqualified or partial urls.
  * inline: Run format hook first, to ensure other format hooks can affect
    inlined content.  Closes: #509710

 -- Joey Hess <joeyh@debian.org>  Sun, 28 Dec 2008 15:01:02 -0500

ikiwiki (2.71) unstable; urgency=low

  * comments: Blog-style comment support, contributed by Simon McVittie.
  * htmlbalance: New plugin contributed by Simon McVittie.
  * Change deb dependencies to list Text::Markdown before markdown (really
    this time).
  * Improve escaping of wikilinks and preprocessor directives in content
    produced by aggregate and recentchanges.
  * French translation update from Philippe Batailler. Closes: #506250
  * Spanish translation update from Victor Moral.
  * Fix handling of wrappergroup option.
  * Correct --dumpsetup to include the srcdir in the setup file.
  * German translation update from Kai Wasserbäch. Closes: #507056
  * inline: Support emptyfeeds=no option to skip generating empty feeds.
  * inline: Support feedfile option to change the filename of the feed
    generated.
  * meta: Pass info to htmlscrubber so htmlscrubber_skip can take effect.
  * htmlbalance: don't compact whitespace, and set misc other options (smcv)
  * rename: Fix double-escaping of page name in edit box.
  * monotone: When getting the log, tell monotone how many entries
    we want, rather than closing the pipe, which it dislikes. (thm)
  * Coding style change: Remove explcit vim folding markers.
  * aggregate: If a feed fails to be downloaded, try again immediatly
    next time aggregation is run, even if the usual time has not passed.
    Closes: #508622 (Michael Gold)
  * meta: Process meta date during scan pass so that the date will always
    affect sorting in inlines.
  * Improve display of some openids (smcv)

 -- Joey Hess <joeyh@debian.org>  Sun, 21 Dec 2008 16:22:05 -0500

ikiwiki (2.70) unstable; urgency=low

  * Avoid crash on malformed utf-8 discovered by intrigeri.

 -- Joey Hess <joeyh@debian.org>  Wed, 12 Nov 2008 17:45:58 -0500

ikiwiki (2.69) unstable; urgency=low

  * Avoid multiple ikiwiki cgi processes piling up, eating all memory,
    and thrashing, by making the cgi wrapper wait on a cgilock.
    If you had to set apache's MaxClients low to avoid ikiwiki thrashing your
    server, you can now turn it up to a high value.
  * Stop busy-waiting in lockwiki, as this could delay ikiwiki from waking up
    for up to one second. The bailout code is no longer needed after above
    change.
  * Remove support for unused optional wait parameter from lockwiki.
  * aggregate: Try to query XML::Feed for the base url when derelevatising
    links. Since this needs the just released XML::Feed 0.3, as well 
    as a not yet released XML::RSS, it will fall back to the old method
    if no xml:base info is available.
  * meta: Plugin is now enabled by default since the basewiki uses it.
  * txt: Do not encode quotes when filtering the txt, as that broke
    later parsing of any directives on the page.
  * Fix the link() pagespec to match links that are internally recorded as
    absolute.
  * Add rel=nofollow to recentchanges_links for the same (weak) reasons it
    was earlier added to edit links.
  * tag: Normalize tagbase so leading/trailing slashes in it don't break
    things.
  * bzr: Fix dates for recentchanges.

 -- Joey Hess <joeyh@debian.org>  Tue, 11 Nov 2008 20:35:55 -0500

ikiwiki (2.68) unstable; urgency=low

  * Add support for checking pushes from untrusted git committers. This can be
    used to set up anonymous git pushes, and other similar things.
  * format: New plugin, allows embedding differently formatted text inside a
    page (ie, otl inside a mdwn page, or syntax highlighted code inside a
    page).
  * relativedate: New javascript-alicious plugin that makes all dates display
    relative, in a very nice way, if I say so myself.
  * Optimise the no-op post-commit hook, to speed up web edits by a fraction
    of a second.
  * git: Allow [[sha1_commit]] to be used in the diffurl, to support cgit.
  * shortcut: Fix display of shortcuts while previewing.
  * Plugins that used to override displaytime should instead override
    formattime. displaytime will call that, and may wrap markup around the
    formatted time.
  * Add an underlay for javascript, and add ikiwiki.js containing some utility
    code.
  * toggle: Stop embedding the full toggle code on each page using it, and
    move it to toggle.js in the javascript underlay.
  * recentchanges: Make feed links point back to anchors on the recentchanges
    page. (JasonBlevins)
  * Fix issue with utf-8 in wikiname breaking session cookies, by
    entity-encoding the wikiname in the session cookie.
  * Use the pure perl Data::Dumper when generating setup files to ensure that
    utf-8 characters are written out as such, and not as the encoded perl
    strings the C Data::Dumper produces.
  * inline: Only the last feed link was put on the page, fix this to include
    all feed links. So rss will be included along with atom, and pages with
    multiple feeds will get links added for all feeds.
  * tag: When tagbase is set, force the links created by tagging to point at
    the toplevel tagbase, and not closer subpages. The html links already went
    there, but internally the links were not recorded as absolute, which could
    cause confusing backlinks etc.
  * Add an inject function, that can be used by plugins that want to
    replace one of ikiwiki's functions with their own version.
    (This is a scary thing that grubs through the symbol table, and replaces
    all exported occurances of a function with the injected version.)
  * external: RPC functions can be injected to replace exported functions.
  * Updated French translation. Closes: #502694
  * Updated Spanish translation from the ever vigilant Victor Moral.
  * Updated Danish translation from Jonas Smedegaard. Closes: #503117
  * Preserve syslog setting when doing `ikiwiki -setup foo -dumpsetup bar`
  * Several fixes to --render mode.

 -- Joey Hess <joeyh@debian.org>  Mon, 03 Nov 2008 16:31:11 -0500

ikiwiki (2.67) unstable; urgency=low

  * remove: Avoid $_ breakage. (Stupid, stupid perl.)
  * Updated Spanish translation from Victor Moral.
  * lockedit: Support specifying which users (and IP addresses) a page
    is locked for. This supports most of the ACL type things users have been
    wanting to be done. Closes: #443346 (It does not control who can read a
    page, but that's out of scope for ikiwiki.)
  * orphans: Fix unquoted page name in regexp.
  * google: Plugin provides google site search, contributed by Peter Simons.
  * Pass HTTPS variable through the wrapper so that CGI->https can be used
    by plugins. Closes: #502047
  * inline: Allow MTIME to be used in inlinepage.tmpl.
  * inline: Use the feed's description in the rss and atom links.
    Closes: #502113
  * aggregate: Avoid bug that caused immediate expiration of items
    with a date in the future.

 -- Joey Hess <joeyh@debian.org>  Fri, 17 Oct 2008 13:13:41 -0400

ikiwiki (2.66) unstable; urgency=low

  * recentchanges: Fix redirects to non-page files. 
  * aggregate: Avoid uninitialized value warnings for pages with no recorded
    ctime.
  * attachment: Add admin() pagespec to test if the uploading user is a wiki
    admin.
  * git: Fix handling of utf-8 filenames in recentchanges.
  * tag: Make edit link for new tags ensure that the tags are created
    inside tagbase, when it's set.
  * template: Make edit link for new templates ensure the page is located
    under toplevel templates directory.
  * htmlscrubber: Add a config setting that can be used to disable the
    scrubber acting on a set of pages.
  * Expand usage message and add --help. Closes: #500344
  * Beautify urls used in various places. (smcv)
  * Export pagetitle, titlepage, linkpage.
  * htmltidy: Avoid returning undef if tidy fails. Also avoid returning the
    untidied content if tidy crashes. In either case, it seems best to tidy
    the content to nothing.
  * htmltidy: Avoid spewing tidy errors to stderr.
  * Reorganize index file, add a format version field. Upgrades to the new
    index format should be transparent.
  * Add %wikistate, which is like %pagestate except not specific to a given
    page, and is preserved across rebuilds.
  * editpage: Be more aggressive (and less buggy) about cleaning up
    temporary files rendered during page preview.
  * Add an indexpages option, which causes foo/index.mdwn to be the source
    for page foo when foo.mdwn doesn't exist. Also, when it's enabled,
    creating a new page will save it to foo/index.mdwn by default.
    Closes: #474611
    (Sponsored by The TOVA Company.)
  * httpauth: Document that ikiwiki.cgi has to be in a directory subject to
    authentication. Closes: #500524 
  * inline: Fix handling of rootpage that doesn't exist.
  * attachment: Support adding attachments to pages even as they are being
    created.
  * remove, rename: Allow acting on attachments as a page is being created.
  * Updated French translation. Closes: #500929

 -- Joey Hess <joeyh@debian.org>  Sun, 05 Oct 2008 19:11:08 -0400

ikiwiki (2.65) unstable; urgency=low

  * aggregate: Expire excess or old items on the same pass that adds them,
    not only on subsequent passes.
  * editdiff: Broken since 2.62 due to wrong syntax, now fixed.
  * aggregate: Support atom feeds with only a summary element, and no content
    elements.
  * progress: Display an error if the progress cannot be parsed, and allow
    the percent parameter to only optionally end with "%".
  * Fix reversion in use of ikiwiki -verbose -setup with a setup file that
    enables syslog. Setup output is once again output to stdout in this
    case.
  * edittemplate: Default new page file type to the same type as the template.
    (willu)
  * edittemplate: Add "silent" parameter. (Willu)
  * edittemplate: Link to template, to allow creating it. (Willu)
  * editpage: Add a missing check that the page name contains only legal
    characters, in addition to the existing check for pruned filenames.
  * Print a debug message if a page has multiple source files.
  * Add keepextension parameter to htmlize hook. (Willu)
  * rename, remove: Don't rely on a form parameter to tell whether the page
    should be treated as an attachment.
  * rename: Add support for moving SubPages of a page when renaming it.
    (Sponsored by The TOVA Company.)
  * rename: Hide type field from rename form when renaming attachments.

 -- Joey Hess <joeyh@debian.org>  Wed, 24 Sep 2008 17:55:14 -0400

ikiwiki (2.64) unstable; urgency=low

  * Avoid uninitialised value when --dumpsetup is used and no srcdir/destdir
    specified.
  * ddate: Stop clobbering timeformat when not enabled.
  * progress: New plugin to generate progress bars (willu)
  * Add allow_symlinks_before_srcdir to config so websetup doesn't eat it.
  * img: Support sizes like 200x. Closes: #475149
  * goodstuff: Remove otl plugin from the bundle since it needs a significant
    external dependency and is not commonly used. If you use otl, make sure
    you explicitly enable it now.
  * goodstuff: Add more, progress, and table plugins to the bundle.
  * Improve error message if external plugin fails to load. Closes: #498458
  * Directive documentation broken out of the plugin documentation and into 
    pages suitable to be used as an underlay. Thanks to Willu for doing most
    of the tedious work.
  * Move the directive documentation into its own underlay, separate from
    basewiki, since it's sorta large compared to the rest of basewiki.
  * listdirectives: Enable use of the directives underlay.
  * Removed the obsolete blog page from the basewiki. ikiwiki/blog still
    remains, but is now deprecated too.
  * Removed old redirecton pages from basewiki (helponformatting,
    markdown, openid, pagespec, preprocessordirective, subpage, wikilink).
  * inline: Treat rootpage as a link, so that it can refer to a subpage
    without hardcoding the path.

 -- Joey Hess <joeyh@debian.org>  Sun, 14 Sep 2008 16:58:25 -0400

ikiwiki (2.63) unstable; urgency=low

  * Set cookies HttpOnly.
  * Typo. Closes: #497003
  * Ignore failure to install files into /etc, in case install is running as
    non-root.
  * Work around perl $_ scoping nonsense that caused breakage when loading
    external plugins.
  * style.css: Add missing semicolon. Closes: #497176 
  * filecheck: Fall back to testing for binary or plain text files
    if no mime type is detected.
  * table: Support header=column to make the table header be the first
    column of the data. (AlexandreDupas)
  * For fine control over what characters are allowed, unescaped in
    source filenames, the wiki_file_chars setting is added. For example,
    set to "-[:alnum:]+/._" to disable colons from being used in source files
    (which can cause troubl om Windows).
  * po/Makefile: update po files when the pot file has changed.
    Closes: #497951
  * editpage: New core plugin factoring out page editing to allow disabling it
    if desired.

 -- Joey Hess <joeyh@debian.org>  Mon, 08 Sep 2008 12:17:15 -0400

ikiwiki (2.62.1) unstable; urgency=low

  * filecheck: Fixed two bits broken in move from attachment.

 -- Joey Hess <joeyh@debian.org>  Thu, 28 Aug 2008 13:04:47 -0400

ikiwiki (2.62) unstable; urgency=low

  * Avoid using cp -a (again). (HenrikBrixAndersen)
  * Avoid using hostname -f for portability to eg, OS X, use Net::Domain
    instead, and prompt if it fails.
  * Fix bug in wikiname sanitisation in the setup automator.
  * ikiwiki-makerepo: Added support for monotone. (Thomas Keller)
  * map: The fix for #449285 was buggy and broke display of parents in certain
    circumstances.
  * teximg: The prefix is configurable, and has changed to not include the
    nonstandard mhchem by default. (willu)
  * teximg: dvipng is used if available to render images. Its output is
    antialiased and better than dvips. If not available, the old dvips+convert
    chain will be used. (willu)
  * Drop suggests on texlive-science, add suggests on dvipng.
  * listdirectives: New plugin. (willu)
  * filecheck: New plugin factoring out the PageSpec additions that were
    originally part of the attachment plugin.
  * edittemplate: Don't wipe out edits on preview.
  * color: New plugin from ptecza.
  * autoindex: Avoid re-adding previously deleted (or renamed) pages.

 -- Joey Hess <joeyh@debian.org>  Wed, 27 Aug 2008 15:14:09 -0400

ikiwiki (2.61) unstable; urgency=low

  * poll: Fix typo that broke plugin.
  * graphviz: Fix breakage of the name of the preprocessor directive.

 -- Joey Hess <joeyh@debian.org>  Thu, 14 Aug 2008 18:13:22 -0400

ikiwiki (2.60) unstable; urgency=low
 
  [ Joey Hess ]
  * Starting with this version, "ikiwiki -setup /etc/ikiwiki/auto.setup"
    can be used create a new wiki in seconds.
  * websetup: New plugin providing a setup form on the web.
  * ikiwiki --dumpsetup can generate a nice setup file snapshotting ikiwiki's
    current configuration.
  * The way wrappers are defined in the setup file has changed. Old setup
    files will continue to work, for now.
  * ikiwiki-transition setupformat can be used to convert a setup file to the
    new format.
  * Version control backends promoted to first-class plugins.
  * ikiwiki-update-wikilist: Add -r switch to remove. Default behavior is now
    always to add.
  * Start moving admin preferences from the web interface to the setup file.
  * Add getsetup hook, all plugins should use it to record information about
    themselves and any fields they add to %config
  * Large amounts of internal config data reorg.
  * ikiwiki-makerepo: Bail if both srcdir and repository are not specified.
    Closes: #493628
  * Clarify some wording in the setup documentation that could maybe lead
    users to putting paths with "~/" in the setup file, which doesn't work.
    Closes: #493835
  * autoindex: Ignore internal pages, and take underlay directories into
    account. Also, avoid making index pages for directories that contain
    no files.
  * external: Fix support for hooks called in an array context.
  * Options set in the setup file are now immediatly loaded by ikiwiki -setup.
    This allows later switches to override them. Previously, setup file
    options overrode most command line options.
  * Added a small icon to the search input box.

  [ Josh Triplett ]
  * Add Suggests on texlive and texlive-science for the teximg plugin

  [ Joey Hess ]
  * inline: Ignore parent dirs when sorting pages by title.
  * rename: Support changing page extensions. (willu)
  * Danish update. Closes: #494632

 -- Joey Hess <joeyh@debian.org>  Tue, 12 Aug 2008 14:20:25 -0400

ikiwiki (2.56) unstable; urgency=low

  * autoindex: New plugin that generates missing index pages.
    (Sponsored by The TOVA Company.)
  * Escape HTML is rss and atom feeds instead of respectively using CDATA and
    treating it as XHTML. This avoids problems with escaping the end of the
    CDATA when the htmlscrubber is not used, and it avoids problems with atom
    XHTML using named entity references that are not in the atom DTD.
    (Simon McVittie)
  * Add test for old versions of git that don't support --cleanup=verbatim,
    and munge empty commit messages.

 -- Joey Hess <joeyh@debian.org>  Thu, 31 Jul 2008 19:25:24 -0400

ikiwiki (2.55) unstable; urgency=low

  * remove: New plugin that adds the ability to remove pages via the web.
    (Sponsored by The TOVA Company.)
  * rename: New plugin that adds the ability to rename pages via the web.
    (Sponsored by The TOVA Company.) (This one's for you, Kyle.)
  * All rcs backends need to implement rcs_remove, rcs_commitstaged,
    and rcs_rename. (Done for svn, git).
  * This version adds renamepage hooks, which can be used to modify page
    content, including links, during renames.
  * prefix_directives enabled in doc wiki, all preprocessor directives
    converted. (Simon McVittie)
  * editpage: Don't show attachments link when attachments are disabled.
  * tag: Allow tagbase to be overridden by starting a tag with "./" or "/".
    (Simon McVittie)
  * Really fix bug with links to pages with names containing colons. 
    Previous fix mised a few cases.
  * Avoid troublesome abs_path calls in wrapper setup.
  * Add allow_symlinks_before_srcdir config setting that can be used to avoid
    a security check that is a good safe default, but problimatic overkill in
    some situations.
  * Don't allow uploading an attachment with the same name as an existing
    page, to avoid confusion.
  * Split out error messages from editpage.tmpl into several separate
    templates.
  * attachment: Do not escape _ when determining attachment filenames.
  * Rebuild pages that change their type. (Gabriel McManus)
  * monotone: Add support for rename, delete, and also diff. (William Uther)
  * toggle: Fix incompatibility between javascript and webkit.
  * bzr: Add support for rename and delete. (Jelmer Vernooij)
  * attachment: Use relative paths when inserting links.
  * toggle: Fix for when html got tidied. Closes: #492529 (Enrico Zini)
  * cutpaste: New plugin by Enrico Zini

 -- Joey Hess <joeyh@debian.org>  Sun, 27 Jul 2008 11:23:13 -0400

ikiwiki (2.54) unstable; urgency=low

  [ Joey Hess ]
  * Make it possible to load setup files w/o running them. Code
    needing to do so can call IkiWiki::Setup::load, which will return
    a hash of values.

  [ Josh Triplett ]
  * ikiwiki-transition: Fix command-line processing so the prefix_directives
    transition works again.

  [ Joey Hess ]
  * template: Add support for a BASENAME variable.
  * Fixes creation of pages when clicking on WikiLinks starting with "/".
  * Change deb dependencies to list Text::Markdown before markdown, since
    the former, while slower, has a much better html parser that avoids
    numerous bugs.
  * Move yesno function out of inline and into IkiWiki core, not exported.
  * Error handling improvement for preprocess hooks. It's now safe to call
    error() from such hooks; it will cause a nicely formatted error message
    to be inserted into the page.
  * Cut the size of the binary package in half by excluding pages for bugs
    and todo items from the html shipped in it.
  * parentlinks: New plugin, split out of ikiwiki core and enabled by default,
    and several new fields added to allow for advanced styling. (intrigeri)
  * smileys: Some fixes for escaped smileys.
  * smileys: Note that smileys need to be double-escaped for the escaping to
    work. Markdown removes one level of escaping.
  * Add a postscan hook.
  * search: Use postscan hook, avoid updating index when previewing.
  * git: Put web committer name/openid/address in the git author field.
    The committer's email address is not used (because leaking email addresses
    is not liked by many users). Closes: #451023
  * git: Fix parsing of git logs with no commit messages at all.
  * search: Fixes for title stemming, and use better term for tags.
    (Gabriel McManus)
    (Rebuilding the wiki on upgrade to this version is recommended if you
    use the search plugin.)

  [ Simon McVittie ]
  * meta, inline: Support guid options, to allow forcing a particular url or
    uuid in feeds.
  * meta: fix title() PageSpec
  * Some footer style changes.
  * aggregate: Add an `aggregateinternal` option, which allows storing
    aggregated data to internal-use files, rather than wiki pages. This
    can save disk space, and be faster.
  * ikiwiki-transition: Add a `aggregateinternal` transition to rename
    the aggregated files.

 -- Joey Hess <joeyh@debian.org>  Mon, 21 Jul 2008 10:10:52 -0400

ikiwiki (2.53) unstable; urgency=low

  * search: generate configuration files once only when rebuilding
    (Gabriel McManus)
  * attachment: Fix an uninitialised value warning when editing a page
    that currently has no attachments.
  * Fix a bug with links to pages whose names contained colons.
  * attachment: Support old versions of CGI.pm that lack an upload method.
  * Include ikiwiki.setup in examples in the debian package.
  * attachment: Support perl 5.8's buggy version of CGI.pm.
  * otl: Support utf-8 files. (Recai Oktaş)

 -- Joey Hess <joeyh@debian.org>  Wed, 09 Jul 2008 16:45:33 -0400

ikiwiki (2.52) unstable; urgency=low

  * attachment: New plugin for uploading and managing attachments.
    This includes a fairly powerful PageSpec based admin pref for deciding
    whether to accept a given upload, and an attachment management interface
    on the edit page.
    (Sponsored by The TOVA Company.)
  * If attachments are not enabled, configure CGI.pm to disable file
    uploads by default. (An anti-DOS measure.)
  * toggle: Add support for toggles that are open by default.
  * toggle: Fix to work in preview mode.
  * toggle: Add javascript to top of page, not to end. This avoids flicker
    since closed toggles will not be displayed as the page is loading.
  * The editpage form now uses the raw page name, not the page title, in its
    'page' cgi parameter. Using the title was ambiguous and made it
    impossible to tell between some pages, like "foo/bar" and "foo__47__bar",
    sometimes causing the wrong page to be edited.
  * This change means that some edit links need to be updated.
    Force a rebuild on upgrade to this version.
  * Above change also allowed really fixing escaped slashes from the blogpost
    form.

 -- Joey Hess <joeyh@debian.org>  Sun, 06 Jul 2008 19:15:37 -0400

ikiwiki (2.51) unstable; urgency=low

  * Improve toplevel parentlink to link directly to index.html when usedirs is
    disabled.
  * map: Add a "show" parameter. "show=title" can be used to display page
    titles, rather than the default page name. Based on a patch from 
    Jaldhar H. Vyas, Closes: #484510
  * hnb: New plugin, contributed by Axel Beckert.
  * meta: Store "description" in pagestate for use by other plugins.
  * map: Support show=description.
  * textile: The Text::Textile perl module has some regexps that fail if
    input is flagged as utf-8, but contains invalid characters such as 0x92.
    To prevent it from crashing, re-encode the content before calling it,
    which will ensure that it's really utf-8.
  * Version the suggests of xapian-omega to a version known to be new enough
    to work with ikiwiki. Reportedly, version 0.9.9 is too old to work.
    Closes: #486592
  * creole: New plugin from Bernd Zeimetz. Closes: #486930
  * aggregate: Add template parameter.
  * Add support for the universal edit button <http://universaleditbutton.org/>
    (To get this on all pages of an exiting wiki, rebuild the wiki.)
  * txt: New plugin, contributed by Gabriel McManus.
  * smiley: Generate links relative to the destpage. (Fixes a reversion from
    2.41.)
  * toc: Revert change in 2.45 that made it run at sanitize time. That broke
    use of toc in a sidebar.
  * Call format hooks when generating page previews, thus fixing toc display
    there, as well as fixing inlins to again display in page previews, since
    it's started using format hooks. This also allows several other things,
    like embed, that use format hooks, to work during page preview time.
  * Format hooks should not rely on getting an entire html document, as they
    will only get the body during page preview.
  * toggle: Deal with preview mode when adding javascript.

 -- Joey Hess <joeyh@debian.org>  Sun, 29 Jun 2008 14:09:37 -0400

ikiwiki (2.50) unstable; urgency=low

  * img: Support captions.
  * img: Don't generate empty title attributes, etc.
  * img: Allow setting defaults for class and id too.
  * ikiwiki-mass-rebuild: Make group list comparison more robust.
  * search: Work around xapian bug #486138 by only stemming locales
    in a whitelist.

 -- Joey Hess <joeyh@debian.org>  Fri, 13 Jun 2008 15:17:30 -0400

ikiwiki (2.49) unstable; urgency=low

  * haiku: Generate valid xhtml.
  * ikiwiki-mass-rebuild: Don't trust $! when setting $)
  * inline: The optimisation in 2.41 broke nested inlines. Detect those
    and avoid overoptimising.
  * search: Converted to use xapian-omega.
  * Filter hooks are no longer called during the scan phase. This will
    prevent wikilinks added by filters from being scanned properly. But
    no known filter hook does that, so let's not waste time on it.
  * Pass a destpage parameter to the sanitize hook.
  * The search interface now allows searching for a page by title
    ("title:foo"), as well as for pages that contain a given link
    ("link:bar").

 -- Joey Hess <joeyh@debian.org>  Sat, 07 Jun 2008 15:22:41 -0400

ikiwiki (2.48) unstable; urgency=high

  * Fix security hole that occurred if openid and passwordauth were both
    enabled. passwordauth would allow logging in as a known openid, with an
    empty password. Closes: #483770 (CVE-2008-0169)
  * Add rel=nofollow to edit links. This may prevent some spiders from
    pounding on the cgi following edit links.
  * passwordauth: If Authen::Passphrase is installed, use it to store
    password hashes, crypted with Eksblowfish.
  * `ikiwiki-transition hashpassword /path/to/srcdir` can be used to
    hash existing plaintext passwords.
  * Passwords will no longer be mailed, but instead a password reset link.
  * The password_cost config setting is provided as a "more security" knob.
  * teximg: Fix logurl.
  * teximg: If the log isn't written, avoid ugly error messages.
  * Updated French translation. Closes: #478530

 -- Joey Hess <joeyh@debian.org>  Fri, 30 May 2008 17:36:07 -0400

ikiwiki (2.47) unstable; urgency=low

  * mdwn: Add a multimarkdown setup file option.
  * If PERL5LIB is set to the libdir when building ikiwiki, calculate and 
    hardcode a proper 'use lib' statement anyway. This fixes a gotcha,
    since PERL5LIB won't work once ikiwiki is running via a wrapper or as
    a cgi.
  * orphans: As a special case, the toplevel index page is never considered
    an orphaned page.
  * inline: Display a message if the 'pages' parameter is missing, before
    it just expanded to nothing.
  * git: Skip over signed-off-by and similar lines in commit messages
    when generating recentchanges.
  * ENV can be used in the setup file to override environment variable
    settings, such as TZ or PATH.
  * Perls older than 5.10 need to use the old method of decoding utf-8 in CGI
    values. Neither method will work for all versions of perl, so check
    version number at runtime.
  * Avoid unsightly warning message when evaling broken pagespecs.
  * Improve error message when a pagespec fails to parse.

 -- Joey Hess <joeyh@debian.org>  Sun, 25 May 2008 14:25:42 -0400

ikiwiki (2.46) unstable; urgency=low

  * amazon_s3: New plugin, which injects wiki pages into Amazon S3, allowing
    ikiwiki to be used without a dedicated web server.
  * aggregate: Add support for web-based triggering of aggregation 
    for people stuck on shared hosting without cron. (Sheesh.) Enabled
    via the `aggregate_webtrigger` configuration optiom.
  * Add pinger and pingee plugins, which allow setting up mirrors and branched
    wikis that automatically ping one another to stay up to date.
  * Optimised file statting code when scanning for modified pages;
    cut the number of system calls in half. (Still room for improvement.)
  * Fixes for behavior changes in perl 5.10's CGI that broke utf-8 support
    in several interesting ways.

 -- Joey Hess <joeyh@debian.org>  Mon, 12 May 2008 20:51:50 -0400

ikiwiki (2.45) unstable; urgency=low

  * toc: Add the table of contents at sanitize time, rather than at format
    time. This allows the toc to be displayed when previewing an edit. It also
    avoids headers in the page template from showing up in the toc.
  * Add PREFIX/bin to the hardcoded PATH within ikiwiki.
  * Deal with different paths to perl when removing -T flag.
  * Add missing de.po. Closes: #471540
  * img: Support a title attribute, will be passed through to html.
    Closes: #478718
  * anonk: Add anonok_pagespec configuration setting that can be used to
    allow anonymous users to edit only matching pages. Closes: #478892
  * Fix ugly display when editing a page that has vanished.
  * srcfile now has an optional second parameter to avoid it throwing an error
    if the source file does not exist.
  * git: Put -- before the filename when calling git rev-list to avoid
    warning message when the file doesn't exist.
  * Add a Bundle::IkiWiki and Bundle::IkiWiki::Extras to the source for use
    with CPAN to install perl modules.
  * Add a cpan directory containing a CPAN::MyConfig that can ease use of
    CPAN to install in a home directory on shared hosting providers.
  * With these changes, it's pretty easy to install onto nearlyfreespeech.net
    and probably other shared hosting providers like dreamhost. Added
    a page documenting the process for nearlyfreespeech.

 -- Joey Hess <joeyh@debian.org>  Mon, 05 May 2008 15:06:05 -0400

ikiwiki (2.44) unstable; urgency=medium

  * Bring back the svnrepo setup file option. This is needed for
    recentchangediff to work with svn repos.
  * Allow libtext-markdown-perl to satisfy dependencies, as a
    an alternative to the markdown package.
  * Correct a bug in pagespec matching, where a empty pagespec matched all
    pages. This manifested as wikis with no locked pages treating them all as
    locked. The bug was introduced in version 2.41.
  * Medium urgency upload due to above fix.

 -- Joey Hess <joeyh@debian.org>  Thu, 17 Apr 2008 14:33:54 -0400

ikiwiki (2.43) unstable; urgency=low

  * Fix missing import of escapeHTML in userlink. (Scott Bronson)
  * Fix broken rcs_update for bzr. (Scott Bronson)
  * Use bzr --quiet to avoid it outputting stuff and messing up http headers.
    (Scott Bronson)
  * Give the full path to the hyperestraier helpfile in estseek.conf.
  * Recommend a recent git-core for git init. Closes: 475609

 -- Joey Hess <joeyh@debian.org>  Wed, 16 Apr 2008 18:35:13 -0400

ikiwiki (2.42) unstable; urgency=high

  * aggregate: Correct a mistake in the code that dummy up a guid for feeds
    lacking one.
  * inline: Correct handling of urls relative to baseurl in feeds.
  * Fix CSRF attacks against the preferences and edit forms. The fix involved
    embedding the session id in the forms, and not allowing the forms to be
    submitted if the embedded id does not match the session id. Closes: #475445
    (CVE-2008-0165)

 -- Joey Hess <joeyh@debian.org>  Thu, 03 Apr 2008 02:35:39 -0400

ikiwiki (2.41) unstable; urgency=low

  [ Adeodato Simó ]
  * Preprocessor directives generated by the shortcut plugin accept a `desc`
    parameter that overrides the anchor text provided at shortcut definition
    time. (Closes: #458126)

  [ martin f. krafft ]
  * The meta plugin now allows for the robots tag to be specified without the
    risk of it being scrubbed.
  * Let meta.openid set X-XRDS-Location header
  * Make makerepo set the Git merge remote.
    branch.master.remote previously used to default to origin, which has
    recently been changed; it now needs to be set explicitly, which this
    patch does. Closes: #470517
  * meta: Also generate openid2 headers.
  * Handle SimpleXMLRPCDispatcher arg count change in python 2.5
  * Provide XML-RPC proxy abstraction for Python plugins.

  [ Joey Hess ]
  * Add recentchangesdiff plugin that adds diffs to the recentchanges feeds.
  * rcs_diff is a new function that rcs modules should implement.
  * Implemented rcs_diff for git, svn, and tla (tla version untested).
    Mercurial and monotone still todo.
  * Support Text::Markdown::markdown, which is the spelling used by 
    version 1.0.16 of Text::Markdown.
  * Updated Spanish translation from Victor Moral.
  * Fix example exclude regexp. Closes: #469691
  * Remove locking code in git rcs_commit. I'm not sure if this was ever
    correct, and it's certianly not correct now, since the wiki is locked
    before rcs_commit is ever called, and should not be unlocked by
    rcs_commit either.
  * monotone: Require version 0.38 or greater, and stop using the mtnmergerc
    option. (Brian May)
  * Use forcebaseurl to make page previews be displayed with the html base
    set to the destination page. This avoids need for hacks to munge the urls
    in preview mode, which fixes several bugs.
  * Several destpage fixes in plugins.
  * Use absolute url for feedurl when filling out the feed templates.
    Closes: #470530
  * Fix expiry of old recentchanges changeset pages.
  * French translation update. Closes: #471010
  * external: Fix support of XML::RPC::fault.
  * htmltidy: Pass --markup yes, in case tidy's config file disabled it.
  * external: Add getargv and setargv methods to allow access to ikiwiki's
    @ARGV.
  * Correct bug in encoding of %pagestate keys, fixes edittemplate.
  * Detect invalid pagespecs and do not merge them in add_depends,
    as that can result in a broken merged pagespec that matches nothing.
  * Record new pages in %pagesources temporarily when previewing so that
    things that need to know the page source or type can query it from there.
    Fixes previewing of tables when creating a new page.
  * German translation update. Closes: #471540
  * Time::Duration is no longer used, remove from docs and recommends.
  * Store userinfo in network byte order for easy portability.
    (Old files will be automatically converted.)
  * Close meta tag for redir properly.
  * smiley: Detect smileys inside pre and code tags, and do not expand.
  * inline: Crazy optimisation to work around slow markdown.
  * Precompile pagespecs, about 10% overall speedup.
  * Changed to a binary index file, written using Storable, for speed.
  * external: Work around XML RPC's lack of support for null by passing
    a special sentinal value.
  * inline: Allow the "feedshow" parameter to take values greater than the
    value for "show".
  * Added a hardlink option in the setup file, useful if the source and
    dest are on the same filesystem and the wiki includes large media files,
    which would normally be copied, wasting time and space.

 -- Joey Hess <joeyh@debian.org>  Sat, 29 Mar 2008 21:07:22 -0400

ikiwiki (2.40) unstable; urgency=low

  [ Josh Triplett ]
  * Add new preprocessor directive syntax¸ using a '!' prefix.  Add a
    prefix_directives option to the setup file to turn this syntax on;
    currently defaults to false, for backward compatibility.  Support
    optional '!' prefix even with prefix_directives off, and use that in
    the underlay to support either setting of prefix_directives.  Add NEWS
    entry with migration information.

  [ Joey Hess ]
  * Danish translation update from Jonas Smedegaard. Closes: #465152
  * Generate XML RPC messages with the encoding set to utf-8 instead
    of XML::RPC's default of us-ascii. Allows interoperation with
    python's xmlrpc library, which threw invalid encoding exceptions and
    caused the rst plugin to hang.
  * Add the linkify and scan hooks. These hooks can be used to implement
    custom, first-class types of wikilinks.
  * Move standard wikilink implementation to a new link plugin, which
    will of course be enabled by default.
  * camelcase: Convert to use new linkify and scan hooks rather than the old
    hack.
  * Setting NOTAINT=1 had no effect when building ikiwiki itself, fix this.
  * Depend on HTML::Scrubber, since the scrubber is enabled by default and
    dies if its can't be loaded.
  * The search plugin needs to override <base> to point to the directory
    containing ikiwiki.cgi, but this should not change the urls to the style
    sheets etc. Add a new forcebareurl parameter to misctemplate to allow
    it to do that.
  * Preview limits the page dropdown to what's selected previously
    (as preserving the full list across preview would be tricky). Userdirs
    were still being offered as an option there, remove them.
  * Fix a bug where user A created a page concurrently with user B, and
    when B previewed it would redirect B to A's new page, losing B's work.
    Instead, don't redirect and let conflict handling resolve it.
  * monotone: Add code to default mergerc file to run
    _MTN/ikiwiki-netsync-hook when a commit is merged in from the net.
  * tla: Remove call to escapeHTML when constructing recentchanges message;
    the html is escaped at a different level. Closes: #466495
  * bzr, mercurial: Remove unused import of escapeHTML.
  * Fix another preview will_render bug. This one involved inline,
    which forced a scan of the page to make available metadata that
    appeared after the inline directive. Problem is that scan made it forget
    about any other files rendered due to the page. The scan also turns out
    to be unnecessary now, since meta persistently stores state and it's
    always available. So it was just removed.
  * Disable taint checking for all builds as people keep complaining about it,
    and since all versions of perl seem to be hopelessly broken.
  * Fix links generated by preprocessor directives when previewing.
  * inline: When forcing urls absolute for rss feeds, skip mailto and other
    such urls.
  * ikiwiki-makerepo: Don't fail if the third argument ends in a slash.
  * Allow colons in URLs after the first slash. (Adeodato Simó)

 -- Joey Hess <joeyh@debian.org>  Fri, 29 Feb 2008 23:05:39 -0500

ikiwiki (2.31.3) unstable; urgency=high

  [ Josh Triplett ]
  * Do not allow the about: URI scheme; some browsers interpret about:
    URIs like a limited version of data: URIs.  In particular, some
    versions of Internet Explorer interpret arbitrary HTML content in
    about: URIs.
  * Also filter the attributes cite, longdesc, and usemap, which can contain
    URIs.

  [ Joey Hess ]
  * meta: Check that the urls provided for authorurl, permalink, and openid
    are safe and can't contain javascript.

  [ Josh Triplett ]
  * Match literal '.' in URI schemas containing '.', rather than matching any
    character.
  * Do not allow the steam: URI scheme.
  * Allow the snews: URI scheme.
  * Allow the smb: URI scheme.

 -- Josh Triplett <josh@freedesktop.org>  Sun, 10 Feb 2008 14:48:48 -0800

ikiwiki (2.31.2) unstable; urgency=high

  * The security fix in the last release had buggy handling of data:image,
    now fixed. Closes: #465110 (CVE-2008-0808, CVE-2008-0809)

 -- Joey Hess <joeyh@debian.org>  Sun, 10 Feb 2008 15:31:17 -0500

ikiwiki (2.31.1) unstable; urgency=low

  * htmlscrubber security fix: Block javascript in uris.
  * Add htmlscrubber test suite.
  * Thanks to Josh Triplett for pointing out the holes and for his help
    in implementing and checking fixes.

 -- Joey Hess <joeyh@debian.org>  Sun, 10 Feb 2008 13:22:59 -0500

ikiwiki (2.31) unstable; urgency=low

  [ Joey Hess ]
  * Revert preservation of input file modification times in output files,
    since this leads to too many problems with web caching, especially with
    inlined pages. Properly solving this would involve tracking every page
    that contributes to a page's content and using the youngest of them all,
    as well as special cases for things like the version plugin, and it's just
    too complex to do.
  * aggregate: Forking a child broke the one state that mattered: Forcing
    the aggregating page to be rebuilt. Fix this.
  * cgi hooks are now run before ikiwiki state is loaded.
  * This allows locking the wiki before loading state, which avoids some
    tricky locking code when saving a web edit.
  * poll: This plugin turns out to have edited pages w/o doing any locking.
    Oops. Convert it from a cgi to a sessioncgi hook, which will work
    much better.
  * recentchanges: Improve handling of links on the very static changes pages
    by thunking to the CGI, which can redirect to the page, or allow it to be
    created if it doesn't exist.
  * recentchanges: Exipre all *._change pages, even if the directory
    they're in has changed.
  * aggregate: Lots of changes; aggregation can now run without locking the
    wiki, and there is a separate aggregatelock to prevent multiple concurrent
    aggregation runs.
  * monotone changes by Brian May:
    - On commits, replace "mtn sync" bidirectional with "mtn push" single
      direction. No need to pull changes when doing a commit. mtn sync
      is still called in rcs_update.
    - Support for viewing differences via patches using viewmtn.
  * inline: When previewing, still call will_render on rss/atom files,
    just avoid actually writing the files. This is necessary because ikiwiki
    saves state after a preview (in case it actually *did* write files),
    and if will_render isn't called its security checks will get upset
    when the page is saved. Thanks to Edward Betts for his help tracking this
    tricky bug down.
  * inline: Add new `allowrss` and `allowatom` config options. These can be
    used if you want a wiki that doesn't default to generating rss or atom
    feeds, but that does allow them to be turned on for specific blogs.
  * Don't die if running with --getctime and rcs_getctime throws an error.
    There are several cases (recentchanges files, aggregated files)
    where some source files are not in revision control.
  * Page templates can now use CTIME to show when the page was created.

  [ Josh Triplett ]
  * README.Debian: Mention user wikilists.

 -- Joey Hess <joeyh@debian.org>  Sat, 09 Feb 2008 23:09:45 -0500

ikiwiki (2.30) unstable; urgency=low

  [ Joey Hess ]
  * Old versions of git-init don't support --git-dir or GIT_DIR with
    --bare. Change ikiwiki-makerepo to use a method that should work with
    those older versions too.
  * aggregate: Don't let feeds set creation times for pages in the future.
  * Add full parser for git diff-tree output (Brian Downing)
  * aggregate: Fork a child process to handle the aggregation. This simplifies
    the code, since that process can change internal state as needed, and
    it will automatically be cleaned up for the parent process, which proceeds
    to render the changes.

  [ Josh Triplett ]
  * Add trailing comma to commented-out umask in sample ikiwiki.setup, so
    that uncommenting it does not break the setup file.

  [ Joey Hess ]
  * inline: The template can check for FIRST and LAST, which will be
    set for the first and last inlined page. Useful for templates that build
    tables and the like.
  * prettydate,ddate: Don't ignore time formats passed to displaytime
    function.
  * Pages with extensions starting with "_" are internal-use, and will
    not be rendered or web-edited, or matched by normal pagespecs.
  * Add "internal()" pagespec that matches internal-use pages.
  * RecentChanges is now a static html page, that's updated whenever a commit
    is made to the wiki. It's built as a blog using inline, so it can have
    an rss feed that users can subscribe to.
  * Removed support for sending commit notification mails. Along with it went
    the svnrepo and notify settings, though both will be ignored if left in
    setup files. Also gone with it is the "user()" pagespec.
  * Add refresh hook.
  * meta: Add pagespec functions to match against title, author, authorurl,
    license, and copyright. This can be used to create custom RecentChanges.
  * meta: To support the pagespec functions, metadata about pages has to be
    retained as pagestate.
  * Fix encoding bug when pagestate values contained spaces.
  * Add support for bzr, written by Jelmer Vernooij. Thanks also to bma for
    his independent work on bzr support.
  * Copyright file updates.

 -- Joey Hess <joeyh@debian.org>  Sat, 02 Feb 2008 17:41:57 -0500

ikiwiki (2.20) unstable; urgency=low

  * inline: Add copyright/license info on a per-post basis to atom
    feeds if available. (rss doesn't allow such info on a per-post basis)
  * Also include overall copyright/license and author info in atom feeds if
    available.
  * meta: Allow copyright/license metadata to contain arbitrary markup.
  * Call preprocessor hooks in void context during the scan pass. This allows
    the hook to determine if it's just scanning, and avoid expensive
    operations.
  * img: Detect scan mode and avoid generating and writing the image file
    during it, for a 2x speedup.
  * meta: Run in scan mode again (more intelligently) and re-add support for
    meta link.
  * Fix support for the case where metadata appears after an inline directive
    that needs to use it. This was broken in version 2.16.
  * template: Remove bogus htmlize pass added in 2.16.
  * template: Htmlize template variables, but also provide a raw version
    via `<TMPL_VAR raw_variable>`.
  * When htmlizing text, if the input is a single line with no newline,
    and the htmlizer (such as markdown and textile) generates a html
    paragraph, remove it. This allows removing several hacks from other
    plugins that htmlize fragements of pages.
  * In preferences, allow the subscriptions and email fields to be cleared.
  * teximg: Fix to support the same formula on multiple pages.

 -- Joey Hess <joeyh@debian.org>  Thu, 10 Jan 2008 14:52:57 -0500

ikiwiki (2.19) unstable; urgency=low

  * Only try postsignin if no other action matched. Fixes a bug where the
    user goes back from the signin screen and does something else.
  * Improve behavior when trying to sign in with no cookies.
  * Improved the canedit hook interface, allowing a callback function to be
    returned (and not run in some cases) rather than the plugins directly
    forcing a user to log in.
  * opendiscussion: allow editing of the toplevel discussion page,
    and, indirectly, allow creating new discussion pages.
  * Add a prereq on Data::Dumper 2.11 or better, needed to dump q// objects.
  * htmlscrubber: Further work around #365971 by adding tags for 'br/', 'hr/'
    and 'p/'.
  * aggregate: Include copyright statements from rss feed as meta copyright
    directives.
  * aggregate: Yet another state saving fix (sigh).
  * aggregate: Add hack to support feeds with invalidly escaped html entities.

 -- Joey Hess <joeyh@debian.org>  Tue, 08 Jan 2008 20:43:18 -0500

ikiwiki (2.18) unstable; urgency=low

  * Split error messages for failures to drop real uid and gid.
  * Retry dropping uid and gid, possibly this will help with the "Resource
    temporarily unavailable" failures I've experienced under xen.
  * Stop testing Encode::is_utf8 in decode_form_utf8: That doesn't work.
  * decode_form_utf8 only fixed the utf-8 encoding for fields that were
    registered at the time it was called, which was before the
    formbuilder_setup hook. Fields added by the hook didn't get decoded.
    But it can't be put after the hook either, since plugins using the hook
    need to be able to use form values. To fix this dilemma, it's been changed
    to a decode_cgi_utf8, which is called on the cgi query object, before the
    form is set up, and decodes *all* cgi parameters.
  * aggregate: Only save state if it was already loaded. This didn't used to
    matter, but after recent changes, state is not always loaded, and saving
    would kill it.
  * table: Fix dependency tracking for external data files. Closes: #458387

 -- Joey Hess <joeyh@debian.org>  Sat, 05 Jan 2008 02:15:18 -0500

ikiwiki (2.17) unstable; urgency=low

  * Improved parentlinks special case for index pages.
  * redir: Support for specifying anchors.
  * img: Avoid nesting images when linking to another image. Closes: #457780
  * img: Allow the link parameter to point to an exterior url.
  * conditional: Improve regexp testing for simple uses of pagespecs
    that match only the page using the directive, adding 'included()'
    and supporting negated pagespecs and added whitespace.
  * map: Fix handling of common prefix to handle the case where it's
    in a subdirectory. Patch by Larry Clapp.
  * aggregate: Fix stupid mistake introduced when converting it to use
    the needsbuild hook. This resulted in feeds not being removed when pages
    were updated, and feeds sometimes being forgotten about.
  * aggregate: Avoid uninitialised value warning when removing a feed that
    has an expired guid.

 -- Joey Hess <joeyh@debian.org>  Sun, 30 Dec 2007 14:57:44 -0500

ikiwiki (2.16) unstable; urgency=low

  * Major basewiki reorganisation. Most pages moved into ikiwiki/ subdirectory
    to avoid polluting the main namespace, and some were further renamed.
  * meta: Add redir support, based on a patch by Thomas Schwinge.
  * Redirs added for moved basewiki pages. These will be removed in a future
    release.
  * Remove .otl file from sandbox to avoid build ugliness. Closes: #454181
  * Finally implemented a simple per-page data storage mechanism for plugins,
    via the %pagestate hash.
  * Use pagestate in meta to detect potential redir loops.
  * Added a version plugin that saves state about what's using it, to force
    pages to rebuild when ikiwiki's version changes.
  * The calendar plugin stores state about when it needs to be updated,
    and forces rebuilds of the pages that contain calendars. So
    running ikiwiki --refresh at midnight is now enough, no need for a full
    wiki rebuild each midnight.
  * calendar: Work around block html parsing bug in markdown 1.0.1 by
    enclosing the calendar in an extra div.
  * Fix file pruning code to work if ikiwiki is run with "." as the srcdir.
  * Add an edittemplate plugin, allowing registering template pages, that
    provide default content for new pages created using the web frontend.
  * Change formbuilder hook to not be responsible for displaying a form,
    so that more than one plugin can use this hook.
    I believe this is a safe change, since only passwordauth uses this hook.
    (If some other plugin already used it, it would have broken passwordauth!)
  * Ensure that web edited pages always end in a newline.
  * Avoid unnecessary stat calls to get mtime when rendering pages, use
    cached value.
  * Preserve input file modification times in output files.
  * Allow dashes in preprocessor directive commands, and shortcuts.
  * Htmlize parameters passed to the template preprocessor directive before
    inserting them into the html template. This ensures that markdown
    acts on them, even if the value is expanded inside a block-level html
    element in the html template. Closes: #454058
  * Use a div in the note template rather than a span.
  * shortcut: Expand %S to the raw input text, not url-encoded.
  * Don't increment feed numbers when an inline has no feeds. (Nis Martensen)
  * Allow editing a page and deleting all content, while still disallowing
    creating a new page that's entirely empty.
  * meta: Drop support for "meta link", since supporting this for internal
    links required meta to be run during scan, which complicated its data
    storage, since it had to clear data stored during the scan pass to avoid
    duplicating it during the normal preprocessing pass.
  * If you used "meta link", you should switch to either "meta openid" (for
    openid delegations), or tags (for internal, invisible links). I assume
    that nobody really used "meta link" for external, non-openid links, since
    the htmlscrubber ate those. (Tell me differently and I'll consider bringing
    back that support.)
  * meta: Improved data storage.
  * meta: Drop the hackish filter hook that was used to clear
    stored data before preprocessing, this hack was ugly, and broken (cf:
    liw's disappearing openids).
  * aggregate: Convert filter hook to a needsbuild hook.
  * map: Don't inline images.
  * brokenlinks: Don't list the same link multiple times. (%links might
    contain multiple copies of the same link)
  * git: Correct display of multiline commit messages in recentchanges.
  * Re-organise dependencies and recommends now that recommends are installed
    by default.
  * Don't refuse to render files with ".." in their name. (Anchor the regexp.)
  * Work around perl taint checking bug #411786, where perl sometimes randomly
    sets the taint flag on untainted variables, by disabling taint checking
    in the deb. This sucks.

 -- Joey Hess <joeyh@debian.org>  Tue, 18 Dec 2007 16:37:22 -0500

ikiwiki (2.15) unstable; urgency=low

  * Add a new ikiwiki-makerepo program, that automates setting up a repo
    and importing existing content for svn, git, and mercurial. This makes
    the setup process much simpler.
  * Reorganised git documentation.
  * Actually install the ikiwiki-update-wikilist program.
  * Improve workaround for perl bug #376329. Rather than double-encoding,
    which has been reported to cause encoding problems (though I haven't
    reproduced them), just catch a failure of markdown, and retry.
    (The crazy perl bug magically disappears on the retry.)
    Closes: #449379
  * Add umask configuration option. Closes: #443329

 -- Joey Hess <joeyh@debian.org>  Sat, 01 Dec 2007 11:44:01 -0500

ikiwiki (2.14) unstable; urgency=high

  * Let CC be used to control what compiler is used to build wrappers.
  * Use 'cc' instead of gcc as the default compiler.
  * Security fix: Ensure that there are no symlinks anywhere in the path
    to the top of the srcdir. In certian unusual configurations, an attacker
    who could commit to one of the parent directories of the srcdir could
    use a symlink attack to cause ikiwiki to publish files elsewhere in the
    filesystem. More details at <http://ikiwiki.info/security/#index29h2>

 -- Joey Hess <joeyh@debian.org>  Mon, 26 Nov 2007 15:26:06 -0500

ikiwiki (2.13) unstable; urgency=low

  The ikiwiki zombie army release.

  * Add liblwpx-paranoidagent-perl to recommends of Debian package,
    this is needed to do OpenID really securely.
  * ikiwiki.setup is licensed same as the basewiki, not GPLed.
  * inline: Add timeformat parameter to control how the ctime of
    inlined pages is displayed. Closes: #451019
  * Add wrappergroup config option, which can be used to cause wrappers
    to be created owned by some group other than the default. Useful
    then there's a shared repository with access controlled by a group,
    to let ikiwiki run setgid to that group.
  * ikiwiki-mass-rebuild: Run build with the user in all their groups.
  * Correct markdown in example index page in setup. Closes: #451469
  * Better error message when a setup file has a syntax error.
    Closes: #451666
  * Fix mercurial historyurl in example setup file.
  * More compact output for the brokenlinks plugin.
  * Allow trailing slashes after page names in wikilinks.
  * Don't consider links to anchors on the same page to be self links.
    Patch by Daniel Burrows. Closes: #451729
  * When usedirs is disabled, link direct to index.html files, not to
    directories, to improve browsing of file:// urls.
    Patch by Daniel Burrows. Closes: #451728
  * Allow html5 video and audio tags and their attributes in the htmlscrubber.
  * toc: Handle html elements embedded inside a header, rather than
    stopping collecting the header text at the first element.

 -- Joey Hess <joeyh@debian.org>  Sat, 24 Nov 2007 16:06:22 -0500

ikiwiki (2.12) unstable; urgency=low

  [ Joey Hess ]
  * Fix some issues with toggles in preview mode.
  * Fix an aggregate plugin expiry bug. Over time, it's possible for the same
    page name to be expired and reused for several distinct guids. When this
    happened, the expiry code counted each past guid that had used that page
    name as a currently existing page, and thus expired too many pages.
  * Avoid a race in the git rcs_commit function, by not assuming HEAD will
    stay the same for the duration of the function.
  * Avoid using commands like git-diff and instead use "git diff".
    In some configurations, only the main git command is in the path.
  * Improve the RecentChanges display for git merges, by passing -c instead
    of -m to git-log, and by skipping display of commits that change no
    pages.
  * Don't truncate git commit messages to the first line in RecentChanges,
    show the full message.
  * map: Recent changes caused unnecessary ul's to be inserted for items
    that were all at the same level, fix. Closes: #449285

  [ Josh Triplett ]
  * Fix table plugin to not generate an unbalanced tbody tag with header=no
  * Add xmlns attribute on html element in templates; pages can now
    validate.

  [ Joey Hess ]
  * In the example setup file, use mode 6755 for the git post-update hook.
    It needs to be setgid if the master repo is a shared repository, so
    that pushes into the working copy repository happen as the same group,
    avoiding permissions problems.
  * The first git commit legitimately has no parents. Avoid recentchanges
    spewing uninitialised value warnings and debug messages about it.
    Dummying up a parent of 0000000 allows gitweb to work too.

 -- Joey Hess <joeyh@debian.org>  Mon, 12 Nov 2007 14:35:09 -0500

ikiwiki (2.11) unstable; urgency=low

  * Correct a pair of logic errors that triggered if svnpath was empty.
  * If gitorigin_branch is set to the empty string, don't push or pull.
    Useful for laptop clones of remote wikis.
  * Add a calendar plugin, contributed by Manoj Srivastava.
  * Reformat calendar plugin to ikiwiki conventions.
  * The calendar plugin made *every* page depend on every other page,
    which seemed a wee tiny little bit overkill. Fixed the dependency
    calculations (I hope.)
  * Removed manual ctime statting code, and just have the calendar plugin use
    %pagectime.
  * Ikiwiki has moved into a git repository.
  * postsparkline: Avoid a confusing error message if no pages match
    and instead show an empty graph.
  * Add handling of feeds for nested inlines, as well as support for a
    single page containing two different feeds.
  * Also fixed some places in inline that failed to use destpage correctly.
  * ikiwiki-mass-rebuild: Patch from HenrikBrixAndersen to fix order
    of permissions dropping code to work on FreeBSD.
  * ikiwiki-mass-rebuild: Don't clear PATH from the environment.
  * Run git-commit -q (though it doesn't do much good due to its stderr
    abuse).

 -- Joey Hess <joeyh@debian.org>  Fri, 26 Oct 2007 03:29:09 -0400

ikiwiki (2.10) unstable; urgency=low

  * Tidy ctime debug output for git.
  * French translation update. Closes: #445923
  * Fix --get-ctime with git, needed to remove srcdir from filename.
  * In the cgi edit path, reload the index file before rendering. A bug
    showed up where a web edit that added a page caused a near-concurrent
    web edit to fail in will_render. While it would be hard to reproduce this,
    my analysis is that the failing cgi started first, loaded the index file
    (prior to locking) then the other cgi created the new page and rendered
    it, and then the failing cgi choked on the new file when _it_ tried to
    render it. Ensuring that the index file is loaded after taking the lock
    will avoid this bug.
  * Fix strange stderr-hiding code in the git module, allow error messages
    to be passed on to stderr. Also fixes a potential bug, since git error
    meesages were treated as if they came from git stdout.
  * Add a "createlink" class attribute to the span for wikilinks pointing
    to not-yet-existing pages. I don't have a useful style defined for that
    though.
  * Rewritten rst plugin by madduck is a python program that communicates with
    ikiwiki via XML RPC. This should be much faster than the old plugin that
    had to fork python for every rst page render. Note that if you use
    the rst plugin, you now need to have the RPC::XML perl module installed.
  * Danish translation from Jonas Smedegaard. Closes: #446952
  * Support git authors of the form "joey <joey>", which is common when
    importing from a svn repo.

 -- Joey Hess <joeyh@debian.org>  Sat, 20 Oct 2007 19:42:46 -0400

ikiwiki (2.9) unstable; urgency=low

  * Fix copyright and licence styling.
  * tag: Add taglink preprocessor directive, supporting visible tag links.
    Closes: #443344
  * map: Fully specify paths to links to avoid issues when the bestlink
    didn't point to the correct page.
  * map: Render pages on the way to subpages whose parent pages
    are not included in the map. Include special styling for such pages.
  * map: Remove common prefixes and don't over-indent.
  * Add class option to htmllink().
  * img: Allow link=somepage to cause the image to link to a given page.
    Slight overriding of link, as link=no is still used to disable the linking
    entirely. Unless you have a page named "no"..
  * Save index after previewing page edit, since even previewing can create
    files in some situations, and this is appropriate in some cases, such as
    the teximg plugin's error log file.
    Such files will be automatically cleaned up at an appopriate later time.
  * Don't allow whitespace in link text in a wikilink. This was still
    allowed by the regexp in one case though not documented to work, and
    was ambiguous with preprocessor directives.
  * camelcase: Tighten regexp to avoid false positives. WikiWords are only
    linkified now if they are preceeded by whitespace.

 -- Joey Hess <joeyh@debian.org>  Sun, 30 Sep 2007 15:07:24 -0400

ikiwiki (2.8) unstable; urgency=low

  * Redid the debian/copyright file, using the proposed new copyright file
    format. Included many details not previously listed in the old file.
  * inline: add feedonly option, set feedonly=yes to get only the feed button
    but not inline the pages.
  * meta: Support license and copyright information. The information will
    be shown in the page footer. HTML will also be inserted that should
    support the rel=license microformat as well as the HTML spec's
    rel=copyright.
  * table plugin: Actually specify the delimiter when parsing CSV.
  * table plugin: The previous version broke WikiLinks inside quoted values.
    Fix this by linkifying CSV data after parsing it, while DSV data is still
    linkified before parsing.

 -- Joey Hess <joeyh@debian.org>  Sun, 16 Sep 2007 20:02:25 -0400

ikiwiki (2.7) unstable; urgency=low

  [ Joey Hess ]
  * Add an editcontent hook.
  * Support for looking in multiple directories for underlay files.
  * Plugins can add new directories to the search path with the add_underlay
    function.
  * Split out smiley underlay files into a separate underlay, so if the plugin
    isn't used, the wiki isn't bloated with all those files.
  * Allow -cgi -wrapper to be passed on the command line to generate a
    wrapper.
  * Fix some taint issues with generating wrappers using the command line.
  * Don't allow newlines in link text in a wikilink.
  * Tables containing links with a link text were misparsed, because the "|"
    in the wikilink looked like a table field separator. Avoid this ambiguity
    by linkifying the data before parsing it as a table.
  * Turn on allow_loose_quotes in the table plugin's Text::CSV object,
    so that links from wikilinks don't confuse the parser.
  * mercurial: Pass --style default to hg log to ensure right format is used.
  * mercurial: Fix rcs_getctime (thanks, bma)

  [ Josh Triplett ]
  * Use git-log rather than the shell, git-rev-list, and git-diff-tree.
    Patch by Jamey Sharp <jamey@minilop.net>.
  * Renames from git-diff-tree aren't handled, so don't ask for them.
    Patch by Jamey Sharp
  * Handle operating in sub-trees of a git repository.
    When looking for git commits that affect the wiki, only include changes
    that affect the ikiwiki source directory. If that is not the top-level
    directory in this git repository, strip off the prefix as given by
    `git-rev-parse --show-prefix` from all names reported by git-log.
    Patch by Jamey Sharp

  [ Joey Hess ]
  * Correct generation of RFC 3339 format times for atom/rss feeds. Always use
    gmtime for these since a time zone is not specified.
  * Updated Spanish translation from Victor Moral.
  * table: Text::CSV doesn't return decoded unicode (XS module); decode its
    return values.
  * Change git test suite to reflect change in log for initial repo creation
    commit.
  * Add the ikiwiki-update-wikilist command.
  * Exclude external plugin from syntax check since it uses a module that is
    not in the build depends. Closes: #441171

 -- Joey Hess <joeyh@debian.org>  Sat, 08 Sep 2007 21:54:11 -0400

ikiwiki (2.6.1) unstable; urgency=low

  * Ye olde brown paper bag.
  * Fix minor bug when blogging by cgi, introduced in last version.
  * Fix a bug in unlockwiki intorduced last version that made it crash ikiwiki
    if it wasn't locked when called. This is known to break post-commit
    emails.

 -- Joey Hess <joeyh@debian.org>  Sun, 26 Aug 2007 13:38:23 -0400

ikiwiki (2.6) unstable; urgency=low

  * Various minor bug fixes for silly mistakes in the code, thanks to the
    various reviewers.
  * Fix problems with previewing in the graphviz plugin. Thanks,
    HenrikBrixAndersen.
  * Allow raw html in the rst plugin.
  * Add --set-option command line switch.
  * pagetemplate: don't display template name
  * Add rel=tag attribute to tag links, supporting that microformat, as well
    as allowing them to be styled specially. Thanks, NicolasLimare.
  * Add sessioncgi hook.
  * Move blog form code out of CGI.pm and into the inline plugin.
  * Updated Spanish translation from Victor Moral.
  * Updated French translation from Cyril Brulebois. Closes: #437181
  * The toc directive doesn't work well or make sense inside an inlined page.
    Disable it when the page with the toc is nested inside another page.
  * Apply a patch from NicolasLimare adding modification date tags to rss and
    atom feeds, and also changing the publication time for a feed to the
    newest modiciation time (was newest creation time).
  * The patch also adds dcterms:creator to rss items that have a known author.
  * Support pagespec "functions" with no parameters, like included() in the
    conditional plugin.
  * Add time=mtime option to postsparkline.
  * Fix --libdir to work at the command line.
  * Plugins can now be written as standalone external programs, which can
    be written in any language that can do XML RPC.
  * Change yet again how unhandled and escaped preprocessor directives are
    re-output onto the page. Hopefully I finally got it right..
  * Fix bug in deletion/move during edit code introduced in 1.44. Need to take
    the underlaydir into account.
  * Fix bug when editing file from underlaydir, need to rcs_add it even though
    a page creation isn't occuring.
  * Various minor fixes and stylistic improvements suggested by Perl::Critic.
  * Applied Jeremie Koenig's pluggable editpage buttons patch:
    - add a title to the editpage form;
    - pass a reference to the list of buttons to the formbuilder_setup
      hooks, so we can add ours;
    - relax asumption about the possible submit values (use "Save Page"
      explicitly);
    - de-hardcode the submit buttons from the editpage template
      (This was needed for compatibility with a bug in CGI::FormBuilder
      3.0401, but ikiwiki already needs a newer version.)
  * Pass buttons to all other formbuilder_setup hooks too.
  * Add color parameter to postsparkline. Closes: #438900
  * Add proper Homepage field to Debian package (needs uber-new dpkg).
  * Add monotone support, contributed by William Uther.
  * Avoid ugly gettext messages if LANG is empty. Closes: #439035
  * Added teximg plugin to generate images from latex code.
    Contributed by Patrick Winnertz as a GSoC project.
  * Call the formbuilder hook for the edit page.
  * Call decode_form_utf8 before running formbuilder_setup hooks.
  * Add editdiff plugin contributed by Jeremie Koenig.
  * Fix it to not leak path info.
  * Add embed plugin, which allows embedding content from google maps, video,
    calendar, and youtube. Normally, the htmlsanitiser eats these since they
    use unsafe tags, the embed plugin overrides it for trusted sites.
  * The googlecalendar plugin is now deprecated, and will be removed
    eventually. Please switch to using the embed plugin.

 -- Joey Hess <joeyh@debian.org>  Fri, 24 Aug 2007 17:09:44 -0400

ikiwiki (2.5) unstable; urgency=low

  * Wrap the editpage template in the standard misctemplate, this allows the
    pagetemplate hook to work for that page.
  * Above change fixes the favicon plugin to work on edit pages.
  * Correct some issues with escaped preprocessor directives.
  * Make the map plugin notice when pages in the map are deleted and update
    it.
  * Add a htmlext config option, this can be used to make ikiwiki generate
    html files with a different extension.
  * Fix graphviz plugin to not try to read images as utf-8; they might
    sometimes contain invalid utf-8 byte sequences. Thanks,
    HenrikBrixAndersen.
  * Fix re-rendering of pages when a linked to page goes away. This was broken
    in version 1.50 with the addition of %destsources. Thanks, Ethan
    Glasser-Camp.
  * Add templatefile hook.
  * Add pagetemplate plugin, which allows changing the template used for
    a page. (Not to be confused with the hook of the same name..)
  * Add a libdir config option to let ikiwiki load perl modules, including
    plugins, from a user-configurable directory.

 -- Joey Hess <joeyh@debian.org>  Thu, 26 Jul 2007 21:42:43 -0400

ikiwiki (2.4) unstable; urgency=low

  * Make the toc plugin use html-compatible anchors. This is necessary since
    most web sites serve ikiwiki xhtml files as text/html and mozilla browsers
    get confused. So it's best for ikiwiki to follow the compatibility
    recommendations in appendix C of the XHTML spec. Closes: #432045
  * Support building on systems that lack asprintf.
  * mercurial getctime is currently broken, apparently by some change in
    mercurial version 0.9.4. Turn the failing test case into a TODO test case.
  * Fix links to alternate stylesheets when usedirs is enabled. Closes: #432556
  * Use type= not style= in html for alternate stylesheets, which is more
    correct (but in my testing both epiphany and iceweasel work ok with
    style=text/css).
  * In img tag, allow link=no to disable link to full size image. Thanks,
    Nis Martensen. Closes: #433188

 -- Joey Hess <joeyh@debian.org>  Sun, 15 Jul 2007 15:02:43 -0400

ikiwiki (2.3) unstable; urgency=low

  * Corrected a typo in an error handler in the image plugin.
  * Allow svnpath config option to contain additional extra slashes anywhere
    w/o confusing ikiwiki.
  * Rcs modules are now imported, so other modules that need similar
    normalisation of configs etc can do so.
  * Patch fixing various additional problems with test suite. Closes: #425891
    once more.
  * French update from Jean-Luc Coulon. Closes: #430771
  * Correct a longstanding bug that could cause the edit form to be empty.
    This turns out to have occured if the cgi wrapper was created by an
    ikiwiki invocation that included --rebuild. Thanks to Carl Worth for
    tracking that down.

 -- Joey Hess <joeyh@debian.org>  Fri, 29 Jun 2007 18:30:38 -0400

ikiwiki (2.2) unstable; urgency=low

  * Change the aggregate plugin's locking strategy. Now it defers loading state
    until the wiki is building and already locked, unless it's aggregating.
    When aggregating, it does not wait for the lock if it cannot get it, and
    instead exits, to prevent aggregating processes from piling up.
  * Updated Spanish translation from Victor Moral.
  * Correct bug in the img plugin that caused dependencies on images to not
    always be tracked correctly.
  * Deal better with rebuilds that involve moving files; track and clean up the
    old files.
  * Change where the img plugin puts scaled images. It's better to make the
    scaled images subpages of the page that embeds them, rather than putting
    them alongside the original image, since if two pages scale the same image
    the same way, this prevents complications in dealing with two pages
    creating the same file. The move will be handled transparently, though you
    might want to rebuild your wiki to make it occur in one step.
  * Fix FTBFS in test suite introduced in last version. Closes: #425891
  * Apply a patch from Carl Worth allowing a class attribute to be passed
    through the img plugin. Also allow the id attribute to be passed through.
  * More consistent encoding of titles in rss and atom feeds. Don't use
    ESCAPE=HTML for titles in the templates for these feeds, and instead
    escape the title going in to the template. Previously, the title was
    sometimes double-escaped in a feed (if set via meta title), and sometimes
    not (if set from the page filename).
  * In the meta plugin, when a title is set, encode the html entities in it
    numerically. This works better in the current landscape of a rss spec that
    doesn't specify encoding, and variously broken feed consumers, according
    to <http://www.rssboard.org/rss-profile#data-types-characterdata>.
  * Correct some issues with display of unhandled preprocessor directives.
  * Apply a patch from Carl Worth adding support for using globs in link()
    in a PageSpec.
  * Explode some of the more insane regexps.
  * Add test suite for preprocessor directive parsing.
  * Fix wrapper generator and untaint code's handling of strings contining
    newlines.
  * Make the url absolution code for feeds significantly more robust.
  * Add typographyattributes configuration setting to typography plugin.

 -- Joey Hess <joeyh@debian.org>  Mon, 18 Jun 2007 21:21:56 +0100

ikiwiki (2.1) unstable; urgency=low

  [ Joey Hess ]
  * Use div layout for the signin and preferences forms, so that they can be
    styled using the stylesheet, rather than by creating signin and prefs
    templates.
  * Make the openid login form nicely styled.
  * Fix a bug that prevented clearing email or subscriptions.
  * Improve handling of edits of locked pages by users who are not yet signed
    in.
  * Make testpagespec more robust, including checking for missing/bad
    parameters.
  * Add all=no option to conditional, can be used to form conditionals that do
    not need to examine every page in the wiki.
  * Add the needsbuild hook. Plugins can use this to manipulate which files
    ikiwiki builds when refreshing the wiki.

  [ Josh Triplett ]
  * Add an account-creation password as a simple anti-spam mechanism. If
    set in the wiki setup, passwordauth will require the password in
    order to create an account.

  [ Joey Hess ]
  * Updated Czech translation from Miroslav Kure.
  * Apply patch from Paweł Tęcza to avoid using -L in Makefile as it's not
    available in older finds.
  * Make all templates have a footer div to ease themeing. Required template
    and style sheet updates, and unless you're using customised versions,
    you'll want to rebuild wikis on upgrade to this version to avoid
    inconsistencies.
  * Allow WIKINAME to to used in footers, as an example of something to put
    there.
  * Patch from hb to fix the pagestats plugin, which was broken by a past
    change to the backlinks() function.
  * Fix some bugs in password handling:
    - If the password is empty in preferences, don't clear the existing
      password.
    - Actually check the confirm password field, even if it's left empty.
  * Add a destpage parameter to the filter hook.
  * Fix links to smilies generated by the smiley plugin for inlined pages. The
    old links were often wrong, but often still worked by accident.
  * Add a test ensuring that the basewiki is self-contained and has no broken
    links.

 -- Joey Hess <joeyh@debian.org>  Sat, 19 May 2007 20:37:38 -0400

ikiwiki (2.00) unstable; urgency=low

  [ Josh Triplett ]
  * Avoid using GNU extensions to cp during "make install", which did
    not work on FreeBSD.  Thanks to Henrik Brix Andersen for the patch.

  [ Joey Hess ]
  * Use fieldsets in the preferences form to group related options together.
    Especially cleans up the ordering of the admin's preferences form.
  * Use a fieldset to set off the openid entry from the rest of the login
    form.
  * Enable openid logins by default.
  * Enable usedirs by default.

  [ Josh Triplett ]
  * fieldset support appeared in CGI::FormBuilder 3.05, so increase
    version in Depends on libcgi-formbuilder-perl to 3.05

  [ Joey Hess ]
  * If Net::OpenID::Consumer is not available, the openid module will quietly
    disable itself, this avoids needing a hard dependency on the perl module.

 -- Joey Hess <joeyh@debian.org>  Mon, 30 Apr 2007 00:43:02 -0400

ikiwiki (1.51) unstable; urgency=low

  [ Joey Hess ]
  * Support setting svnpath to "" for wikis that are rooted at the top of
    their svn repositories, with no trunk directory.
  * Minor template improvements by Alessandro.
  * In mercurial backend, untaint ipaddr when using it as the user for the
    commit. Thanks, Alexander Wirt. Closes: #420428
  * Fix aggregator to not warn when a feed contains no body content at all.
  * Work around bug #420636 by, if XML::Parser crashes, running the feed
    content though Encode::decode_utf8.

  [ Josh Triplett ]
  * Change basewiki CSS to not put a border around images used as links.

  [ Joey Hess ]
  * Move the footer div to enclose tags and links too.
  * More style sheet updates, remove the hack that used the tags div to create
    the footer border.
  * Due to template changes and style sheet changes that depend on them,
    wiki rebuilds are recommended on upgrade to this version.
  * Avoid .svn directories when installing from svn checkout.
  * Fix sending of commit mails when new pages are added via the web.
  * Add user(name) to the PageSpec for commit subscriptions.
  * pagespec_match() has changed to take named parameters, to better allow
    for extended pagespecs. The old calling convention will still work for
    back-compat for now.
  * The calling convention for functions in the IkiWiki::PageSpec namespace
    has changed so they are passed named parameters.
  * Plugin interface version increased to 2.00 since I don't anticipate any
    more interface changes before 2.0.
  * Updated Gujarati translation from Kartik Mistry. Closes: #421198
  * Make pagespec_match return an object that can be stringified to tell
    the reason why the match failed or succeeded.
  * Add testpagespec plugin, which might be useful to see why a pagespec isn't
    working as desired.

  [ Josh Triplett ]
  * Fix bestlink to use pagecase for pages in userdir, to support pages
    with non-lowercase filenames.

  [ Joey Hess ]
  * Include wikiname in syslogged messages.
  * Updated Polish translation from Paweł Tęcza.
  * Updated Czech translation from Miroslav Kure.
  * Updated Spanish translation from Victor Moral.
  * Apply patch from hb that uses the full path to a file when adding a file
    using the mercurial backend. Not 100% sure why it failed w/o the full
    path, but this still passes the test suite, and indeed, is how the test
    suite calls hg add.

 -- Joey Hess <joeyh@debian.org>  Sun, 29 Apr 2007 00:01:23 -0400

ikiwiki (1.50) unstable; urgency=low

  [ Josh Triplett ]
  * Add a graphviz plugin.
  * Suggests: graphviz
  * Enhance helponformatting and related documentation to supply more
    information about available preprocessor directives.
  * Add myself as a co-maintainer, with Joey's approval.

  [ Joey Hess ]
  * Add support for PROFILE=1 to the Makefile, this turns on profiling of the
    wiki build using Devel::Profiler (Dprof can't handle ikiwiki).
  * Add a new %destsources hash, which maps between a destination file and
    the source page used to create it, ie it's the reverse of %renderedfiles.
  * Use %destsources in htmllink and urlto for 20-50% speedup. Thanks
    Josh Triplett for the idea.
  * Optimise displaytime, trimming maybe 6% off the build time.

  [ Josh Triplett ]
  * Conflicts/Replaces/Provides the unofficial ikiwiki-plugin-table
    package, because ikiwiki now provides the table plugin, and thus has
    a file overlap with ikiwiki-plugin-table.
  * Add libtext-csv-perl to Suggests, for the table plugin.
  * Add libdigest-sha1-perl to Suggests, for sparkline and graphviz.
  * Add libtext-typography-perl to Suggests for the typography plugin.

  [ Joey Hess ]
  * Add postformtext parameter to inline.
  * Internal version number and installdir substitutions were lost, fix.
  * Apply patch from Ethan to improve an error message that should never
    happen.
  * Patch from Tuomov to link to the directory in feeds when usedirs is in
    effect. Note that this changes permalinks, so if you are already using
    usedirs you'll have to deal with that on upgrade to this version.
  * Add feedshow parameter to inline, which can be useful for eg, removing
    old posts from feeds when permalinks change.
  * Add .dpkg-tmp to prune regexp, so that if ikiwiki is run right as it's
    being upgraded by dpkg it will ignore dpkg temp files in the basewiki.

 -- Joey Hess <joeyh@debian.org>  Sun, 15 Apr 2007 16:02:05 -0400

ikiwiki (1.49) unstable; urgency=low

  [ Joey Hess ]
  * Add --post-commit option, which allows for the case of a split web server
    and RCS server (or a push mirror). With this the RCS server can have a
    real post-commit hook that sshs back to the web server, and runs ikiwiki
    in post-commit mode to update the wiki.
  * Fix urls generated by mirrorlist plugin.
  * Add a templates page to the basewiki. It will automatically list all
    available templates. Rename the old templates page to wikitemplates.
  * Include the note template in the basewiki.
  * Add a popup template in the basewiki. CSS based on some by Martin Krafft.
  * Make the note, popup, and plugin templates detect missing variables and be
    self-documenting, listing the available variables.
  * Hide excess backlinks and expand using CSS trick; control quantiy via
    the numbacklinks setting.
  * Finally apply the index.html patch, with thanks to everyone who worked
    on and supported creating it (especially Tuomov). This adds a "usedirs"
    option that makes ikiwiki use foo/index.html instead of foo.html as
    output page names. It is not yet enabled by default.
  * Fix a bug in the img plugin that caused thumbnailed files to not be
    tracked properly.
  * Make the OpenID library a reccommendation of the Debian package, rather
    than just a suggests, since OpenID is enabled by default.
  * Fix a bug that caused link(foo) to succeed if page foo did not exist.
  * Fix tags to page names that contain special characters.

  [ Josh Triplett ]
  * Use pngcrush and optipng on all PNG files.
  * Add neutral smileys ":|" and ":-|", and question icon smiley "(?)",
    with images taken from phpBB (GPL) and converted with gif2png.
  * Improvements to Description in debian/control:
    * Note that some plugins have additional dependencies, found among the
      Recommends and Suggests.
    * ikiwiki supports both RSS and Atom feeds.
    * Fix typos.
  * Add Homepage field.
  * Add XS-Vcs-Browser field.

  [ Joey Hess ]
  * Updated French translation from JLC. Closes: #417982
  * Reorder the icon in the template above the stylesheets, to avoid icon
    flashing during page load.
  * Fix smiley plugin to scan smileys.mdwn after it's updated, which fixes
    a bug caused by committing changes to smilies.mdwn.
  * Fix display of escaped wikilinks containing anchors.

  [ Josh Triplett ]
  * Remove stray semicolon in linkmap.pm.

 -- Joey Hess <joeyh@debian.org>  Sun, 08 Apr 2007 16:14:46 -0400

ikiwiki (1.48) unstable; urgency=low

  * Fix link() PageSpecs to not just look at the raw link text, but at where
    that given link points based on the page doing the linking. Note that this
    could make such PageSpecs match different things than before, if you
    relied on the old behavior of them only matching the raw link text.
  * This required changing the match_* interface, adding a third parameter.
  * Allow link() PageSpecs to match relative, as is allowed with globs.
  * Add postform option to inline plugin.
  * Add an bug tracker to the softwaresite example.
  * Make ikiwiki's stylesheet support printing by hiding parts of the page
    that shouldn't appear in a printout: Search box, actions bar,
    blog post form, tags, backlinks, and feed buttons.
  * Finally fixed the longstanding inline removal bug.
  * Renamed %oldpagemtime to a more accurately named %pagemtime and fix it to
    actually store pages' mtimes.
  * Add "mtime" sort parameter to inline plugin.
  * Fix mercurial backend to deal with empty commit messages.

 -- Joey Hess <joeyh@debian.org>  Sat, 24 Mar 2007 11:14:10 -0400

ikiwiki (1.47) unstable; urgency=low

  * Fix a security hole that allowed insertion of unsafe content via the meta
    plugins's support for inserting html link and meta tags. Now such content
    is passed through the htmlscrubber like everything else.
  * Unfortunatly, that means that some valid uses of those tags are no longer
    usable, and special case methods needed to be added for including
    stylesheets, and for doing openid delegation. If you use either of these
    in your wiki, it will need to be modified. See the meta plugin docs
    for details.

 -- Joey Hess <joeyh@debian.org>  Wed, 21 Mar 2007 14:05:00 -0400

ikiwiki (1.46) unstable; urgency=low

  * Fix a bug with inlined create page links, including Discussion links on
    blog post pages. The links will now create pages relative to the page that
    actually contains the link.
  * French update. Closes: #414597
  * Fix some broken logic in cgi creation of a subpage when a toplevel page
    with the same name already exists, and generally simplify the edit code.
  * Make ikiwiki -verbose -setup with a setup file that enabled syslog logging
    output the verbose build log to stdout, rather than to the syslog.
  * Detect the case of two people independently creating the same page at the
    same time, and let the second person resolve the conflict.
  * Applied a patch from Michał to make the mercurial backend pass --quiet to
    hg.
  * Fix a security hole that allowed a web user to insert arbitrary html in
    the title of a page due to missing escaping of titles in the meta plugin.

 -- Joey Hess <joeyh@debian.org>  Wed, 21 Mar 2007 01:51:30 -0400

ikiwiki (1.45) unstable; urgency=low

  * Allow for underscores to appear in page titles, if encoded appropriately
    (__95__) in filenames. Previously, all underscores were replaced with
    spaces. Thanks, Enrico Zini for noticing that bug.
  * Add "template" option to inline plugin to allow for use of customised
    templates.
  * Add titlepage template for inline plugin.
  * Add preview parameter to preprocesser calls, use this rather than the
    previous ugly hack used to avoid writing rss feeds in previews.
  * Fix the img plugin to avoid overwriting images in previews. Instead it
    does all the work to make sure the resizing works, and dummys up a resized
    image using width and height attributes.
  * Also fixes img preview display, the links were wrong in preview before.
  * Add a sparkline plugin.
  * Add a postsparkline plugin.
  * The slash escaping when adding to a blog from the CGI was not working
    since it ended up being double-escaped. Instead, just remove slashes.
  * Fix some nasty issues with page name escaping during previewing
    (introduced in 1.44).
  * Add a table plugin, derived from the one written by Victor Moral.
  * The underscore escaping support exposed a bug in edit links: Such links
    were titlepage escaped in the urls, and then doubly escaped by the CGI
    when editing. To fix this, I removed the titlepage escaping in the edit
    urls.
  * That means that *every edit link* on the wiki is potentially changed.
    Rebuilding wikis on upgrade to this version therefore necessary; enabled
    that in postinst.
  * Correct a deadlock that could occur in post-commit if the aggregate plugin
    was enabled and tried to lock the already locked wiki.

 -- Joey Hess <joeyh@debian.org>  Sat, 10 Mar 2007 21:11:05 -0500

ikiwiki (1.44) unstable; urgency=low

  * Patch by Ben to fix validaton of atom feeds by fixing the category tags.
  * Add a openidlogin-bg.gif to wikiicons and have the stylesheet use it for the
    OpenID login form rather than linking to a remote logo, to avoid various
    issues. Since there is not yet a license for the actual OpenID logo, this
    file is currently a blank image. Users who want to can copy
    http://openid.net/login-bg.gif into their wiki.
  * Allow setting NOTAINT=1 when building the wiki to remove taint checking
    flags, which can be useful on some hosting providers.
  * Fix a bug that made links like [[0|foo]] use "foo" as the link text,
    instead of "0".
  * Changed calling convention for httmllink slightly. The first three
    parameters remain the same, but additional options are now passed in using
    named parameters.
  * Change plugin interface version to 1.02 to reflect this change.
  * Add a new anchor option to htmllink. Thanks Ben for the idea.
  * Support anchors in wikilinks.
  * Add a "more" plugin based on one contributed by Ben to allow implementing
    those dreaded "Read more" links in blogs.
  * Don't error out if estcmd fails, just print a warning message. estcmd is
    too fragile to let it kill ikiwiki.
  * Make img plugin not fail immediately if Image::Magick is not available.
    This lets ikiwiki not build depend on perlmagic.
  * Detect old versions of xgettext and avoid using them.
  * perl is broken: print "" || die fails! Work around this insanity.
  * Smarter detection of no-op changes to po files.
  * Elegant patch from Ethan to clean up the display of page names in the
    dropdown when creating a new page.
  * Since the CGI had to drop the wiki lock to avoid deadlocking the
    commit hook, it was possible for one CGI to race another one and "win"
    the commit of both their files. This race has been fixed by adding a new
    commitlock, which when locked by the CGI, disables the commit hook
    (except for commit mails). The CGI then takes care of the updates the
    commit hook would have done.
  * French translation update. Closes: #411899
  * Patch from HenrikBrixAndersen to fix a broken use of foreach in the
    search plugin.
  * Correct a bug that could lead to infinite looping after signin in some
    circumstances.
  * Patch from Ethan to improve behavior if a page is deleted or moved while
    someone is editing it.
  * Some cleanup of field setting in the failed edit and conflict handling
    code.

 -- Joey Hess <joeyh@debian.org>  Sat, 24 Feb 2007 20:16:35 -0500

ikiwiki (1.43) unstable; urgency=low

  * Allow plugins to add new types of tests that can be used in PageSpecs.
  * Add a "conditional" plugin, which allows displaying text if a condition
    is true. It is enabled by default so conditional can be used in the
    basewiki.
  * Use conditionals in the template for plugins, so that plugin pages
    say if they're currently enabled or not, and in various other places
    in the wiki.
  * Updated Spanish translation.
  * Make the basewiki be full of symlinks to pages that should be the same
    in the doc wiki. This will allow direct edits to alter the base wiki
    without manual munging.
  * Fix the template, toggle, and conditional plugins to filter text before
    preprocessing it.
  * Fix smiley plugin to support smileys at the very beginning or end of
    the content.
  * Allow multiple tag settings to appear in a single page.
  * Many changes to make ikiwiki very resistant to write failures
    including out of disk space situations. ikiwiki should never leave
    truncated files, and if the error occurs during a web-based file edit,
    the user will be given an opportunity to retry.
    Inspired by the many ways Moin Moin destroys itself when out of disk. :-)
  * Fix syslogging of errors.
  * Patch from Ethan to allow using meta tags to set creation dates of pages.
  * Add a prettydate plugin that formats dates in a more readable fashion.
    (I had to get a pretty date somehow today..)
  * Updated Czech translation.
  * Avoid potential syslog format string issue, although only older versions
    of perl are vulnerable and it is not known to really be exploitable from
    ikiwiki.
  * Add explicit module prereqs to Makefile.PL
  * New domain name for ikiwiki: ikiwiki.info. Update your links.

 -- Joey Hess <joeyh@debian.org>  Sun, 18 Feb 2007 23:26:32 -0500

ikiwiki (1.42) unstable; urgency=low

  * Fix several more missing translations of Discussion.
  * Fix for missing backlinks() in pagestats plugin.
  * Add canedit hook, allowing arbitrary controls over when a page can be
    edited.
  * Move code forcing signing before edit to a new "signinedit" plugin, and
    code checking for locked pages into a new "lockedit" plugin. Both are
    enabled by default.
  * Remove the anonok config setting. This is now implemented by a new
    "anonok" plugin. Anyone with a wiki allowing anonymous edits should
    change their configs to enable this new plugin.
  * Add an opendiscussion plugin that allows anonymous users to edit
    discussion pages, on a wiki that otherwise wouldn't allow it.
  * Lots of CGI code reorg and cleanup.
  * Avoid using lots of memory when copying large non-html files.
    Yes, you can keep videos in the wiki..
  * Add feedshow option to allow reducing the number of items included in
    an rss or atom feed.
  * Change based on a patch from Ethan to support relative matching in
    PageSpecs, by using "./".
  * pagespec_match() has grown a new third parameter to support this.
  * Add "reverse" option to inline to invert sort orders.
  * Drop the BSD license for the templates and basewiki, and just allow them
    to be used as close to public domain as possible.
  * viewcvs is now viewvc (in Debian unstable), update everything to use the
    new name.
  * Fix a security hole that allowed a web user to edit images and other
    non-page format files in the wiki. To exploit this, the file already had
    to exist in the wiki, and the web user would need to somehow use the web
    based editor to replace it with malicious content.
    (Sorry Josh, this means you can't edit style.css directly anymore,
    although I do appreciate your fixes, actually..)

 -- Joey Hess <joeyh@debian.org>  Sat, 10 Feb 2007 15:37:39 -0500

ikiwiki (1.41) unstable; urgency=low

  * Gettext 1.04 or up is needed for the OO interface that ikiwiki needs,
    if an older version is installed, just don't gettext strings, instead of
    crashing.
  * Added smileys for Moin Moin compatibility.
  * Fix handling of discussion links on discussion pages when l10n is used.
  * Make gitorigin_branch and gitmaster_branch configurable via the setup
    file. Closes: #408599
  * French translation update. Closes: #408593
  * Improve use of svn merge, by specifying the file to merge, rather than
    chdiring to the srcdir (which wasn't right when merging in a subdir).
    Thanks Ethan.
  * Always call rcs_update after a commit during a web edit, to work around
    the problem described in bugs/svn_fails_to_update. Thanks to Ethan for the
    analysis and patch.
  * Replace underscores in shortcut texts with spaces when formatting for
    display. This allows using a shortcut like [[wikipedia War_of_1812]],
    which links to the correct remote page, but is displayed nicely.
  * When building the doc wiki, build with LANG=C.
  * More gettext fun.
  * Fix openid signin secret generation code. This fixes the bug that made
    all openid signins fail the first time, and then succeed the second
    time.

 -- Joey Hess <joeyh@debian.org>  Tue, 30 Jan 2007 02:36:53 -0500

ikiwiki (1.40) unstable; urgency=low

  * Fix missing categories in rss/atom feeds.
  * Add French translation by Jean-Luc Coulon. Closes: #406881
  * Fix bogus use of CDATA in atom feeds. Closes: #406898

 -- Joey Hess <joeyh@debian.org>  Sun, 14 Jan 2007 21:42:27 -0500

ikiwiki (1.39) unstable; urgency=low

  * Add a rawhtml plugin that allows copying raw html files from the srcdir.
  * Fix --locale to control LC_ALL now.
  * Include the pot file in the source tarball. Closes: #405890
  * Add a Swedish translation by Daniel Nylander. Closes: #406410
  * Add a Czech translation by Miroslav Kure.
  * Add a Bulgarian translation by Damyan Ivanov. Closes: #406580
  * Add a Gujarati translation by Kartik Mistry. Closes: #406635
  * Add a Vietnamese translation by Clytie Siddall.
  * Fix encoding issue with use of Locale::Gettext. Seems that the OO
    interface returns proper utf-8 decoded strings, unlike the traditional
    interface, so use the OO interface.
  * Search in default location for templates as a fallback when templatedir is
    pointed elsewhere, so that only modified templates need to be copied into
    a templatedir. Based on work by JeremyReed.
  * In the aggregator, check for and deal with post filenames that are
    longer than the maximum file length.
  * Change the RecentChanges page to show the path of changed pages.
  * Various minor bugfixes.

 -- Joey Hess <joeyh@debian.org>  Sat, 13 Jan 2007 23:30:20 -0500

ikiwiki (1.38) unstable; urgency=low

  * Corrected a bum regexp in openid munging.
  * Added a Spanish translation by Victor Moral.
  * A few translation infrastructure fixes.
  * Added a Polish translation by Paweł Tęcza.

 -- Joey Hess <joeyh@debian.org>  Fri,  5 Jan 2007 23:13:59 -0500

ikiwiki (1.37) unstable; urgency=low

  * Add mirrorlist plugin.
  * Fixed permissions of some files that were 600 in the tarball. (Did not
    affect the deb).
  * Avoid creating edit links when the cgi url is not known.
  * Avoid displaying discussion links at all, if there's not a discussion
    page, when the cgi url isn't known.
  * Before, svn was used as the RCS by default unless configured otherwise,
    now it defaults to using no RCS unless configured to do so, to avoid some
    suprising behavior when using a setup file and not uncommenting any RCS
    options.
  * Fix some bugs in the commit email sending code.
  * Improve code that ignores files in the underlaydir if the srcdir has a
    file building the same page. Now it will work even if the extensions of
    the source files differ.
  * Initial work on internationalization of the program code. po/ikiwiki.pot
    is available for translation.
  * Export gettext() from IkiWiki module.
  * Don't put discussion links on discussion pages.
  * Allow disabling of plugins included in goodstuff.
  * Add a textile format plugin contributed by mazirian.
  * If a userdir is configured, links to pages in it can be made without
    specifying the path. This allows for easy signing of comments by linking
    to your page in the userdir.
  * Escape slashes in page titles entered in the blog post form.
  * Munge openids of the form somehost.com/user (trial, may revert).

 -- Joey Hess <joeyh@debian.org>  Sun, 31 Dec 2006 17:31:22 -0500

ikiwiki (1.36) unstable; urgency=low

  * Fix various links on the hyperestraier pages.
  * Use POST for poll to avoid some robots.
  * Fix sometimes broken links to Discussion pages from blog pages.
  * Add userdir config setting.
  * Fix man page perms in install.
  * Fix an issue with inlining a page with a rss feed inside another
    page with an rss feed.
  * Turn $config{wiki_file_prune_regexps} into an array that is easier to
    manipulate.
  * Only exclude rss and atom files from processing if the inline plugin
    is enabled and that feed type is enabled. Else it's just a copyable file
    type.
  * Move rss and atom option handling code into the inline plugin.
  * Applied a rather old patch from Recai to fix the "pruning is too strict"
    issue. Now you can have wiki source directories inside dotdirs and the
    like, if you want.
  * Patch from Emanuele Aina to fix modification time code in mercurual
    backend.
  * Add support for links of the form [[/foo]]
  * Fix code to make absolute urls for rss feeds, was missing some urls.
  * Fix double-escaping of html entities in titles etc in rss feeds
    that occured if escaped characters were present in the page filename.

 -- Joey Hess <joeyh@debian.org>  Fri, 22 Dec 2006 15:55:05 -0500

ikiwiki (1.35) unstable; urgency=low

  * Fix daemonisation code to only do daemon setup things after forking the
    child process.
  * The hack used to make the pagetemplate hook have access to the editpage
    template won't work with CGI::FormBuilder 3.0401, so disable it for now.
  * CGI::FormBuilder 3.0401 seems to work ok now with ikiwiki, although
    there might still be bugs lurking..

 -- Joey Hess <joeyh@debian.org>  Fri,  1 Dec 2006 19:14:36 -0500

ikiwiki (1.34.2) unstable; urgency=low

  * Allow /etc/ikiwiki/wikilist to list just the names of users, if so then
    ~user/.ikiwiki/wikilist will be read.
  * Fix url absolution code in inline plugin to support class and id fields in
    links and imgs, and to support anchor urls.
  * More build deps updates.
  * /dev/null fortune failures

 -- Joey Hess <joeyh@debian.org>  Tue, 28 Nov 2006 12:58:47 -0500

ikiwiki (1.34.1) unstable; urgency=low

  * Add libtime-duration-perl to build deps, as it's used by the svn module
    which is now tested at build.

 -- Joey Hess <joeyh@debian.org>  Mon, 27 Nov 2006 12:26:12 -0500

ikiwiki (1.34) unstable; urgency=low

  * Add an openid plugin to support logging in using OpenID.
  * Web commits by OpenID users will record the full OpenID url for the user,
    but in recentchanges, these urls will be converted to a simplified display
    form+link.
  * Modified svn, git, tla backends to recognise such web commits.
  * Move httpauth support to a plugin.
  * Add openidsignup config option.
  * Make the openid plugin support the callbacks from myopenid.com via its
    affiliate program.
  * Add toggle plugin.
  * Add a poll plugin.
  * Add quick mode for archive page generation.
  * Introduce the goodstuff bundle. This is a kind of plugin, that just enables
    many other plugins. It's an easy way to boost ikiwiki from its default,
    basic wiki, to a full-featured wiki, without manually picking the right
    set of plugins. New plugins will be added to goodstuff from time to
    time.
  * Change how post signin actions are propigated through the signin process;
    they're now stored in the session.
  * Add optional "desc" parameter to shortcut definitions.
  * Avoid locking the wiki at all when handling some basic cgi stuff
    (searches, recentchanges).
  * Add "last" parameter to hook function. Very basic ordering, and hopefully
    nothing more spohisticated will be needed.
  * Add formbuilder_setup and formbuilder hooks.
  * Split out a passwordauth module, that holds all the traditional password
    based authentication etc code. It's enabled by default, but can be disabled
    if you want only openid or some other auth method.
  * Rename ikiwiki.pl so MakeMaker doesn't see it, and install it.
  * Add some code to the build system that tries to determine if the
    lib installation directory is in @INC. If it's not, munge ikiwiki
    to hardcode the path to the lib directory. This should allow installing
    ikiwiki in nonstandard locations, including home directories, by just
    setting PREFIX at build time.
  * Fix nested examples directory in deb.
  * Add a test suite for the mercurial backend, contributed by Emanuele Aina.
  * Add a test suite for the svn backend.
  * Add a test suite for the git backend, from Recai
  * Daemonize before sending RPC pings, since that can take a while
    and/or hang.
  * Daemonize before sending commit mails, as that can also take a long
    time/hang if the mail server is unhappy.
  * Factor out commit mail sending code into new function.
  * Change rcs_commit, it is now passed the name of the user doing the commit
    and their IP address, and needs to construct its own commit message
    containing them, or do something more appropriate for the given RCS.
  * Add softwaresite example.
  * Mercurial backend improvements, including --get-ctime support. (Emanuele
    Aina)
  * Git backend improvements, including bug fixes and better robustness,
    from Recai.

 -- Joey Hess <joeyh@debian.org>  Sun, 26 Nov 2006 20:46:56 -0500

ikiwiki (1.33) unstable; urgency=low

  * Fix issue with aggregate plugin updating expired pages.
  * Avoid syntax errors in templates used by the template plugin crashing
    ikiwiki.
  * Enable utf8 file IO in aggregate plugin.
  * Fix some issues with the new registration form.
  * Patch from Ethan Glasser Camp to add a skip option to the inline plugin.
  * Make sure to check for errors from every eval.
  * Fix img plugin's handling of adding dependencies for images that do not
    yet exist.
  * Work around a strange bug in CGI::FormBuilder 3.0401 that makes
    FORM-SUBMIT unusable on customised formbuilder templates. For now,
    hardcode the submit buttons in editpage.tmpl instead of using the
    template variable, which is ok, since the buttons are static.
  * Work with hyperestraier 1.4.9.

 -- Joey Hess <joeyh@debian.org>  Wed, 15 Nov 2006 18:32:26 -0500

ikiwiki (1.32) unstable; urgency=low

  * Add a separate pass to find page links, and only render each page once,
    instead of over and over. Typical speedup is ~4x. Max possible speedup:
    8x.
  * Add "scan" parameter to hook(), which is used to make the hook be called
    during the scanning pass, as well as the render pass. The meta and tag
    plugins need to use the new scan parameter, so will any others that modify
    %links.
  * Now that links are calculated in a separate pass, it can also
    precalculate backlinks in one pass, which is O(N^2) instead of the
    previous code that was O(N^3). A very nice speedup for wikis with lots
    (thousands) of pages.
  * Stylish update to the ikiwiki logo, thanks to Recai Oktaş and Selçuk
    Erdem.
  * Add a default stylesheet entry for the pagecloud.
  * Add examples page with some examples of things that can be done using
    ikiwiki, like a weblog. The examples can be copied into a user's wiki
    for a quick start, without needing to learn everything about how to put
    them together.
  * Install the source of the examples into /usr/share/doc/ikiwiki/examples.
  * Add perlmagick to build-depends so syntax check of img plugin works.
    Closes: #396702
  * Improve login/register process, the login dialog has only name and
    password fields, which allows more web browsers to regognise it as a login
    field, and is less confusing.
  * Implemented expiry options for aggregate plugin.
  * Use precalculated backlinks info when determining if files need an update
    due to a page they link to being added/removed. Mostly significant if
    there are lots of pages.
  * Remove duplicate link info when saving index. In some cases it could
    pile up rather badly. (Probably not the best way to deal with this
    problem.)
  * Patch from James Westby to support podcasting, photoblogging, vidcasting,
    or what have you, by creating enclosures for non-page items that are
    included in feeds.

 -- Joey Hess <joeyh@debian.org>  Fri,  3 Nov 2006 14:46:37 -0500

ikiwiki (1.31) unstable; urgency=low

  * Patch from Paweł Tęcza to cp -a the templates in the Makefile.
  * Change the rss feed title from the wikiname to the page title, with
    an exception for the wiki's toplevel index page, which will still use the
    wikiname as the feed title.
    Overriding the page title with meta title already overrode the rss feed
    tittle.
  * Add an img plugin, based on Christian Mock's img plugin, but stripped
    down to the bare essentials. Useful for handling large images on websites.
  * Sanitize possibly problimatic characters out of the polygen grammar names,
    just in case. Should not be exploitable anyway, since it only tries to run
    polygen after finding the specified grammar file.
  * Add missing dependency on the URI perl module.
  * Add basic spam fighting tool for admins: An admin's prefs page now allows
    editing a list of banned users.

 -- Joey Hess <joeyh@debian.org>  Fri, 27 Oct 2006 23:16:33 -0400

ikiwiki (1.30) unstable; urgency=low

  * Add no_override parameter to hook().
  * Add a shortcut plugin, inspired by Victor Moral's contributed shortcuts
    plugin, but featuring a more ikiwiki-ish syntax and with shortcuts that
    can be configured using a page in wiki.
  * Fix support for --pingurl at the command line.
  * Fix a subtle bug in will_render that broke some builds, by only clearing
    items from renderedfiles the first time per build.
  * Wrap entire technortati ping operation in an eval to catch all possible
    failure modes, after I observed a simple ->value crashing ikiwiki when
    a ping failed.

 -- Joey Hess <joeyh@debian.org>  Mon, 16 Oct 2006 15:17:38 -0400

ikiwiki (1.29) unstable; urgency=low

  * Patch from Paul Tötterman to use CP in the Makefile.
  * Patch from Alec Berryman adding a http_auth config item that allows
    using HTTP Authentication instead of ikiwiki's built in authentication.
    Useful for eg, large sites with their own previously existing user auth
    setup. Closes: #384534
  * Change %renderedfiles to store an array of files rendered from a given
    source file, to allow tracking of extra rendered files like rss feeds.
  * Note that plugins that accessed this variable will need to be updated!
    The plugin interface has been increased to version 1.01 for this change.
    As few plugins use %renderedfiles I haven't done anything else to ensure
    compatibility of old plugins.
  * Add will_render function to the plugin interface, used to register that a
    page renders a destination file, and do some security checks. Previously
    but no longer rendered files will be cleaned up.
  * Use will_render in the inline and linkmap plugins.
  * You will need to rebuild your wiki on upgrade to this version.
  * Atom feed support based on a patch by Clint Adams.
  * Add feeds=no option to inline preprocessor directive to turn off all types
    of feeds.
  * $IkiWiki::version now holds the program version, and is accessible to
    plugins.
  * Make the aggregate plugin emphasize error messages.
  * Patch from Recai to limit recentchanges to displaying max 10 files for a
    given changeset (to avoid large number of file changes excessively
    bloating the page).

 -- Joey Hess <joeyh@debian.org>  Fri, 13 Oct 2006 23:14:28 -0400

ikiwiki (1.28) unstable; urgency=low

  * inline: Add ability to sort by page name, based on a patch from
    Benjamin A'Lee.
  * Fix a forkbomb in various calls to IPC::Open2, which has a highly
    braindead interface. Closes: #389383
  * Don't rm -rf ikiwiki on distclean, since a) there's no such file
    and b) those poor Mac OSX users and their case insensative files!
  * Don't fail syntax check if Text::Typography isn't installed.
    Closes: #389406

 -- Joey Hess <joeyh@debian.org>  Tue, 26 Sep 2006 02:08:17 -0400

ikiwiki (1.27) unstable; urgency=low

  * Work on firming up the plugin interface:
    - Plugins should not need to load IkiWiki::Render to get commonly
      used functions, so moved some functions from there to IkiWiki.
    - Picked out the set of functions and variables that most plugins
      use, documented them, and made IkiWiki export them by default,
      like a proper perl module should.
    - Use the other functions at your own risk.
    - This is not quite complete, I still have to decide whether to
      export some other things.
  * Changed all plugins included in ikiwiki to not use "IkiWiki::" when
    referring to stuff now exported by the IkiWiki module.
  * Add a module version number to IkiWiki, so you can "use IkiWiki '1.00'"
    to declare which version of the interface your plugin needs.
  * Anyone with a third-party ikiwiki plugin is strongly encouraged
    to make like changes to it and avoid use of non-exported symbols from
    "IkiWiki::".
  * Link debian/changelog and debian/news to NEWS and CHANGELOG.
  * Support hyperestradier version 1.4.2, which adds a new required phraseform
    setting.
  * If an inlined page has a permalink, link the page title to that.
  * Patch from Recai to use utf8 when reading the setup file, so that
    utf8 wikinames from there will be used properly.
  * Patch from Recai to kill utf-8 on the wiki name when generating the
    session cookie.
  * Change ddate plugin to use the DateTime::Calendar::Discordian perl module.
  * Fix a baseurl problem in hyperestradier search results.
  * Add a stub local.css to avoid problems with 404's.
  * Patch from Recai to fix a wide character warning from the search plugin
    during setup if the wikiname contains utf8.
  * Yet another fix for those poor case-insensative OS X users.
  * pagetemplate hooks are now also called when generating cgi pages.
  * Add a favicon plugin, which simply adds a link tag for an icon to each
    page (and cgis).
  * Patch from James Westby to deal with the case where you're editing a
    new page, hit cancel, and need to be redirected to somewhere sane.
  * Various documentation improvements by various wiki users.
  * Support Text::Markdown from CPAN, which has a different interface from
    the original markdown or the one in Debian.
  * Version the libcgi-session-perl dependency, some features that need
    the new version are used in some cases (sslcookie).
  * Numerous tla fixes from Clint.
  * Updated ikiwiki.svgz from Recai, includes an icon and is used to generate
    a multi-resolution favicon.ico.
  * README.Debian: typo Closes: #388110
  * chomp trailing newline at the end of templates read in by the template
    plugin, to allow use of the template preprocessor directive in
    whitespace-sensative situations. Closes: #387073
  * Patch from James Westby to make the location of the estseek.cgi script
    configurable.
  * Add typography (SmartyPants) plugin by Recai.
  * Add --render mode, which can be used to preview an edit at the command
    line by test rendering a single page.
  * Add a googlecalendar plugin. A bit special-purpose, but it shows
    one way to to deal with user-supplied content that could cause XSS
    issues w/o the htmlscrubber, and won't survive the scrubber.

 -- Joey Hess <joeyh@debian.org>  Sun, 24 Sep 2006 00:02:21 -0400

ikiwiki (1.26) unstable; urgency=low

  * Add a missing -n to tla undo call.
  * otl2hmtl can't be safely used with IPC::Open2 since it sometimes
    writes before consuming its whole stdin. Avoid this deadlock.
  * Fix alt tags for outline checkboxes.

 -- Joey Hess <joeyh@debian.org>  Fri,  8 Sep 2006 16:24:16 -0400

ikiwiki (1.25) unstable; urgency=low

  * Add proper waitpid calls for open2ed processes throughout to avoid
    zombies; this hit htmltidy especially badly.
  * Drop real uid/gid in the suid wrapper, thus allowing commits to remote
    subversion repos and fixing some other issues.
  * Add support for tla, contributed by Clint Adams. Closes: #385936
  * Add support for mercurial, contributed by Emanuele Aina.
  * Include <link rel> tag for RSS feeds, used by some aggregators and
    firefox to find the feed.
  * Add a linkmap plugin (requires graphviz).

 -- Joey Hess <joeyh@debian.org>  Fri,  8 Sep 2006 01:54:14 -0400

ikiwiki (1.24) unstable; urgency=low

  * Simplify the data structure returned by rcs_recentchanges to avoid
    each rcs plugin needing to form complex strings on its own.
  * Fix another destpage issue in the inline directive. Closes: #385512
    again.

 -- Joey Hess <joeyh@debian.org>  Sun,  3 Sep 2006 15:46:45 -0400

ikiwiki (1.23) unstable; urgency=low

  * Allow inline directives to be nested inside eg, sidebars. Closes: #385512

 -- Joey Hess <joeyh@debian.org>  Sun,  3 Sep 2006 12:14:45 -0400

ikiwiki (1.22) unstable; urgency=low

  * Change how the stylesheet url is determined in the templates: Remove
    STYLEURL and add BASEURL to all templates (some already had it). This
    new more general variable can be used to link to other things (eg, images)
    from the template, as well as stylesheets.
  * Fix a bug introduced last version to do with nested inlines.
  * Allow preprocessor directives to span multiple lines, both to make
    long ones with lots of values easier to write, and to allow for ones with
    multi-line quoted values.
  * Allow preprocessor directives to contain python-like triple-quoted
    text blocks, for easy nesting of quotes inside.
  * Add a template plugin.
  * Make pagespec merge code smarter about merging duplicate pagespecs.
  * Patch from Jordà Polo to make Setup::Standard support hashes in config
    files.
  * Change order of linkify and preprocess; first preprocess and then linkify.
    This allows passing a wikilink inside a parameter to a preprocessor
    directive without it being expanded to html, and leaking out of the
    parameter, which had required some non-obvious use of triple-quoting
    to avoid. Note that any preprocessor plugins that output something
    that looks like a wikilink will now have it treated as such; AFAIK
    this doesn't change any behavior though except for the template plugin.
  * Enable preprocessor directives when previewing an edit.
  * Make all pages pull in a local.css style sheet, if present. This won't
    be included in ikiwiki, but can be created to make local styling changes
    w/o needing to merge in every new change to the distributed style.css.
  * Use DESTDIR and not PREFIX to specify installation prefix for packaging.
  * Support running "perl Makefile.PL PREFIX=foo" to build ikiwiki to run
    from a different directory.
  * Generalised preprocesser loop protection code.
  * Patch from James Westby to allow a description to be set for rss feeds.
  * Patch from James Westby to add a template for the search form.
  * Added a ddate plugin.
  * Patch from James Westby to add a --sslcookie switch, which forces
    cookies to only be sent over ssl connections to avoid interception.
  * Fix preferences page on anonok wikis; still need to sign in to get
    to the preferences page.
  * Add toc (table of contents) plugin.
  * Change htmlize, format, and sanitize hooks to use named parameters.
  * Patch from James Westby to add an actions option to inline; this
    adds Edit and Discussion links at the end of blog entries.
  * Due to some css changes, you'll want to rebuild your wiki on upgrade
    to this version. Will be handled automatically by the deb.
  * Add processed date to aggregate preprocessor directive status output.

 -- Joey Hess <joeyh@debian.org>  Fri,  1 Sep 2006 22:03:34 -0400

ikiwiki (1.21) unstable; urgency=low

  * Add a tail fin^W^Wsidebar plugin by Tuomo Valkonen.
  * If a page links to itself, mark up the link text in a span with
    class="selflink" so that it can be styled. I don't have a useful style
    defined for that though.
  * Call filter hooks on inlined page content.
  * Support inlining pages raw, rather than creating a blog.
  * Clean up yes/no parameter parsing in inline plugin.
  * Implemented better cycle detection in the inline plugin; nested inlines
    will now work.
  * Add a map plugin contributed by Alessandro Dotti Contra.
  * Add otl format plugin, which handles files as created by vimoutliner.
  * Fix ikiwiki-mass-rebuild to work in the way the postinst uses it.
  * Add first draft at a Restructured Text (rst) plugin, by Sergio
    Talens-Oliag. Note that this has many known issues -- see the caveats on
    the plugin's page.
  * Credit everyone who wrote a plugin on the plugins' wiki pages.
  * Fix utf-8 in blog post form.

 -- Joey Hess <joeyh@debian.org>  Sun, 20 Aug 2006 16:42:54 -0400

ikiwiki (1.20) unstable; urgency=low

  * Relicense the templates and basewiki under the 2-clause BSD license.
    Since these can easily become part of other people's websites, they
    should be under as permissive a license as possible.
  * Add --syslog config option, to log to the syslog.
  * Catch failing IPC::Open2 in tidy plugin and retry in case this is a
    transient failure to fork (which I've seen happen in the wild).
  * Fix a bug in the aggregator introduced last version that caused all
    aggregator state to be lost during a non-aggregating build.

 -- Joey Hess <joeyh@debian.org>  Thu, 17 Aug 2006 19:05:56 -0400

ikiwiki (1.19) unstable; urgency=low

  * Fix several related bugs in page type determination during online editing.
  * Add some locking to prevent 2 aggregators from running at once.
  * Fix an infinite loop in the aggregator when finding a unique filename.

 -- Joey Hess <joeyh@debian.org>  Wed, 16 Aug 2006 13:46:25 -0400

ikiwiki (1.18) unstable; urgency=low

  * The last release accidentially installed ikiwiki as ikiwiki.pl, now fixed.
  * Add --version.
  * Man page format fixups.
  * If the meta plugin overides the page title, set a title_overridden
    variable in the template to true. This allows doing things with the
    templates conditional on the title being overriden.
  * Add a %pagecase which maps lower-case page names to the actual case
    used in the filename. Use this in bestlinks calculation instead of
    forcing the link to lowercase.
  * Also use %pagecase in various other places that want to check if a page
    with a given name exists.
  * This means that links to pages with mixed case names will now work,
    even if the link is in some other case mixture, and mixed case pages
    should be fully supported throughout ikiwiki.
  * Recommend rebuilding wikis on upgrade to this version.

 -- Joey Hess <joeyh@debian.org>  Sat, 12 Aug 2006 22:10:48 -0400

ikiwiki (1.17) unstable; urgency=low

  * Disable tidy generator tag.
  * Move tidy back to sanitize hook, found out how to only show body.
  * Turn off tidy indentation too.
  * Turn on HTML::Template loop_context_vars; not actually used in stock
    templates but can be useful for things like making comma-delimited lists
    of tags or what have you.
  * Remove <br> from end of aggregate preprocessor directive output.
  * Ship ikiwiki executable as ikiwiki.pl in source to avoid issues on
    case-sensative filesystems like OSX.
  * Improve markdown loading. First, try to load it as a proper perl module,
    in case it was installed as one. Then fall back to trying
    /usr/bin/markdown.
  * Document in install page how to install markdown, since it has no
    installation procedure in the upstream tarball.
  * Set die_on_bad_params => 0 for all templates, to allow users to modify
    them without annoyances.
  * Suck in the page content when generating an inline archive page, to work
    around the meta plugin's lack of caching of title metadata across runs.

 -- Joey Hess <joeyh@debian.org>  Sat, 12 Aug 2006 12:52:13 -0400

ikiwiki (1.16) unstable; urgency=low

  * Try to handle relative links in aggregated feeds. However,
    the current support is a crude hack due to limitations of XML::Feed:
    xml:base is not supported, neither is Content-Location. And of course,
    relative links in RSS feeds are ill-undefined..
  * Make aggregator save permalinks and author name to pages as metadata.
  * Add permalink and author support to meta plugin, affecting RSS feeds
    and blog pages.
  * Various CSS and formatting changes.
  * Encode link and guid urls in rss feeds to avoid illegal utf8 slipping in.
  * Add xhtml files to the default prune regexp.
  * Also generate rel=bookmark links for permalinks.
  * Fix the htmltidy plugin, which wasn't working due my breaking it when
    I added it..
  * Don't run tidy with -xml as that fails if the input is not well-formed.
    Run it with -asxhtml instead, so it will output well-formed xhtml no
    matter what the input.
  * Disable tidy warnings too.
  * Add a new format hook, and make tidy use it, since tidy can really only
    operate on and output complete html documents, not the body chunks
    that sanitise gets.
  * Fix dates in rss feeds if running localised, so they're still rfc 822.

 -- Joey Hess <joeyh@debian.org>  Fri,  4 Aug 2006 20:48:36 -0400

ikiwiki (1.15) unstable; urgency=low

  * Remove CDPATH and other env vars perl taint checking doesn't like.
    Closes: #381279
  * Added created_before and created_after PageSpec limits.

 -- Joey Hess <joeyh@debian.org>  Thu,  3 Aug 2006 13:00:57 -0400

ikiwiki (1.14) unstable; urgency=low

  * Memoize pagespec translation, this speeds up a build of the ikiwiki tree
    by 10% or so.
  * Fix stupid bug in date matching, patch from Roland Mas. Closes: #381132
  * Added many unit tests for pagespec_match.

 -- Joey Hess <joeyh@debian.org>  Wed,  2 Aug 2006 11:34:06 -0400

ikiwiki (1.13) unstable; urgency=low

  * ikiwiki can now download and aggregate feeds with its new aggregate
    plugin, so it's possible to implement a Planet using ikiwiki!
  * Add a run_hooks function for the common task of running all hooks of a
    given type.
  * Add a savestate hook.
  * Don't put blog post forms on pages if there's no cgiurl set.
  * --setup --refresh no longer rebuilds wrappers. Use --setup --refresh
    --wrappers to do that.
  * Add %IkiWiki::forcerebuild to provide a way for plugins like aggregate
    to update pages that haven't changed on disk.
  * Change meta tags to use html entity-escaped text for values, so that
    quotes and such can be represented in title tags.
  * Depend and build-depend on HTML::Parser for HTML::Entities which is used
    for the above.
  * Make --rebuild also cause --aggregate to re-download and write aggregated
    pages.
  * Avoid outputting duplicate meta info.
  * Include title metadata on aggregated posts for capitalised and un-munged
    titles.
  * Title metadata of inlined pages now shows up in blogs and rss feeds.
  * Fix issue with unicode filenames and updating the hyper estradier search
    index. (Aka Please Please Please, let that be the last one.)
  * Patch from Roland Mas to support an rss=no parameter to inline directives.
    Closes: #380743
  * Renamed GlobLists to PageSpecs.
  * PageSpecs can now include nested parens, "and", and "or". This remains
    backwards compatible to the old GlobList format. It's implemented by
    treating the GlobList as a very limited microlanguage that is transformed
    to perl code that does the matching.
  * The old GlobList format is deprecated, and I encourage users to switch to
    using the new PageSpec format. Compatibility with the old format will be
    removed at some point, possibly by 2.0.
  * Wiki rebuild needed on upgrade to this version due to PageSpec change.
  * Add support for creation_month and creation_year to PageSpec.
    Closes: #380680
  * Changes to index file encoding.

 -- Joey Hess <joeyh@debian.org>  Tue,  1 Aug 2006 21:21:19 -0400

ikiwiki (1.12) unstable; urgency=low

  "Viva l'Italia!"
  * New pagestats plugin from Enrico, which can generate a table counting
    the backlinks for each page, or a del.icio.us style cloud.
  * Build-depend on libtext-wikiformat-perl, so that the syntax check of
    the wikiformat plugin works. Thanks, Emanuele Aina.
  * Patch from Alessandro Dotti Contra to clean up backlinks and navbar
    display, running them through pagetitle. This removes ugly underscores and
    other gunk from the display, much nicer. You may want to rebuild your wiki
    when upgrading to get the cleanup globally.
  * Polygen plugin from Enrico.
  * htmltidy plugin from Faidon.
  * Locale patch from Faidon:
    - Adds a locale setting to setup files.
    - Proper local time, if the locale configuration option is used.
    - Support for UTF-8 (or ISO-8859-X) filenames in SVN. Before this patch,
      commiting (or even rcs_updating) on repositories with UTF-8 filenames was
      impossible.
  * Add getopt hook type, this allows plugins to add new command-line options.
  * Add --tagbase option to tag plugin.
  * Add exclude option in setup files, works same as --exclude.
  * Put categories in rss feeds for tagged items.
  * Allow preprocessor directives to be expanded in inlined blog pages.
    However, to avoid inlining loops etc, don't expand inline directives in
    inlined pages.
  * fortune plugin (trivial)
  * Tag plugins according to type.

 -- Joey Hess <joeyh@debian.org>  Sat, 29 Jul 2006 17:12:56 -0400

ikiwiki (1.11) unstable; urgency=low

  * Patch from Enrico that
    - Adds a tag plugin that allows more easily tagging pages.
      The meta plugin can also still be used for that, but the tag plugin
      also lists a page's tags at the bottom of the page.
    - Allows preprocessor directives to have parameters with no specified
      value.
    - Fixes preprocessor directive parameter parsing so that
      foo=bar baz now means "foo=bar" and a "baz" with no value.
  * Run pagetemplate hooks when inlining pages so that inlined pages also
    list their tags.
  * Make all plugins with pagetemplate hooks check that variables exist
    on the template before setting them, for robustness.
  * Switch pagetemplate hooks to using named parameters.
  * Pass a destpage parameter to preprocessor and pagetemplate hooks.
    This will be the page that a source page will be part of, which is
    different than the source page for inlined pages.
  * Audited all plugins to endure they pass (page, destpage) to htmllink
    appropriately. This means inlining of various plugins will not work
    properly, with correct links generated.

 -- Joey Hess <joeyh@debian.org>  Thu, 27 Jul 2006 20:51:23 -0400

ikiwiki (1.10) unstable; urgency=low

  * Run page through any relevant filters when generating a page preview.
  * Noticed a bug in the wikitext markup plugin -- it made CamelCase links the
    default throughout the wiki, not only on wikitext pages. Decided to call
    this a feature, and split the camelcase support out into a separate plugin
    that is independant of wikitext.
  * Fix CamelCase regexp to not break [[FooBar|BazBar]] WikiLinks.

 -- Joey Hess <joeyh@debian.org>  Wed, 26 Jul 2006 18:06:35 -0400

ikiwiki (1.9) unstable; urgency=low

  * Improve display of parentlinks and page title of toplevel index page.
  * Patch from Faidon to use svn --limit when possible for recentchanges,
    speeds up recentchanges a lot for wikis with more history.
  * Patch from Recai to fix utf8 issues in git backend.
  * Add wikitext markup plugin, which supports ".wiki" pages written in the
    original wiki syntax, CamelCase links and all.
  * Support a w3mmode, which lets w3m run ikiwiki using its local CGI
    support, to edit pages etc without a web server.
  * Display CGI processing errors if present.
  * Fix from Faidon for a XML parser issue that breaks utf-8 for
    RecentChanges. Avoid using XML::SAX::PurePerl, which is buggy in this
    area, and also way slow.
  * Match 'web commit from' in SVN and git, these are web commits too.
    (Faidon)
  * Consolidated all decode_utf8 in FormBuilder's fields to make the code more
    readable and avoid future mistakes. The patch seems to work and for the
    first time I have a UTF-8 username ;-) (Faidon)
  * Use form->field consistently, not form->param.
  * Patch from Recai to allow selection of page type when creating a new page.
    Default page type is inherited from the link clicked on to create the new
    page.

 -- Joey Hess <joeyh@debian.org>  Wed, 26 Jul 2006 17:25:30 -0400

ikiwiki (1.8) unstable; urgency=low

  * Fix orphans plugin to not count a link to a nonexistant page as a reason
    for a page not being an orphan.
  * Support pinging services such as Technorati using XML-RPC to notify them
    about changes to rss feeds.
  * Parse svn log as xml for improved utf8 and security. Note that this makes
    ikiwiki depend on XML::Simple. Patch by Faidon Liambotis.
  * POSIX::strftime doesn't know about encodings and doesn't return a utf8
    flagged string even if the locale causes it to generate utf8 output,
    so make sure to let perl know it should be handled as utf8. Also,
    the optimised version used for standard time formats won't work if the
    user has changed locale, so drop it. Thanks, Faidon Liambotis.
  * Fix re-encoding of the comments field to utf8 if a commit fails
    due to a conflict. Thanks, Faidon Liambotis.
  * Let svn know that commits have utf8 commit messages. Thanks, Faidon
    Liambotis.
  * Add insane double encode/decode to utf8 around call to markdown.
    This works around a truely strange bug, which is apparently a bug in
    perl, #376329. Also added a test case for it.
  * Improve layout of edit page so formatting help link is always visible w/o
    getting in the way of the preview.
  * Centralised all calls to HTML::Template and force all the templates
    to be read as utf8.
  * Support pages with utf8 filenames. Patch by Faidon Liambotis.
  * Introduce add_plugins and disable_plugins config options in setup files.
    This allows adding or removing plugins w/o overriding the whole list of
    default plugins, which makes it easier to upgrade when new default plugins
    are added.
  * Support htmlize plugins and make mdwn one such plugin, which is enabled by
    default (of course!). Based on a patch by Faidon Liambotis.
  * Add a html plugin, which can be used to write wikis in raw html,
    if you'd ever want to do such a thing. Slightly tricky, since ikiwiki
    defaults to not processing .html files, since w/o this plugin they would
    be copied unsanitised. With this plugin, it will process and html
    sanitise them, like any other page type.
  * Rebuilding wrappers is necessary on upgrade to this version.
  * Make ikiwiki --setup --refresh rebuild wrappers, so wrapper rebuild
    will be automatically done on all upgrades.
  * Don't send pings if the wiki is being rebuilt.
  * Work around very innefficient behavior in File::Spec::abs2rel. Result
    is a savings of 2 pointless fork/execs per link calculation, which
    results in ~25% speedup of ikiwiki building its own doc wiki, and
    about 35% speedup displaying RecentChanges!
  * Make RecentChanges use a table and some CSS, should be much more readable.
    No code changes involved.
  * Encode & in diffurl in examples, to conform to pedantic rules.
  * Speed up RecentChanges by another 40% or so with some memoization.
  * Memoize abs2rel, which is still kinda slow, for another 30% speedup
    in time to build the doc wiki.

 -- Joey Hess <joeyh@debian.org>  Tue,  4 Jul 2006 12:46:29 -0400

ikiwiki (1.7) unstable; urgency=low

  * Updated logo from Recai with some kerning and alingment tuning.
  * Patch from Recai to fix git recentchanges code to work with git 1.4 which
    changed some output.
  * Copyright update.

 -- Joey Hess <joeyh@debian.org>  Sun, 18 Jun 2006 23:33:35 -0400

ikiwiki (1.6) unstable; urgency=low

  * YA utf-8 patch from Recai, this time to fix previewing a page so that
    the text in the input box is re-encoded back to utf-8.
  * -CSD does not affect modules, so readfile() was not using the utf-8 input
    layer, which led to lots of problems; make it force read files as utf-8.
    Closes: #373203
  * Note that as a consequence, this version of ikiwiki will actually try to
    parse utf8 in source files for the first time, which may expose broken
    utf8 in wiki sources that was hidden before. Most common will be
    perl warnings like "utf8 "\xE9" does not map to Unicode"
  * writefile() likewise needs to use the utf8 output layer.
  * Remove the -CSD from ikiwiki's hashbang since it's useless to have it
    there.
  * Revert some of the decode_utf8 changes in CGI.pm that seem unnecessary
    given the readfile fix.
  * Add utf-8 testcases for readfile and htmlize.
  * Put back the encode_utf8 in the input to markdown; it's really not utf-8
    safe.
  * More utf-8 fixes from Recai, partly to things I broke above:
    - The serious problem is that writefile() saves the content in undecoded
      format in CGI, hence all (non-ascii) chars are corrupted permanently.
    - Comment field in edit page is not decoded and all the non-ascii chars in
      this field are corrupted as the result.  We should decode it as we do it
      for the content.
    - Add 'use encoding "utf8"' to CGI.pm to avoid warnings about wide
      character in print.
  * New SVG logo from Recai.

 -- Joey Hess <joeyh@debian.org>  Sun, 18 Jun 2006 19:18:46 -0400

ikiwiki (1.5) unstable; urgency=low

  * Add --timeformat config option to allow changing how dates are displayed.
    Note that as a side effect, dates will now be displayed using the local
    timezone, not as GMT.
  * More security review.
  * Patch from Dr. Zini to add link() and backlink() to globlists. This allows
    for some handy stuff like:
    - Using links as a kind of tag; creating blog pages that list all pages
      containing a given tag/link or not containing some other tag.
    - Subscribing to mail notifications whenever a change is made to a page
      that is a backlink of page foo. Ie, "Please notify me of changes in all
      pages that link to my home page in the wiki"
    - Locking any pages that are linked to from a particular page, so that
      lists of locks can be exposed in the wiki.
  * Reorganised the doc wiki's todo/* pages, using a link/tag to flag
    when a todo item is done, instead of the previous moving it to a different
    subdir.
  * Allow pagetemplate plugins to override *anything* in the template.
  * Add a meta plugin, which allows specifying various metadata about pages,
    like license and author. It also allows for inserting html link and meta
    tags into html, overriding the title, and adding hidden WikiLinks, which
    can be useful when using link-based globbing for page categorisation.
  * Remove preprocessor directives from inlined pages.
  * Allow simple preprocessor directive values to be specified w/o quotes.
  * Add support for using git instead of subversion as the RCS backend,
    tremendous thanks to Recai Oktaş for this.
  * Doc updates for git.
  * Fix absolute url munging in rss generation to support https, ftp, etc urls
    not just http urls.
  * Patch from Recai Oktaş to improve utf-8 support, it should now use proper
    utf-8 for edit and other fields, and for recentchanges. There may still
    be utf-8 issues with the preferences page though.

 -- Joey Hess <joeyh@debian.org>  Sun, 11 Jun 2006 19:56:54 -0400

ikiwiki (1.4) unstable; urgency=low

  * Tell HTML::Scrubber to treat "/" as a valid attribute which is its
    very strange way of enabling proper XHTML <br /> type tags. Output html
    should be always valid again now.
  * The page name and parent links has switched from using a <h1> to a styled
    <span>, so pages can use <h1> internally instead of needing to use <h2>.
  * Updated all of ikiwiki's own wiki pages for that.
  * Add pagetemplate hook, which can be used by plugins that want to mess
    around with adding new stuff to the page template.
  * Remove headercontent; the search plugin now adds the search box to the
    header by registering a pagetemplate hook, and other plugins should do
    similarly.
  * Rebuilding on upgrade to this version is recommended.
  * Add a html validity check to the test suite, using the wdg-html-validator,
    if available.
  * Make the html valid when there is nothing in the actions list.
  * Reordered some function call parameters for consistency.
  * Enable full utf-8 support for page input and output.
  * Add a workaround for markdown, which does not work well with utf-8
    strings.
  * --getctime had bitrotted (well I only ever used it the once so far..),
    fix and make it a bit more flexible
  * rcs_getctime is changed, now rather than needing to loop over all pages,
    it should just use the rcs to get the ctime of the passed file.
  * When inlining a page in another one, links from the inlined page are now
    expanded the same as they are when rendering the inlined page as a
    standalone page. So rather than being expanded from the POV of the
    inlining page, they are expanded from the POV of the inlined page.

    For example, a link from blog/foo to "bar" will now link to blog/bar
    if it exists. Previously this needed to be a link explicitly to
    "blog/bar"; such links will also continue to work.

    (This was slightly complex to do as the link still has to be constructed
    relative to the inlining page.)
  * Make page edit textarea resize to fit browser window.
  * Add -refresh option to ikiwiki-mass-rebuild and use that on upgrades that
    do not need a full rebuild, in order to update any basewiki pages.

 -- Joey Hess <joeyh@debian.org>  Sat, 27 May 2006 15:08:49 -0400

ikiwiki (1.3) unstable; urgency=low

  * Fix the preinst introduced in the last version. Closes: #367458

 -- Joey Hess <joeyh@debian.org>  Tue, 16 May 2006 02:43:02 -0500

ikiwiki (1.2) unstable; urgency=low

  * Remove dups from the brokenlinks list.
  * Add libc6-dev to dependencies, needed to build wrappers.
  * Install wikilist in correct location. Closes: #367371

 -- Joey Hess <joeyh@debian.org>  Mon, 15 May 2006 10:53:49 -0500

ikiwiki (1.1) unstable; urgency=low

  * Rename inlinepage to depends, so that it can be used to refer to more
    dependency relationships than just inlining. This will require a rebuild
    on upgrade to this version.
  * Move the rss link, put it in the blogpost form if there is one and at the
    top if not. This is both nicer because easier to find, and it cleans up
    the code which had used inlinepage as a flag for adding the link later.
  * Allow the depends GlobList to be built up from multiple sources (such as
    plugins) during a page render.
  * Which means that more than one blog is now supported to appear on a
    single page. (With some limitations, like only the last one getting an
    rss file.)
  * Added a plugin system.
  * Added a pagecount plugin, enabled by default.
  * Support PreProcessorDirectives with no parameters, ie "[[pagecount ]]".
  * Fixed/optimised backlinks code, to avoid rebuilding pages to update
    backlinks when the backlinks hadn't really changed.
  * Moved inline page support, rss generation etc into the inline plugin,
    enabled by default.
  * Added brokenlinks plugin, not enabled by default, but rather handy.
  * Fix several broken links in the doc wiki.
  * Smarter behavior when creating a page and a page of the same name (but
    different location) already exists.
  * Add an orphans plugin for finding pages that nothing links to.
  * Removed backlinks page, which it turns out nothing used.
  * Split off an IkiWiki.pm out of ikiwiki and have all the other modules use
    it, this will allow for adding a unit test suite.
  * Add unit tests for several core functions, including globlist_match,
    dirname, basename, bestlink, linkify, pagetitle, titlepage.
  * Smart globlist merging.
  * Patch from Thomas Schwinge to switch from --svn to --rcs=svn, etc,
    to pave the way for adding other RCS support. This also changes the
    setup files, where before they had svn => 1 or svn => 0, now they have
    rcs => "svn" or rcs => "".
  * Add a debian/NEWS file with upgrade notes.
  * Load whatever rcs module is specified, so new ones can be just dropped in
    as plugins and work. (Well, in theory.)
  * Add some basic docs about writing RCS modules.
  * Broke search capability out into a plugin, removed the --hyperestraier
    switch.
  * Added smiley plugin, nicely controlled and documented by the smileys page.
  * Copied in some smileys from Moin Moin.
  * Allow links of the form [[some page|page]], with whitespace in the link
    text.
  * Removed --sanitize and --no-sanitize, replaced with --plugin htmlscrubber
    and --disable-plugin htmlscrubber.
  * Allow discussion links on pages to be turned off with --no-discussion.
  * Add ikiwiki-mass-rebuild script, ripped out of the postinst.
  * Add some new config items to the estseek.conf template, which are needed
    by hyperestraier 1.2.3.

 -- Joey Hess <joeyh@debian.org>  Fri,  5 May 2006 17:00:41 -0400

ikiwiki (1.0) unstable; urgency=low

  * First official release.

 -- Joey Hess <joeyh@debian.org>  Tue, 25 Apr 2006 02:08:17 -0400
